/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.commerce.api;

import java.util.List;

/**
 * Class that describes a search result.
 */
public interface CommerceResult {

    /**
     * Get pagination information, like page number, total results, ...
     */
    public PaginationInfo getPaginationInfo() {
		return null;
	}

    /**
     * Get the available sort fields for this query.
     */
    public List<CommerceSort> getSorts() {
		return null;
	}

    /**
     * Get the current range of products returned by this query.
     */
    public List<Product> getProducts() {
		return null;
	}

    /**
     * Get the original query that generated the current result.
     */
    public CommerceQuery getOriginalQuery() {
		return null;
	}

    /**
     * Get the query as interpreted by the current commerce service. Implementations can return {@code null} here if
     * they don't have that information.
     */
    public CommerceQuery getActualQuery() {
		return null;
	}
    
    /**
     * Get a list of facets this query supports.
     */
    public List<CommerceFacet> getFacets() {
		return null;
	}

}
