/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.commerce.common;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import com.day.cq.commons.inherit.HierarchyNodeInheritanceValueMap;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.adapter.SlingAdaptable;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.ValueMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.commerce.api.CommerceConstants;
import com.adobe.cq.commerce.api.CommerceException;
import com.adobe.cq.commerce.api.CommerceService;
import com.adobe.cq.commerce.api.Product;
import com.adobe.cq.commerce.api.VariantFilter;
import com.day.cq.commons.ImageResource;
import com.day.cq.commons.inherit.InheritanceValueMap;
import com.day.cq.commons.inherit.ComponentInheritanceValueMap;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.PageManager;

/**
 * This class is meant to be used as a base class for a {@link Product} implementation built on top of
 * a JCR repository. GeoProductImpl is an example.
 */
public abstract class AbstractJcrProduct extends SlingAdaptable implements Product {

    // This first set is just here for backwards compatibility.  "Truth" is now held in CommerceConstants.
    protected static final String PN_PRODUCT_TYPE = CommerceConstants.PN_COMMERCE_TYPE;
    protected static final String PN_PRODUCT_VARIANT_AXES = CommerceConstants.PN_PRODUCT_VARIANT_AXES;
    protected static final String PN_PRODUCT_DATA = CommerceConstants.PN_PRODUCT_DATA;

    protected static final String PN_PRODUCT_TITLE = "jcr:title";
    protected static final String PN_PRODUCT_DESCRIPTION = "jcr:description";
    protected static final String PN_PRODUCT_IMAGE_CATEGORY = "assetCategory";

    protected static final Logger log = LoggerFactory.getLogger(AbstractJcrProduct.class);

    protected Resource resource;
    protected Product baseProduct;

    /**
     * Constructor
     * @param resource the Resource storing the product (or variant) info
     */
    public AbstractJcrProduct(Resource resource) {
        this.resource = resource;
    }

    public String getPath() {
		return null;
	}
    
    public String getPagePath() {
		return null;
	}

    public String getTitle() {
		return null;
	}

    public String getDescription() {
		return null;
	}

    @Deprecated
    public String getImagePath() {
		return null;
	}

    @Deprecated
    public String getImageUrl() {
		return null;
	}

    @Deprecated
    public String getThumbnailUrl() {
		return null;
	}

    @Deprecated
    public String getThumbnailUrl(int width) {
		return null;
	}

    public ImageResource getImage() {
		return null;
	}

    public List<ImageResource> getImages() {
		return null;
	}

    public ImageResource getThumbnail() {
		return null;
	}

    protected List<ImageResource> getImages(final Resource resource) {
		return null;
	}

    public <T> T getProperty(String name, Class<T> type) {
		return null;
	}

    public Iterator<Product> getVariants() throws CommerceException {
		return null;
	}

    public boolean axisIsVariant(String axis) {
		return false;
	}

    public Iterator<Product> getVariants(VariantFilter filter) throws CommerceException {
		return null;
	}

    //
    // Returns the list of variant axes (properties)
    //
    public Iterator<String> getVariantAxes() {
		return null;
	}

    //
    // Fetches the base product from any product in a product/variant hierarchy.
    //
    public Product getBaseProduct() throws CommerceException {
		return null;
	}

    //
    // Fetches the PIM product (from /etc/commerce/products) for this Product.
    //
    public Product getPIMProduct() throws CommerceException {
		return null;
	}

    /**
     * Returns true if resource's cq:commerceType is "variant".
     * @param resource
     * @return
     */
    public static boolean isAVariant(Resource resource) {
		return false;
	}

    /**
     * Returns true if resource's cq:commerceType is "product".
     * @param resource
     * @return
     */
    public static boolean isABaseProduct(Resource resource) {
		return false;
	}

    /**
     * Returns true if resource's cq:commerceType is  "product" or "variant".
     * @param resource
     * @return
     */
    public static boolean isAProductOrVariant(Resource resource) {
		return false;
	}

    //
    // Recursive descent of the resource tree, checking any leaf nodes against the
    // filter for inclusion.
    //
    protected void collectVariants(Product p, VariantFilter filter, List<Product> variants) {
	}

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings("unchecked")
    public <AdapterType> AdapterType adaptTo(Class<AdapterType> type) {
		return null;
	}

}


