package com.adobe.cq.commerce.common;

import com.adobe.cq.commerce.api.CommerceException;
import com.adobe.cq.commerce.api.CommerceSession;
import com.adobe.cq.commerce.api.PriceInfo;
import com.adobe.cq.commerce.api.Product;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.Predicate;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * The default implementation for a {@link CommerceSession.CartEntry} used by
 * {@link AbstractJcrCommerceSession}.
 *
 * Implementations requiring customization should extend this class and override
 * {@link AbstractJcrCommerceSession#newCartEntryImpl(int, com.adobe.cq.commerce.api.Product, int)}
 * to return said extension.
 */
public class DefaultJcrCartEntry implements CommerceSession.CartEntry {
    private int index;
    private Product product;
    private int quantity;
    private List<PriceInfo> prices;

    public DefaultJcrCartEntry(int index, Product product, int quantity) {
        this.index = index;
        this.product = product;
        this.quantity = quantity;
    }

    @Override
    public int getEntryIndex() {
		return 0;
	}

    public void setEntryIndex(int index) {
	}

    @Override
    public Product getProduct() throws CommerceException {
		return null;
	}

    @Override
    public int getQuantity() {
		return 0;
	}

    public void setQuantity(int quantity) {
	}

    @Override
    public List<PriceInfo> getPriceInfo(Predicate filter) throws CommerceException {
		return null;
	}

    @Override
    public String getPrice(Predicate filter) throws CommerceException {
		return null;
	}

    /**
     * A helper routine which updates the cart entry prices with a new {@link PriceInfo}.  If all
     * the priceInfo's types match an existing entry, the entry will be updated.
     *
     * <p>Note: automatically add the priceInfo's currencyCode as an additional tag to ease
     * filtering on currency.</p>
     *
     * @param priceInfo A {@link PriceInfo} containing the amount and currency.
     * @param types Classifiers indicating the usage of the PriceInfo (ie: "UNIT", "PRE_TAX").
     */
    public void setPrice(PriceInfo priceInfo, String... types) {
	}

    @Override
    public <T> T getProperty(String name, Class<T> type) {
		return null;
	}


    /*
     * ==================================================================================================
     * Deprecated methods.  For backwards-compatibility only.
     * ==================================================================================================
     */

    @Deprecated // since 5.6
    public String getUnitPrice() {
		return null;
	}
    @Deprecated // since 5.6
    public String getPreTaxPrice() {
		return null;
	}
    @Deprecated // since 5.6
    public String getTax() {
		return null;
	}
    @Deprecated // since 5.6
    public String getTotalPrice() {
		return null;
	}

}
