package com.adobe.cq.commerce.common;

import com.adobe.cq.commerce.api.PriceInfo;
import org.apache.commons.collections.Predicate;

import java.util.Set;

/**
 * Default filter predicate to use with getPriceInfo methods.
 */
public class PriceFilter implements Predicate {

    /**
     * In order to use this filter the prices passed to it must have this property set and it has to be a
     * {@link Set} with {@link String} elements, where each element is a price type.
     */
    public static final String PN_TYPES = "com.adobe.cq.commerce.common.PriceFilter.types";

    protected String[] types;

    /**
     * Default constructor. This filter will match prices that contain <strong>all</strong> supplied types.
     * @param types the types this filter has to match. If empty, all prices will be included.
     */
    public PriceFilter(String... types) {
        this.types = types;
    }

    public boolean evaluate(Object object) {
		return false;
	}

}
