/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.mcm.salesforce;

import com.adobe.granite.crypto.CryptoException;
import com.adobe.granite.crypto.CryptoSupport;
import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.wcm.webservicesupport.Configuration;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

/**
 * The <code>SalesforceLeadSearch</code> component is used to search leads on salesforce and return back the data
 * as JSON
 * */
@Component
@Service(value = SalesforceLeadSearch.class)
public class SalesforceLeadSearch {

    private static final Logger log = LoggerFactory.getLogger(SalesforceLeadSearch.class);
    private static final String INSTANCE_URL = "instanceurl";
    public static final String CUSTOMER_KEY = "customerkey";
    public static final String CUSTOMER_SECRET = "customersecret";
    public static final String REFRESH_TOKEN = "refreshtoken";
    private static final String QUERY_PATH = "/services/data/v20.0/query/";
    public static final String APPLICATION_JSON = "application/json";
    public static final String ACCESS_TOKEN = "accesstoken";

    @Reference
    private CryptoSupport cryptoSupport;

    /**
     * Uses the <code>{@link SalesforceClient}</code> to search leads
     * @param cloudConfig Salesforce Cloud Service Configuration used for identifying Salesforce Account.
     * @param parameters Search Parameters used via searching
     * @param resolver The current ResourceResolver object used if the access token expires during the search
     *                 and we need to save the new access token in the configuration.
     * @return JSON object consisting of leads information
     * */
    public JSONObject search(Configuration cloudConfig, SalesforceSearchParameters parameters,
                             ResourceResolver resolver)throws SalesforceException{
								return null;
							}


    /***
     * Builds a SOSL query from the given <code>{@link SalesforceSearchParameters}</code> parameters
     * */
    protected String buildSOSL(SalesforceSearchParameters parameters) throws SalesforceException{
		return null;
	}

    private String getEncodedSearchVal(String operator, String searchVal){
		return null;
	}

}
