/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.searchcollections.lucene;

import static javax.jcr.query.qom.QueryObjectModelConstants.JCR_JOIN_TYPE_LEFT_OUTER;
import static javax.jcr.query.qom.QueryObjectModelConstants.JCR_JOIN_TYPE_RIGHT_OUTER;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.query.InvalidQueryException;
import javax.jcr.query.QueryResult;
import javax.jcr.query.Row;
import javax.jcr.query.RowIterator;
import javax.jcr.query.qom.Column;
import javax.jcr.query.qom.Constraint;
import javax.jcr.query.qom.Join;
import javax.jcr.query.qom.Ordering;
import javax.jcr.query.qom.PropertyValue;
import javax.jcr.query.qom.QueryObjectModelFactory;
import javax.jcr.query.qom.Selector;
import javax.jcr.query.qom.Source;

import org.apache.jackrabbit.commons.JcrUtils;
import org.apache.jackrabbit.commons.iterator.RowIteratorAdapter;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.store.Directory;

import com.adobe.cq.searchcollections.qom.AbstractQueryObjectModel;
import com.adobe.cq.searchcollections.qom.ConstraintSplitter;
import com.adobe.cq.searchcollections.qom.Constraints;
import com.adobe.cq.searchcollections.qom.JoinMerger;
import com.adobe.cq.searchcollections.qom.OperandEvaluator;
import com.adobe.cq.searchcollections.qom.RowComparator;
import com.adobe.cq.searchcollections.qom.SimpleQueryResult;

class QueryObjectModelImpl extends AbstractQueryObjectModel {

    private final Directory directory;

    private final Analyzer analyzer;

    private final Session session;

    private final QueryObjectModelFactory factory;

    public QueryObjectModelImpl(Directory directory, Analyzer analyzer,
            Session session, QueryObjectModelFactory factory, Source source,
            Constraint constraint, Ordering[] orderings, Column[] columns) {
        super(source, constraint, orderings, columns);
        this.directory = directory;
        this.analyzer = analyzer;
        this.session = session;
        this.factory = factory;
    }

    public QueryResult execute() throws InvalidQueryException,
            RepositoryException {
				return null;
			}

    protected QueryResult executeSelector(Selector selector,
            LuceneQueryFactory lqf, OperandEvaluator evaluator)
            throws RepositoryException {
				return null;
			}

    private QueryResult executeJoin(Join join, OperandEvaluator evaluator)
            throws RepositoryException {
				return null;
			}

    private Map<String, PropertyValue> getColumnMap(
            Map<String, NodeType> selectors) throws RepositoryException {
				return null;
			}

    private Map<String, PropertyValue> getColumnMap(String selector,
            NodeType type) throws RepositoryException {
				return null;
			}

    private Map<String, NodeType> getSelectorNames(Source source)
            throws RepositoryException {
				return null;
			}

    private NodeType getNodeType(Selector selector) throws RepositoryException {
		return null;
	}

    /**
     * Sorts the given query results according to the given QOM orderings. If
     * one or more orderings have been specified, this method will iterate
     * through the entire original result set, order the collected rows, and
     * return a new result set based on the sorted collection of rows.
     * 
     * @param result
     *            original query results
     * @param evaluator
     *            operand evaluator
     * @return sorted query results
     * @throws RepositoryException
     *             if the results can not be sorted
     */
    public QueryResult sort(QueryResult result, OperandEvaluator evaluator)
            throws RepositoryException {
				return null;
			}

}