/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/
package com.adobe.cq.sightly;

import org.apache.sling.api.SlingHttpServletRequest;

import com.day.cq.wcm.api.WCMMode;

/**
 * This is taken from the existing Sightly impl. If this is useful and not specific to Sightly,
 * this should be added to CQBindingsValueProvider instead of AEMBindingsValueProvider.
 *
 * */
public class SightlyWCMMode {
    private final boolean isDisabled;
    private final boolean isPreview;
    private final boolean isAnalytics;
    private final boolean isReadOnly;
    private final boolean isEdit;
    private final boolean isDesign;

    private final SlingHttpServletRequest request;

    public SightlyWCMMode(SlingHttpServletRequest request) {
        this.request = request;

        this.isEdit = (WCMMode.fromRequest(request) == WCMMode.EDIT);
        this.isDesign = (WCMMode.fromRequest(request) == WCMMode.DESIGN);
        this.isDisabled = (WCMMode.fromRequest(request) == WCMMode.DISABLED);
        this.isPreview = (WCMMode.fromRequest(request) == WCMMode.PREVIEW);
        this.isAnalytics = (WCMMode.fromRequest(request) == WCMMode.ANALYTICS);
        this.isReadOnly = (WCMMode.fromRequest(request) == WCMMode.READ_ONLY);
    }

    public boolean isDisabled () {
		return false;
	}

    public boolean isPreview() {
		return false;
	}

    public boolean isAnalytics() {
		return false;
	}

    public boolean isReadOnly() {
		return false;
	}

    public boolean isEdit() {
		return false;
	}

    public boolean isDesign() {
		return false;
	}

    @Override
    public String toString() {
		return null;
	}
}
