/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.blog;

/**
 * Used to filter blog entries by author.
 */
public class AuthorEntryFilter implements BlogEntryFilter {

    private final String authorName;

    /**
     * Creates a <code>AuthorEntryFilter</code> using the specified author name.
     * @param author The author name
     */
    public AuthorEntryFilter(final String author) {
        authorName = author;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean pass(final BlogEntry entry) {
		return false;
	}
}
