/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.blog;

import java.util.Map;

import javax.jcr.RepositoryException;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.sling.api.resource.ResourceResolver;
import org.osgi.service.component.ComponentContext;

import com.adobe.cq.social.blog.impl.BlogNodeIndexerExtension;
import com.adobe.cq.social.ugc.api.RelatedSearch;

/**
 * Utility methods for performing related search.
 */
@Component(metatype = false)
public class BlogMetadataSearchUtil {

    @Reference
    private RelatedSearch relatedSearch;

    private static RelatedSearch relatedSearchStatic;

    protected void activate(final ComponentContext context) {
	}

    protected void deactivate(final ComponentContext context) {
	}

    public static final int MIN_TERM_FREQ = 0;
    public static final int MIN_DOC_FREQ = 0;
    public static final int MAX_RESULTS = 10;

    /**
     * Return a list of related posts, given a query.
     * @param resolver The resource resolver.
     * @param query The string to search for.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The component path.
     * @param catergoryFields Node properties to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents.
     */
    public static Map<String, Integer> getRelatedBlogEntries(final ResourceResolver resolver, final String query,
        final String resourceTypeFilter, final String componentFilter, final String[] catergoryFields,
        final int maxResults, final int minTermFreq, final int minDocFreq) throws RepositoryException {
			return null;
		}
}
