/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.blog;

import javax.jcr.Session;

import org.apache.sling.api.resource.ResourceResolver;

import com.adobe.cq.social.commons.CollabUtil;
import com.day.cq.security.profile.Profile;

/**
 * <code>BlogUtil</code> provides various tool methods revolving around {@link Blog}s.
 */
public class BlogUtil {

    /**
     * Indicates whether the user within the given resource resolver has enough permissions to post to the given blog.
     * If no posts to this blog have yet been made, the permissions on the
     * {@link com.adobe.cq.social.commons.CommentSystem#PATH_UGC} path are checked instead.
     * @param resolver The {@link org.apache.sling.api.resource.ResourceResolver}
     * @param blog The {@link Blog}
     * @return <code>true</code> if the user may post.
     */
    public static boolean mayCreateEntry(final ResourceResolver resolver, final Blog blog) {
		return false;
	}

    /**
     * Indicates whether the user within the given session and profile has enough permissions to post to the given
     * blog.
     * @param session The {@link javax.jcr.Session}
     * @param authorizable The {@link com.day.cq.security.profile.Profile}
     * @param entry The {@link BlogEntry}
     * @return <code>true</code> if the user may post.
     */
    public static boolean mayEditEntry(final Session session, final Profile authorizable, final BlogEntry entry) {
		return false;
	}
}
