/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.blog.antispam.process;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.jcr.resource.JcrResourceResolverFactory;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.blog.Blog;
import com.adobe.cq.social.blog.BlogManager;
import com.adobe.cq.social.blog.antispam.AkismetService;
import com.day.cq.workflow.WorkflowException;
import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.exec.WorkItem;
import com.day.cq.workflow.exec.WorkflowData;
import com.day.cq.workflow.exec.WorkflowProcess;
import com.day.cq.workflow.metadata.MetaDataMap;

/**
 * This <code>JavaProcess</code> checks a comment for spam.
 */
@Component(metatype = false)
@Service(value = com.day.cq.workflow.exec.WorkflowProcess.class)
@Property(name = "process.label", value = "Check Spam")
public class CheckSpamProcess implements WorkflowProcess {

    private static final String COMMENT_RESOURCE_TYPE = "social/commons/components/comments/comment";
    private static final String TRACKBACK_RESOURCE_TYPE = "social/blog/components/trackbacks";

    private static final String SLING_RESOURCE_TYPE = "sling:resourceType";

    private static final String TYPE_JCR_PATH = "JCR_PATH";

    private final Logger logger = LoggerFactory.getLogger(this.getClass().getName());

    /** A reference to the Akismet Service. */
    @Reference
    private AkismetService akismetService;

    /** A reference to the JcrResourceResolverFactory. */
    @Reference
    private JcrResourceResolverFactory jcrResourceResolverFactory;

    protected void activate(final ComponentContext context) {
	}

    /**
     * @see WorkflowProcess#execute(WorkItem, WorkflowSession, MetaDataMap)
     */
    @Override
    public void execute(final WorkItem workItem, final WorkflowSession workflowSession, final MetaDataMap args)
        throws WorkflowException {
		}

    private void setIsSpam(final Node commentNode, final boolean value, final Session session)
        throws WorkflowException {
		}

}
