/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/
package com.adobe.cq.social.calendar.client.api;

import java.util.Map;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.commons.client.api.SocialCollectionComponent;
import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * Simply Social Calendar, a collection of CalendarEvent
 */
public interface Calendar extends SocialCollectionComponent {
    /**
     * Calendar component resource type.
     */
    String RESOURCE_TYPE = "social/calendar/components/hbs/calendar";

    /**
     * Calendar event resource type
     */
    String RESOURCE_TYPE_EVENT = "social/calendar/components/hbs/event";

    /**
     * Pagination and date filter selector's separator
     */
    String SELECTOR_SEPARATOR = "_";

    /**
     * Returns the resource path of this calendar.
     */
    String getPath() {
		return null;
	}

    /**
     * Returns the title of this calendar.
     */
    String getName() {
		return null;
	}

    /**
     * Get the range of date applies to this calendar instance.
     * @return
     */
    @JsonIgnore
    DateRangeFilter getDateRangeFilter() {
		return null;
	}

    /**
     * Set the date range filter
     */
    void setDateRangeFilter(final DateRangeFilter dateFilter) {
	}

    /**
     * Get next listing page
     */
    Page getNextListingPage() {
		return null;
	}

    /**
     * Get previous listing page
     */
    Page getPreviousListingPage() {
		return null;
	}

    /**
     * Get previous listing page
     */
    Page getCurrentListingPage() {
		return null;
	}

    /**
     * Get next calendar page
     */
    Page getNextCalendarPage() {
		return null;
	}

    /**
     * Get previous calendar page
     */
    Page getPreviousCalendarPage() {
		return null;
	}

    /**
     * Internal implementation. Do not use this API
     */
    Map<String, SimpleCalendarEvent> getEvents() {
		return null;
	}

    /**
     * Get the configuration for this Calendar
     * @return the configuration
     */
    CalendarConfiguration getConfiguration() {
		return null;
	}

    /**
     * Creates the configuration.
     * @param eventResource the event resource
     * @param calendarResouce the calendar resouce
     * @return the calendar configuration
     */
    CalendarConfiguration createConfiguration(final Resource eventResource, final Resource calendarResouce) {
		return null;
	}
}
