/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.calendar.client.api;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.calendar.client.impl.CalendarImpl;
import com.adobe.cq.social.calendar.client.impl.CalendarQueryRequestInfoImpl;
import com.adobe.cq.social.calendar.client.impl.DateRangeFilterImpl;
import com.adobe.cq.social.commons.client.api.AbstractSocialComponentFactory;
import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.commons.client.api.QueryRequestInfo;
import com.adobe.cq.social.commons.client.api.SocialComponent;
import com.adobe.cq.social.commons.client.api.SocialComponentFactory;
import com.day.cq.commons.date.DateUtil;
import com.day.cq.commons.date.InvalidDateException;

/**
 * CalendarSocialComponentFactory enabling the client to create Calendar instance for a specified resource.
 */
@Component(label = "AEM Social Communities Calendar SocialComponent Factory")
@Service(value = SocialComponentFactory.class)
public class CalendarSocialComponentFactory extends AbstractSocialComponentFactory implements SocialComponentFactory {
    /** Logger for this class. */
    private static final Logger LOG = LoggerFactory.getLogger(CalendarSocialComponentFactory.class);
    private static final DateUtil dateUtil = new DateUtil();

    /**
     * {@inheritDoc}
     */
    @Override
    public String getSupportedResourceType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource, final SlingHttpServletRequest request) {
		return null;
	}

    /**
     * Get the {@link QueryRequestInfo} from the specified request.
     * @param request
     * @return the QueryRequestInfo
     */
    @Override
    protected QueryRequestInfo getQueryRequestInfo(final SlingHttpServletRequest request) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource, final ClientUtilities clientUtils,
        final QueryRequestInfo queryInfo) {
			return null;
		}

    /**
     * Parse the date range filter from the request. The date range filter should be the third selector of the request
     * with the format of "start date-end date", where start and end date is an ISO8601 date time format string. If
     * the request is null, or does not have a selector, the method returns a DateRangeFilter of today's date.
     * @param request
     * @return a DateRangeFilter of the request
     * @throws InvalidDateException
     */
    protected DateRangeFilter getDateRangeFromRequest(final SlingHttpServletRequest request)
        throws InvalidDateException {
			return null;
		}
}