/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.activation.DataSource;
import javax.jcr.Binary;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.cq.social.commons.comments.endpoints.CommentOperations;
import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.wcm.api.WCMMode;

/**
 * <code>Comment</code> represents a single comment. It can also contain other {@link Comment}s.
 * @deprecated @since AEM 6.0. Use {@link CommentOperations} and {@link com.adobe.cq.social.commons.comments.api.Comment} instead.
 */
@Deprecated
public interface Comment extends com.adobe.granite.comments.Comment {

    /**
     * The comment node type.
     */
    public static final String NODE_TYPE = "cq:Comment";

    /**
     * The comment resource type.
     */
    public static final String RESOURCE_TYPE = "social/commons/components/comments/comment";

    /**
     * The property name for the resource type.
     */
    public static final String PROP_RESOURCE_TYPE = "sling:resourceType";

    /**
     * The property name for the message of this comment.
     */
    public static final String PROP_MESSAGE = JcrConstants.JCR_DESCRIPTION;

    /**
     * The property name for the date this comment has been added.
     */
    public static final String PROP_DATE = "added";

    /**
     * The property name for the approval status.
     */
    public static final String PROP_APPROVED = "approved";

    /**
     * The property name for the spam flag.
     */
    public static final String PROP_SPAM = "isSpam";

    /**
     * The property name for the boolean indicating the comment is hidden because it has been flagged enough.
     */
    public static final String PROP_FLAG_HIDE = "isFlaggedHidden";

    /**
     * The property name for the spam flag.
     */
    public static final String PROP_FLAGGED = "isFlagged";

    /**
     * The property name for the 'closed' flag.
     */
    public static final String PROP_CLOSED = "isClosed";

    /**
     * The location where the tally flags are stored relative to the comment.
     */
    public static final String FLAG_PATH_PREFIX = "/flags_";

    /**
     * The property name for the IP address.
     */
    public final static String PROP_IP_ADDRESS = "ip";

    /**
     * The property name for the user agent.
     */
    public final static String PROP_USER_AGENT = "userAgent";

    /**
     * The property name for the referer.
     */
    public final static String PROP_REFERER = "referer";

    /**
     * The name of the dynamically added parameter that needs to be present to make sure the form was posted by a
     * human being.
     */
    public final static String PARAM_BOTCHECK = "id";

    /**
     * The value of the dynamically added parameter that needs to be present to make sure the form was posted by a
     * human being.
     */
    public final static String VALUE_BOTCHECK = "nobot";

    /**
     * The property name for the authorizableId.
     */
    public final static String PROP_AUTHORIZABLE_ID = "authorizableId";

    /**
     * The property name for the file upload.
     */
    public final static String PROP_FILE_UPLOAD = "allowFileUploads";

    /**
     * The property name for deleting attachments
     */
    public final static String PROP_DELETE_ATTACHMENTS = "deleteAttachments";

    /**
     * The property name for forward replication
     */
    public final static String FORWARD_REPLICATED = "forwardReplicated";

    /**
     * The property to trigger moderation on edits.
     */
    public final static String PROP_MODERATE = "moderate";

    /*
     * The separator character using by a comment id.
     */
    public static final String COMMENTID_SEPARATOR = "__";

    /**
     * The forward redirect attribute using by form manager.
     */
    public static final String REQ_ATTR_REDIRECT = "cq.form.redirect";

    public static final String PROP_FLAG_REASON = "social:flagReason";

    public static final String PROP_FLAG_ALLOW_COUNT = "social:flagAllowCount";

    /**
     * Returns the first level of comments in chronological order.
     * @return The comments Replaced the old getComments():List
     */
    public Iterator<Comment> getComments() {
		return null;
	}

    /**
     * Returns the number of direct comments. Comments are excluded from the count if they are marked as spam, or
     * still unapproved in case comments are moderated.
     * @return The number of comments
     */
    public int countComments() {
		return 0;
	}

    /**
     * Returns the number of direct comments based on . If not in edit mode, comments are excluded from the count if
     * they are marked as spam, or still unapproved in case comments are moderated.
     * @param wcmMode The WCM mode
     * @return The number of comments
     */
    public int countComments(WCMMode wcmMode) {
		return 0;
	}

    /**
     * Checks whether there are any comments or not. Comments are excluded from the count if they are marked as spam,
     * or still unapproved in case comments are moderated.
     * @return <code>true</code> if there are comments, <code>false</code> otherwise
     */
    public boolean hasComments() {
		return false;
	}

    /**
     * Checks whether there are any comments or not based on the specified WCM mode. If not in edit mode, comments are
     * excluded from the count if they are marked as spam, or still unapproved in case comments are moderated.
     * @param wcmMode The WCM mode
     * @return <code>true</code> if there are comments, <code>false</code> otherwise
     */
    public boolean hasComments(WCMMode wcmMode) {
		return false;
	}

    /**
     * Returns the resource of the component responsible to draw these comments.
     * @return The component resource
     */
    public Resource getComponent() {
		return null;
	}

    /**
     * Get a named property and convert it into the given type.
     * @param name The name of the property
     * @param type The class of the type
     * @return Return named value converted to type T or null if non existing or can't be converted.
     * @see org.apache.sling.api.resource.ValueMap#get(String, Class)
     */
    public <T> T getProperty(String name, Class<T> type) {
		return null;
	}

    /**
     * Get a named property and convert it into the given type.
     * @param name The name of the property
     * @param defaultValue The default value to use if the named property does not exist or cannot be converted to the
     *            requested type. The default value is also used to define the type to convert the value to. If this
     *            is null any existing property is not converted.
     * @return Return named value converted to type T or the default value if non existing or can't be converted.
     * @see org.apache.sling.api.resource.ValueMap#get(String, Object)
     */
    public <T> T getProperty(String name, T defaultValue) {
		return null;
	}

    /**
     * Returns the underlying resource.
     * @return The resource
     */
    public Resource getResource() {
		return null;
	}

    /**
     * Returns the path of this comment.
     * @return The path
     */
    @Override
    public String getPath() {
		return null;
	}

    /**
     * Returns the relative URL of this comment.
     * @return The URL
     */
    public String getUrl() {
		return null;
	}

    /**
     * Returns the absolute URL of this comment, including scheme, server name and port. Use for non-html/browser
     * output formats that require absolute URLs, such as feeds or emails.
     * @param request The sling request
     * @return The URL
     */
    public String getFullUrl(SlingHttpServletRequest request) {
		return null;
	}

    /**
     * Returns the URL to refresh this comment, circumventing caching.
     * @return The refresh URL
     */
    public String getRefreshUrl() {
		return null;
	}

    /**
     * Returns the author of this comment.
     * @return The URL
     */
    public CollabUser getAuthor() {
		return null;
	}

    /**
     * Returns the message of this comment.
     * @return The message
     */
    @Override
    public String getMessage() {
		return null;
	}

    /**
     * Returns the date this comment was added on.
     * @return The date
     */
    public Date getDate() {
		return null;
	}

    /**
     * Sets the date this comment was added on.
     * @param date The date
     * @throws CommentException if date cannot be set
     */
    public void setDate(Date date) throws CommentException {
	}

    /**
     * Checks whether this comment is pending approval (in case comments are moderated).
     * @return <code>true</code> if comment is pending approval, <code>false</code> otherwise
     */
    public boolean isPending() {
		return false;
	}

    /**
     * Checks whether this comment is approved (in case comments are moderated).
     * @return <code>true</code> if comment is approved or unmoderated, <code>false</code> otherwise
     */
    public boolean isApproved() {
		return false;
	}

    /**
     * Checks whether this comment is denied (in case comments are moderated).
     * @return <code>true</code> if comment is denied, <code>false</code> otherwise
     */
    public boolean isDenied() {
		return false;
	}

    /**
     * Checks whether this comment is marked as spam.
     * @return <code>true</code> if comment is marked as spam, <code>false</code> otherwise
     */
    public boolean isSpam() {
		return false;
	}

    /**
     * Checks whether this comment is flagged as inappropriate.
     * @return <code>true</code> if comment is flagged, <code>false</code> otherwise
     */
    public boolean isFlagged() {
		return false;
	}

    /**
     * Checks whether this comment is hidden from flagging (before moderators have allowed or denied it).
     * @return <code>true</code> if comment is hidden from being flagged enough, <code>false</code> otherwise
     */
    public boolean isFlaggedHidden() {
		return false;
	}

    /**
     * Checks whether this comment is closed.
     * @return <code>true</code> if comment is closed, <code>false</code> otherwise
     */
    public boolean isClosed() {
		return false;
	}

    /**
     * Returns the ID of this comment.
     * @return The ID
     */
    public String getId() {
		return null;
	}

    /**
     * Returns the system this comment is in.
     * @return The system
     */
    public CommentSystem getCommentSystem() {
		return null;
	}

    /**
     * Adds a attachment to this comment.
     * @param name Name of the file
     * @param data Binary representation of the file
     * @param contentType Content Type of the file
     * @return The path of the attached file
     * @throws com.adobe.cq.social.commons.CommentException If the comment cannot be created
     * @deprecated use {@link addAttachemnt(Comment, String, java.io.InputStream, String)}
     */
    @Deprecated
    public String addAttachment(String name, Binary data, String contentType) throws CommentException {
		return null;
	}

    /**
     * Deletes a attachment from this comment.
     * @param attPath Attachment Path of the file.
     * @throws com.adobe.cq.social.commons.CommentException If the comment cannot be created
     * @deprecated use {@link removeAttachment(String)
     */
    @Deprecated
    public void deleteAttachment(String attPath) throws CommentException {
	}

    /**
     * Add multiple attachments for this comment.
     * @param attachments List of attached files in the DataSource format.
     */
    public void addAttachments(final List<DataSource> attachments) {
	}

    /**
     * Return true if this is a top level comment.
     * @return true if this is a top level comment.
     */
    public boolean isTopLevel() {
		return false;
	}

    /**
     * Returns the Properties valuemap for the node.
     * @return the properties set on the node.
     */
    @Override
    public ValueMap getProperties() {
		return null;
	}

    public Map<String, Attachment> getAttachments() {
		return null;
	}
}
