/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.activation.DataSource;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.commons.comments.endpoints.CommentOperations;
import com.adobe.granite.comments.CommentCollection;
import com.day.cq.wcm.api.WCMMode;

/**
 * <code>CommentSystem</code> represents a system of {@link Comment}s under a comments component.
 * @deprecated @since AEM 6.0. Use {@link CommentOperations} and {@link com.adobe.cq.social.commons.comments.api.CommentCollection} instead.
 */
@Deprecated
public interface CommentSystem extends CommentCollection {

    /**
     * The resource type for the comments component.
     */
    public static final String RESOURCE_TYPE = "social/commons/components/comments";

    /**
     * The node type of the comment node in UGC.
     */
    public static final String COMMENT_CONTENT_NODETYPE = "cq:CommentContent";

    /**
     * The node type for the comment system root
     */
    public static final String NODE_TYPE = COMMENT_CONTENT_NODETYPE;

    /**
     * The HTML suffix for URLs.
     */
    public static final String URL_SUFFIX = ".html";

    /**
     * The property name for the moderation status.
     */
    public static final String PROP_CLOSED = "closed";

    /**
     * The property name for the path to the comments component.
     */
    public static final String PROP_COMPONENT = "commentsNode";

    /**
     * The property name for the moderation status.
     */
    public static final String PROP_MODERATE_COMMENTS = "moderateComments";

    /**
     * The property name for the Comment Attachments folder.
     */
    public static final String NN_COMMENT_ATTACHMENTS = "attachments";

    /**
     * The path to the user-generated content.
     */
    public static final String PATH_UGC = "/content/usergenerated";

    /**
     * The name of the resource type property.
     */
    public static final String PROP_RESOURCE_TYPE = "sling:resourceType";

    /**
     * The property name for the file upload.
     */
    public final static String PROP_FILE_UPLOAD = "allowFileUploads";

    /**
     * The property name for the allowing replies to comments.
     */
    public final static String PROP_ALLOW_REPLIES = "allowRepliesToComments";

    /**
     * The property name for the file upload size.
     */
    public final static String PROP_FILE_UPLOAD_SIZE = "maxFileSize";

    /**
     * The property name for the allowed file types.
     */
    public final static String PROP_FILE_UPLOAD_TYPES = "acceptFileTypes";

    /**
     * The property name for the default attachment size.
     */
    public static final long PV_DEFAULT_MAX_ATTACHMENT_SIZE = 104857600;

    /**
     * The property name for the file upload size.
     */
    public final static String PROP_IMAGE_UPLOAD_SIZE = "maxImageFileSize";

    /**
     * The property name for the rich text editor enabled.
     */
    public final static String PROP_RTE_ENABLED = "rteEnabled";

    /**
     * The property name for the default image size.
     */
    public static final long PV_DEFAULT_MAX_IMAGE_BYTE_SIZE = 2097152;

    /**
     * The property that points to where the edit form is located.
     */
    static final String PN_EDIT_COMMENT_FORM = "editform";

    /**
     * The default edit form location.
     */
    static final String PN_EDIT_COMMENT_FORM__DEFAULT_LOCATION = "/etc/forms/social/comments/editcomment";

    /**
     * The property to allow users to edit their comments.
     */
    static final String PN_DELETE_COMMENTS = "allowDeleteComments";

    /**
     * The property to allow moderators to deny a comment.
     */
    static final String PN_DENY_COMMENTS = "allowDenyComments";

    /**
     * The property to allow moderators to close a comment.
     */
    final String PN_CLOSE_COMMENTS = "allowCloseComments";

    /**
     * The property name for the character limit of message.
     */
    static final String PROP_MESSAGE_LENGTH = "maxMessageLength";

    /**
     * The default character limit of message.
     */
    static final long PV_DEFAULT_MAX_MESSAGE_LENGTH = 104857600;

    /**
     * The property to allow users to flag a comment (as inappropriate).
     */
    static final String PN_FLAG_COMMENTS = "allowFlagComments";

    /**
     * The property to allow users to flag a comment and indicate a reason from a list of reasons.
     */
    static final String PN_USE_FLAG_REASON_LIST = "useFlagReasonList";

    /**
     * The property indicating the number of times a comment must be flagged, after being marked for moderation,
     * before it is hidden from public view.
     */
    static final String PN_FLAG_VIEW_THRESHOLD = "flagViewThreshold";

    /**
     * The property indicating the number of times a comment must be flagged to be marked for moderation.
     */
    static final String PN_FLAG_MOD_THRESHOLD = "flagModerateThreshold";

    /**
     * The default flag view threshold.
     */
    static final Integer PV_DEFAULT_FLAG_VIEW_THRESHOLD = 4;

    /**
     * The default flag moderate threshold.
     */
    static final Integer PV_DEFAULT_FLAG_MOD_THRESHOLD = 1;

    /**
     * The property to allow users to enter a custom flagging reason.
     */
    static final String PN_ALLOW_CUSTOM_FLAG_REASON = "allowCustomFlagReason";

    /**
     * The name of the reverse replication property.
     * @deprecated use {@link com.day.cq.replication.Replicator} directly to trigger reverse replication.
     */
    @Deprecated
    public static final String PROP_DISTRIBUTE = "cq:distribute";

    /**
     * Returns the ID of the comments.
     * @return The ID
     */
    public String getId() {
		return null;
	}

    /**
     * Returns the path of the page hosting the comments.
     * @return The path
     */
    @Override
    public String getPath() {
		return null;
	}

    /**
     * Sets the path of the page hosting the comments.
     * @param path The path of the page hosting the comments.
     */
    public void setPath(String path) {
	}

    /**
     * Returns the root path of the comment system.
     * @return The path
     */
    public String getRootPath() {
		return null;
	}

    /**
     * Returns the URL for these comments.
     * @return The URL
     */
    public String getUrl() {
		return null;
	}

    /**
     * Returns the first level of comments in chronological order.
     * @return The comments Replaced the old getComments() : List<Comment>
     */
    public Iterator<Comment> getComments() {
		return null;
	}

    /**
     * Returns the number of comments (including comments to comments). Comments are excluded from the count if they
     * are marked as spam, or still unapproved in case comments are moderated.
     * @return The number of comments
     */
    public int countComments() {
		return 0;
	}

    /**
     * Returns the number of comments (including comments to comments) based on the specified WCM mode. If not it edit
     * mode, comments are excluded from the count if they are marked as spam, or still unapproved in case comments are
     * moderated.
     * @param wcmMode The WCM mode
     * @return The number of comments
     */
    public int countComments(WCMMode wcmMode) {
		return 0;
	}

    /**
     * Checks whether there are any comments or not. Comments are excluded from the count if they are marked as spam,
     * or still unapproved in case comments are moderated.
     * @return <code>true</code> if there are comments, <code>false</code> otherwise
     */
    public boolean hasComments() {
		return false;
	}

    /**
     * Checks whether there are any comments or not based on the specified WCM mode. If not in edit mode, comments are
     * excluded from the count if they are marked as spam, or still unapproved in case comments are moderated.
     * @param wcmMode The WCM mode
     * @return <code>true</code> if there are comments, <code>false</code> otherwise
     */
    public boolean hasComments(WCMMode wcmMode) {
		return false;
	}

    /**
     * Returns the underlying resource.
     * @return The resource
     */
    public Resource getResource() {
		return null;
	}

    /**
     * Checks whether the comments are moderated.
     * @return <code>true</code> if comments are moderated, <code>false</code> otherwise
     */
    public boolean isModerated() {
		return false;
	}

    /**
     * Checks whether comments system is closed.
     * @return <code>true</code> if comment system closed, <code>false</code> otherwise
     */
    public boolean isClosed() {
		return false;
	}

    /**
     * Get a named property of the comments component and convert it into the given type.
     * @param name The name of the property
     * @param type The class of the type
     * @return Return named value converted to type T or null if non existing or can't be converted.
     * @see org.apache.sling.api.resource.ValueMap#get(String, Class)
     */
    public <T> T getProperty(String name, Class<T> type) {
		return null;
	}

    /**
     * Get a named property of the comments component and convert it into the given type.
     * @param name The name of the property
     * @param defaultValue The default value to use if the named property does not exist or cannot be converted to the
     *            requested type. The default value is also used to define the type to convert the value to. If this
     *            is null any existing propert is not converted.
     * @return Return named value converted to type T or the default value if non existing or can't be converted.
     * @see org.apache.sling.api.resource.ValueMap#get(String, Object)
     */
    public <T> T getProperty(String name, T defaultValue) {
		return null;
	}

    /**
     * Adds a comment to this comment collection. The comment does not have any file attachment.
     * @param text The text
     * @param author The author of the comment (optional)
     * @return The comment
     * @throws com.adobe.cq.social.commons.CommentException If the comment cannot be created
     */
    public Comment addComment(String text, String author) throws CommentException {
		return null;
	}

    /**
     * Adds a comment to this comment collection using the specified text, author and file attachment.
     * @param text The text
     * @param author The author of the comment (optional)
     * @param fileAttachment The file upload of the comment (optional)
     * @return The comment
     * @throws com.adobe.cq.social.commons.CommentException If the comment cannot be created
     */
    public Comment addComment(String text, String author, List<DataSource> fileAttachment) throws CommentException {
		return null;
	}

    /**
     * Adds a comment to this comment collection using the specified text, author and file attachment.
     * @param text The text
     * @param author The author of the comment (optional)
     * @param fileAttachments The file upload of the comment (optional)
     * @param properties set of properties of the new comment
     * @return The comment
     * @throws com.adobe.cq.social.commons.CommentException If the comment cannot be created
     */
    Comment addComment(String text, String author, List<DataSource> fileAttachments, String annotationData,
        String resourceType, Map<String, Object> properties) throws CommentException {
		return null;
	}

    /**
     * Return a subset of the comments as defined by the given offset and size. The comments are returned in
     * chronological order.
     * @param offset the offset starting from 0.
     * @param size the max number of elements to return.
     * @return The list of comments with the specified offset and size.
     * @throws CommentException if an error occurs when getting a comment
     */
    List<Comment> getComments(int offset, int size) throws CommentException {
		return null;
	}

    /**
     * Return a subset of the comments as defined by the given offset and size. The comments are returned in reversed
     * order.
     * @param offset the offset starting from 0.
     * @param size the max number of elements to return.
     * @param reversedOrder set to <code>true</code> to get the reversed order of the list.
     * @return The list of comments with the specified offset and size.
     * @throws CommentException if an error occurs when getting a comment
     */
    List<Comment> getComments(int offset, int size, boolean reversedOrder) throws CommentException {
		return null;
	}

    /**
     * Saves all changes made. Missing resources will be created
     * @throws CollabException if saving fails
     */
    public void save() throws CollabException {
	}

    /**
     * Returns true if the comment system has a property to allow edits. @See CommentSystem#NN_EDIT_COMMENTS
     * @return true if the comment system allows deletes
     */
    boolean allowsEdit() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow deletes. @See CommentSystem#NN_DELETE_COMMENTS
     * @return true if the comment system allows deletes
     */
    boolean allowsDelete() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow deny actions. @See CommentSystem#NN_DENY_COMMENTS
     * @return true if the comment system allows deny actions
     */
    boolean allowsDeny() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow close actions. @See CommentSystem#NN_DENY_COMMENTS
     * @return true if the comment system allows close actions
     */
    boolean allowsClose() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow deny actions. @See CommentSystem#NN_DENY_COMMENTS
     * @return true if the comment system allows deny actions
     */
    boolean allowsFlagging() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow attachments. @See CommentSystem#PROP_FILE_UPLOAD
     * @return true if the comment system allows attachments
     */
    boolean allowsAttachment() {
		return false;
	}

    /**
     * Returns true if the comment system has a property to allow replies to comments. @See
     * CommentSystem#PROP_ALLOW_REPLIES
     * @return true if the comment system allows replies
     */
    boolean allowsReplies() {
		return false;
	}

    /**
     * Returns the Maximum number of bytes a file may have if the comment system has a property to allow attachments.
     * @See CommentSystem#PROP_FILE_UPLOAD_SIZE
     * @return file attachment size if the comment system allows attachments
     */
    long getAttachmentSizeLimit() {
		return 0L;
	}

    /**
     * Returns the Maximum number of characters a comment message text may have. @See
     * CommentSystem#PROP_MESSAGE_LENGTH
     * @return the maximum number of characters in comment message text
     */
    long getMessageCharacterLimit() {
		return 0L;
	}

    /**
     * Returns the string that is a list of Comma seperated file extensions with dots. @See
     * CommentSystem#PROP_FILE_UPLOAD_TYPES
     * @return List of allowed file extensions (white list) with dots, example [".jpg", ".jpeg", ".png", ".doc",
     *         ".docx", ".ppt", ".zip", ".rar"]
     */
    List<String> getAllowedFileTypes() {
		return null;
	}

    /**
     * Deletes a comment from the comment system. This will also delete any replies to that comment.
     * @param comment the comment to delete
     * @throws CommentException if an error occurs when deleting a comment
     * @return a list of Paths that will be changed by the delete
     * @deprecated use {@link Comment.remove}
     */
    @Deprecated
    List<String> deleteComment(Comment comment) throws CommentException {
		return null;
	}

    /**
     * Set the bucket postfix to be used with the <code>BucketStorageSystem</code>.
     * @param postfix the postfix
     */
    public void setBucketPostfix(String postfix) {
	}

    /**
     * Get the bucket postfix.
     * @return bucket postfix
     */
    public String getBucketPostfix() {
		return null;
	}

    /**
     * Returns true if the comment system has a property to enable rich text editor. @See
     * CommentSystem#PROP_RTE_ENABLED
     * @return true if the comment system enabling rte
     */
    public boolean isRteEnabled() {
		return false;
	}

    /**
     * Returns the configured editFormLocation of the comment system.
     * @return the location, as a String, or an empty String if unset.
     */
    public String getEditFormLocation() {
		return null;
	}

    /**
     * @return the number of times a comment must be flagged before it is hidden.
     */
    public long getFlagViewThreshold() {
		return 0L;
	}

    /**
     * @return the number of times a comment must be flagged to be sent for moderation.
     */
    public long getFlagModerateThreshold() {
		return 0L;
	}

    /**
     * Returns true if the comment system allows users to choose reasons for flagging content from a list
     * @return true allowed
     */
    public boolean useFlagReasonList() {
		return false;
	}

    /**
     * Returns true if the comment system allows users to enter their own reason for flagging content
     * @return true if allowed
     */
    public boolean allowCustomFlagReason() {
		return false;
	}
}
