/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.cq.social.commons.comments.api.CommentCollectionConfiguration;
import com.day.cq.wcm.api.designer.Designer;
import com.day.cq.wcm.api.designer.Style;

/**
 * Collection of utilities revolving around CQ Social Collaboration comment features.
 * @since CQ 5.6.0
 */
public class CommentUtil {

    /**
     * Checks whether the provided comment is pending approval (in case comments are moderated).
     * @param resource The comment resource
     * @param component The comment component resource
     * @return <code>true</code> if comment is pending approval, <code>false</code> otherwise
     */
    public static boolean isPending(final Resource resource, final Resource component) {
		return false;
	}

    /**
     * Checks whether the provided comment is approved (in case comments are moderated).
     * @param resource The comment resource
     * @param component The comment component resource
     * @return <code>true</code> if comment is approved or unmoderated, <code>false</code> otherwise
     */
    public static boolean isApproved(final Resource resource, final Resource component) {
		return false;
	}

    /**
     * Checks whether the provided comment is marked as spam.
     * @param resource The comment resource
     * @return <code>true</code> if comment is marked as spam, <code>false</code> otherwise
     */
    public static boolean isSpam(final Resource resource) {
		return false;
	}

    /**
     * Checks whether the provided comment is flagged as inappropriate.
     * @param resource The comment resource
     * @return <code>true</code> if comment is flagged, <code>false</code> otherwise
     */
    public static boolean isFlagged(final Resource resource) {
		return false;
	}

    /**
     * Checks whether the provided comment is closed.
     * @param resource The comment resource
     * @return <code>true</code> if comment is closed, <code>false</code> otherwise
     */
    public static boolean isClosed(final Resource resource) {
		return false;
	}

    /**
     * Checks whether the provided comment is hidden from flagging.
     * @param resource The comment resource
     * @return <code>true</code> if comment is hidden from flagging, <code>false</code> otherwise
     */
    public static boolean isFlaggedHidden(final Resource resource) {
		return false;
	}

    /**
     * Checks whether the comments are moderated.
     * @param component The comment component, representing the comment system
     * @return <code>true</code> if comments are moderated, <code>false</code> otherwise
     */
    public static boolean isSystemModerated(final Resource component) {
		return false;
	}

    /**
     * Checks whether the comment system is closed.
     * @param component The comment component, representing the comment system
     * @return <code>true</code> if comment system is closed, <code>false</code> otherwise
     */
    public static boolean isSystemClosed(final Resource component) {
		return false;
	}

    /**
     * Get a named property of the provided resource and convert it into the given type.
     * @param resource The resource
     * @param name The name of the property
     * @param defaultValue The default value to use if the named property does not exist or cannot be converted to the
     *            requested type. The default value is also used to define the type to convert the value to. If this
     *            is null any existing propert is not converted.
     * @return Return named value converted to type T or null if non existing or can't be converted.
     * @see org.apache.sling.api.resource.ValueMap#get(String, Class)
     */
    public static <T> T getProperty(final Resource resource, final String name, final T defaultValue) {
		return null;
	}

    /**
     * Check whether the comment system allow users vote on comment
     * @param component the comment component, representing the comment system
     * @return <code>true</code> if comment system enable the user to vote, <code>false</code> otherwise
     */
    public static boolean isAllowVoting(final Resource component) {
		return false;
	}

    public static String getVotingType(final Resource component) {
		return null;
	}

    public static String getVotingRoot(final Resource component) {
		return null;
	}

    public static <T> T getDesignConfig(final Resource component, final String configName, final T defaultValue) {
		return null;
	}
}
