/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

/**
 * Interface for access to email configuration values.
 */
public interface EmailConfig {

    /**
     * The host prefix property name.
     */
    static final String HOST_PREFIX_PROPERTY = "host.prefix";

    /**
     * Return the config value or null if it is unspecified.
     * @param configType the config type.
     * @param name the config name.
     * @return the config value or null if it is unspecified.
     */
    String getConfig(String configType, String name) {
		return null;
	}

    /**
     * Set the config value.
     * @param configType the config type.
     * @param name the config name.
     * @param path the path to the node that stores this configuration.
     * @param defaultValue the default value if the configPath does not exist.
     */
    void setConfig(String configType, String name, String configPath, String defaultValue) {
	}
}
