/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

import org.apache.sling.api.SlingHttpServletRequest;

/**
 * <code>ToggleUtil</code>...
 */
public class ToggleUtil {

    /**
     * Property for selector user state toggle.
     */
    public static final String SELECTOR_USER_STATE_TOGGLE = "socialuserstatetoggle";

    /**
     * Property for state provider base resource type.
     */
    public static final String RESOURCETYPE_STATEPROVIDER_BASE =
        "social/commons/components/toggle/stateproviders/base";

    /**
     * Property for current state name.
     */
    public static final String PARAM_NAME_CURRENTSTATE = "cs";

    /**
     * Property for old state name.
     */
    public static final String PARAM_NAME_OLDSTATE = "os";

    /**
     * Property for resource name.
     */
    public static final String PARAM_NAME_RESOURCE = "r";

    /**
     * Property for state provider name.
     */
    public static final String PARAM_NAME_STATEPROVIDER = "sp";

    /**
     * Property for workflow model name.
     */
    public static final String PARAM_NAME_WORKFLOWMODEL = "wf";

    /**
     * Property for need approval name.
     */
    public static final String PARAM_NAME_NEEDAPPROVAL = "na";

    /**
     * Property for confirm message toggle name.
     */
    public static final String PN_CONFIRMATIONTOGGLE = "confirmationMessageToggle";

    /**
     * Property for confirm message untoggle name.
     */
    public static final String PN_CONFIRMATIONUNTOGGLE = "confirmationMessageUntoggle";

    /**
     * Property for state provider.
     */
    public static final String PN_STATEPROVIDER = "stateProvider";

    /**
     * Property for toggle state approval.
     */
    public static final String PN_NEEDAPPROVAL = "toggleStateApproval";

    /**
     * Property for transition label.
     */
    public static final String PN_TRANSITIONLABEL = "transitionLabel";

    /**
     * Property for toggle label.
     */
    public static final String PN_TOGGLELABEL = "toggleLabel";

    /**
     * Property for toggle workflow model.
     */
    public static final String PN_TOGGLEWORKFLOWMODEL = "toggleWorkflowModel";

    /**
     * Property for untoggle label.
     */
    public static final String PN_UNTOGGLELABEL = "untoggleLabel";

    /**
     * Property for untoggle workflow model.
     */
    public static final String PN_UNTOGGLEWORKFLOWMODEL = "untoggleWorkflowModel";

    /**
     * Property for toggle state provider.
     */
    public static final String PN_WORKFLOW_METADATA_STATEPROVIDER = "toggleStateProvider";

    /**
     * Property for toggle resource.
     */
    public static final String PN_WORKFLOW_METADATA_RESOURCE = "toggleResource";

    /**
     * Property for social state toggle user.
     */
    public static final String PN_WORKFLOW_METADATA_USER = "socialstateToggleUser";

    /**
     * Property for toggle state approval.
     */
    public static final String PN_WORKFLOW_METADATA_APPROVAL = "toggleStateApproval";

    /**
     * Property for social state toggle workflows.
     */
    public static final String PN_PROFILE_TOGGLEWORKFLOWS = "socialstateToggleWorkflows";

    /**
     * Property for workflow failure message.
     */
    public static final String PN_WORKFLOW_FAILURE_MESSAGE = "workflowFailureMessage";

    /**
     * enum STATE of toggle.
     */
    public static enum STATE {

        HIDE, TOGGLED, TRANSITION, UNTOGGLED

    }

    /**
     * Property for ToggleUtil.state.
     */
    public static final String REQUEST_ATTRIBUTE_NAME_STATE = ToggleUtil.class.getName() + ".state";

    /**
     * This method sets the STATE attribute to request.
     * @param state The toggle state
     * @param request The sling request
     */
    public static void toRequest(final STATE state, final SlingHttpServletRequest request) {
	}

    /**
     * This method returns the STATE attribute from request.
     * @param request The sling request
     * @return the toggle state
     */
    public static STATE fromRequest(final SlingHttpServletRequest request) {
		return null;
	}
}
