/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons;

import org.apache.sling.api.SlingHttpServletRequest;

/**
 * The <code>UserStateToggleManager</code> defines methods pertaining to the user state toggle feature.
 */
public interface UserStateToggleManager {

    /**
     * This method determins whether the user state for a given state provider is currently transitioning, i.e. is in
     * the process of switching from toggled/untoggled to untoggled/toggled. Transitioning is defined as a running
     * workflow present in the user's profile pertaining to the state provider.
     * @param stateProviderPath The path of the state provider component.
     * @param request The request from which the user's profile is determined.
     * @return <code>true</code> if a transitioning state was detected.
     */
    boolean isTransitioning(String stateProviderPath, SlingHttpServletRequest request) {
		return false;
	}
}
