/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.client.api;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The QueryRequestInfo maintains information such as pagination, query predicates of a client request.
 * @author thuynh
 */
public interface QueryRequestInfo {

    public interface QueryRequestInfoFactory {
        QueryRequestInfo create() {
			return null;
		}

        QueryRequestInfo create(QueryRequestInfo copyFrom) {
			return null;
		}
    }

    QueryRequestInfoFactory DEFAULT_QUERY_INFO_FACTORY = new QueryRequestInfoFactory() {
        @Override
        public QueryRequestInfo create() {
			return null;
		}

        @Override
        public QueryRequestInfo create(final QueryRequestInfo copyFrom) {
			return null;
		}
    };

    /**
     * Is the request a query request
     */
    boolean isQuery() {
		return false;
	}

    /**
     * Get the query predicates.
     * @return null if the request is not a query request, otherwise, the method returns a map of the query predicates
     */
    Map<String, String[]> getPredicates() {
		return null;
	}

    /**
     * Get the request paging specification
     */
    CollectionPagination getPagination() {
		return null;
	}

    /**
     * Set the pagination
     * @param pagination the pagination setting.
     */
    void setPagination(final CollectionPagination pagination) {
	}

    /**
     * @param a list of indexes to use to sort the list by
     */
    void setSortBy(final List<String> sortBy) {
	}

    /**
     * @return the list of index names requested to sort the list by
     */
    List<String> getSortBy() {
		return null;
	}

    /**
     * @param order for the list
     */
    void setSortOrder(final CollectionSortedOrder order) {
	}

    /**
     * @return the requested order to sort the list by
     */
    CollectionSortedOrder getSortOrder() {
		return null;
	}
}
