/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.client.api;

import java.util.List;

public interface User extends SocialComponent {

    public static final String RESOURCE_TYPE = "social/commons/components/author";

    /**
     * An interface that represents a badge that is awarded to community users.
     */
    public interface Badge {
        /**
         * @return name of the badge
         */
        String getTitle() {
			return null;
		}

        /**
         * @return externalized url to the badge's image
         */
        String getImageUrl() {
			return null;
		}
    }

    /**
     * User display name.
     * @return the user name
     */
    String getName() {
		return null;
	}

    /**
     * Get URL to fetch the user avatar.
     * @return the url of the user avatar
     */
    String getAvatarUrl() {
		return null;
	}

    /**
     * @return the userId of the user.
     */
    String getUserId() {
		return null;
	}

    /**
     * Get URL to fetch the user avatar (48px).
     * @return the url of the user avatar
     */
    String getLargeAvatarUrl() {
		return null;
	}

    /**
     * Get externalized URL to the profile page
     * @return an externalized URL to the user's public profile
     */
    String getProfileUrl() {
		return null;
	}

    /**
     * @return number of forum posts authored by the user
     */
    Long getNumberOfPosts() {
		return null;
	}

    /**
     * @return a list of badges that the user has been awarded
     */
    List<Badge> getBadges() {
		return null;
	}
}
