/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.client.endpoints;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.concurrent.ConcurrentHashMap;

import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.request.RequestParameter;
import org.apache.sling.api.request.RequestParameterMap;
import org.apache.sling.api.resource.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Abstract class that implements {@link OperationService}. This class provides the necessary functionality to
 * bind/unbind OperationExtentions and to perform before and after actions.
 * @param <T> the specific type of {@link OperationExtension} supported by this service.
 * @param <U> the specific set of operations supported by this service.
 * @param <S> the object representing the resource/component that the service was performed on.
 */
@SuppressWarnings("rawtypes")
public abstract class AbstractOperationService<T extends OperationExtension, U extends Operation, S> implements
    OperationService<T, U, S> {

    protected final Map<U, SortedSet<T>> extensionProviders = new ConcurrentHashMap<U, SortedSet<T>>(10);
    /**
     * Logger.
     */
    private static final Logger LOG = LoggerFactory.getLogger(AbstractOperationService.class);

    @SuppressWarnings("unchecked")
    @Override
    public synchronized void addOperationExtension(final T extension) {
	}

    @SuppressWarnings("unchecked")
    @Override
    public synchronized void removeOperationExtension(final T extension) {
	}

    @SuppressWarnings("unchecked")
    @Override
    public void performBeforeActions(final U operation, final Session session, final Resource resource,
        final Map<String, Object> requestParameters) throws OperationException {
		}

    @SuppressWarnings("unchecked")
    @Override
    public void performAfterActions(final U operation, final Session session, final S component,
        final Map<String, Object> requestParameters) throws OperationException {
		}

    /**
     * @param request a HTTP request that triggered the operation
     * @return a map of request parameters.
     * @throws RepositoryException if request parameters could not be converted to Value
     */
    protected Map<String, Object> getValueMapFromRequest(final SlingHttpServletRequest request)
        throws RepositoryException {
			return null;
		}
}
