/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.client.endpoints;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferenceCardinality;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.SyntheticResource;
import org.apache.sling.api.servlets.HttpConstants;
import org.apache.sling.api.wrappers.SlingHttpServletRequestWrapper;
import org.osgi.framework.BundleContext;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.client.api.BaseSocialComponent;
import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.commons.client.api.ClientUtilityFactory;
import com.adobe.cq.social.commons.client.api.SocialComponent;
import com.adobe.cq.social.commons.client.api.SocialComponentFactory;
import com.adobe.cq.social.commons.client.api.SocialComponentFactoryManager;
import com.adobe.cq.social.ugcbase.AbstractSessionServlet;
import com.adobe.cq.social.ugcbase.SocialException;
import com.adobe.cq.social.ugcbase.SocialUtils;
import com.adobe.granite.xss.XSSAPI;
import com.day.cq.search.QueryBuilder;

/**
 * This servlet serves all GET requests to .social.json.
 */
@Component(metatype = true, label = "AEM Social Communities DefaultSocialGetServlet",
        description = "This servlet serves the GET request for social components")
@Service(value = javax.servlet.Servlet.class)
@Properties({
    @Property(name = "service.description",
            value = "com.adobe.cq.social.comments.client.servlets.DefaultSocialGetServlet"),
    @Property(name = "sling.servlet.resourceTypes", value = {"sling/servlet/default"}, propertyPrivate = true),
    @Property(name = "sling.servlet.methods", value = {HttpConstants.METHOD_GET}, propertyPrivate = true),
    @Property(name = "sling.servlet.selectors", value = {DefaultSocialGetServlet.DEFAULT_SELECTOR,
        DefaultSocialGetServlet.QUERY_SELECTOR, DefaultSocialGetServlet.INDEX_SELECTOR}, propertyPrivate = false),
    @Property(name = "sling.servlet.extensions", value = {"json"}, propertyPrivate = false)})
public class DefaultSocialGetServlet extends AbstractSessionServlet {
    protected static final String CONTENT_TYPE = "application/json";

    protected static final String ENCODING = "utf-8";
    protected static final Boolean DEFAULT_TIDY = Boolean.FALSE;

    private static final long serialVersionUID = 351915124629267812L;

    /** Logger for this class. */
    private static final Logger LOG = LoggerFactory.getLogger(DefaultSocialGetServlet.class);

    /**
     * Parameter to use for tidy JSON. If present, indentation and line breaks are added for better legibility.
     */
    private static final String TIDY = "tidy";
    private BundleContext bundleContext;

    @Reference
    protected SocialComponentFactoryManager srfMgr;
    @Reference
    protected QueryBuilder queryBuilder;
    /** Reference to <code>XSSAPI</code>. */
    @Reference(cardinality = ReferenceCardinality.MANDATORY_UNARY, policy = ReferencePolicy.STATIC)
    private XSSAPI xss;
    @Reference
    private SocialUtils socialUtils;

    @Reference
    private ClientUtilityFactory clientUtilFactory;

    public static final String DEFAULT_SELECTOR = "social";
    public static final String QUERY_SELECTOR = "social.query";
    public static final String INDEX_SELECTOR = "index";

    @Override
    protected final void doPost(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}

    @SuppressWarnings("rawtypes")
    @Override
    protected final void doGet(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}

    private void sendResponse(final SocialComponent resource, final SlingHttpServletResponse response,
        final SlingHttpServletRequest request, final boolean tidy) throws IOException {
		}

    protected void writeResponse(final SocialComponent resource, final SlingHttpServletResponse response,
        final SlingHttpServletRequest request, final boolean tidy) throws IOException {
		}

    protected void setResponseHeaders(final SlingHttpServletResponse response, final SlingHttpServletRequest request) {
	}

    protected ClientUtilities getClientUtils(final SlingHttpServletRequest request) {
		return null;
	}

    protected void activate(final ComponentContext context) {
	}
}
