/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.client.endpoints;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.servlet.ServletException;

import org.apache.commons.lang3.StringUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferenceCardinality;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.servlets.HttpConstants;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.annotation.Endpoint;
import com.adobe.cq.social.commons.annotation.Parameter;
import com.adobe.cq.social.commons.annotation.Parameters;
import com.adobe.cq.social.ugcbase.AbstractSessionServlet;

@Component(metatype = true, label = "AEM Social Communities OperationsServlet",
        description = "This servlet returns the APIs that is supported by all social component endpoints")
@Service(value = javax.servlet.Servlet.class)
@Properties({
    @Property(name = "service.description",
            value = "com.adobe.cq.social.comments.client.endpoints.SocialOperationsServlet"),
    @Property(name = "sling.servlet.resourceTypes", value = {"sling/servlet/default"}, propertyPrivate = true),
    @Property(name = "sling.servlet.methods", value = {HttpConstants.METHOD_GET}, propertyPrivate = true),
    @Property(name = "sling.servlet.selectors", value = {"social"}, propertyPrivate = false),
    @Property(name = "sling.servlet.extensions", value = {"api"}, propertyPrivate = false)})
@Reference(name = "SocialOperationInfo", referenceInterface = SocialOperationInfo.class,
        cardinality = ReferenceCardinality.OPTIONAL_MULTIPLE, policy = ReferencePolicy.DYNAMIC)
public class SocialOperationsServlet extends AbstractSessionServlet {

    private static final long serialVersionUID = -6564020190927800329L;
    protected final Map<String, List<SocialOperationInfo>> operationProviders =
        new ConcurrentHashMap<String, List<SocialOperationInfo>>(10);
    /**
     * Logger.
     */
    private static final Logger LOG = LoggerFactory.getLogger(SocialOperationsServlet.class);

    @Override
    protected final void doPost(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}

    @SuppressWarnings("rawtypes")
    @Override
    protected final void doGet(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}

    private List<SocialOperationInfo> getOperationProviders(final Resource resource) {
		return null;
	}

    private void writeOperationProviders(final JSONWriter out, final String resourceType,
        final List<SocialOperationInfo> providers) throws JSONException {
		}

    private void writeOperationInfo(final JSONWriter out, final SocialOperationInfo operation) throws JSONException {
	}

    private void writeParameters(final JSONWriter out, final Parameters parameters) throws JSONException {
	}

    private void writeParameter(final JSONWriter out, final Parameter param) throws JSONException {
	}

    /**
     * OSGi bind {@link SocialOperationInfo} handler.
     * @param operation the SocialOperationInfo
     */
    protected void bindSocialOperationInfo(final SocialOperationInfo operation) {
	}

    /**
     * OSGi unbind {@link SocialOperationInfo} handler.
     * @param operation the SocialOperationInfo
     */
    protected void unbindSocialOperationInfo(final SocialOperationInfo operation) {
	}
}
