/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.comments.api;

import com.fasterxml.jackson.annotation.JsonProperty;

public interface CommentCollectionConfiguration {
    /**
     * The property name for allowing users to vote
     */
    String PN_ALLOW_VOTING = "allowVoting";

    /**
     * The default value of Allow Voting property
     */
    boolean PV_DEFAULT_ALLOW_VOTING = false;

    /**
     * The property name of the allowing users voting root
     */
    String PN_VOTING_ROOT = "votingRoot";

    String PN_ALLOW_TAGGING = "allowTagging";

    /**
     * The default value of allow users voting root
     */
    String PV_DEFAULT_VOTING_ROOT = "voting";

    /**
     * The property name of the voting type
     */
    String PN_VOTING_TYPE = "votingType";

    /**
     * The default value of allow users voting type
     */
    String PV_DEFAULT_VOTING_TYPE = "social/tally/components/hbs/voting";

    /**
     * @return true if the comment can be voted
     */
    @JsonProperty("isVotingAllowed")
    boolean isVotingAllowed() {
		return false;
	}

    /**
     * Allows attachment.
     * @return true, if successful
     */
    @JsonProperty("isAttachmentAllowed")
    boolean isAttachmentAllowed() {
		return false;
	}

    /**
     * Checks if is RTE enabled.
     * @return true, if is RTE enabled
     */
    @JsonProperty("isRTEEnabled")
    boolean isRTEEnabled() {
		return false;
	}

    /**
     * @return boolean indicating if custom flag reasons are allowed. The JCR of this attribute is called
     *         "seFlagReasonFreeformText"
     */
    @JsonProperty("isCustomFlagReasonAllowed")
    boolean isCustomFlagReasonAllowed() {
		return false;
	}

    /**
     * @return the default number of comments on a page as configured on the component. If there is no configuration,
     *         this defaults to 10.
     */
    int getPageSize() {
		return 0;
	}
}
