/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.comments.listing;

import com.adobe.cq.social.commons.client.api.CollectionPagination;
import com.adobe.cq.social.storage.index.IndexElementFactory;

/**
 * Define copy constructor which copies the current {@link IndexElementFactory} with a new specified
 * {@link CollectionPagination}.
 * @param <C>
 */
public interface CommentIndexElementFactory<C> extends IndexElementFactory<C> {
    /**
     * Create a new instance of IndexElementFactory with the specified pagination.
     * @param pagination the new pagination.
     * @return new instance of CommentIndexElementFactory
     */
    CommentIndexElementFactory<C> setPagination(final CollectionPagination pagination) {
		return null;
	}

    /**
     * Gets the pagination information associated with the factory.
     * @return pagination details used by this factory.
     */
    CollectionPagination getPagination() {
		return null;
	}
}
