/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.cors;

/**
 * Singleton configuration holder so that both the CORS filter and CORS post processor have accessing to the system
 * settings.
 */
public final class CORSConfig {
    private static final CORSConfig INSTANCE = new CORSConfig();

    private boolean enable = false;

    // Private constructor prevents instantiation from other classes
    private CORSConfig() {
    }

    /**
     * Get the CORSConfig instance.
     * @return the CORSConfig singleton
     */
    public static CORSConfig getInstance() {
		return null;
	}

    /**
     * Check whether the CORS support is enabling.
     * @return <code>true</code> if CORS is enabled, else returns <code>false</code>
     */
    public synchronized boolean isEnable() {
		return false;
	}

    /**
     * Set the CORS enabling.
     * @param value <code>true</code> to enable CORS.
     */
    public synchronized void setCORSEnabling(final boolean value) {
	}
}
