/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.digest;

import java.util.Calendar;
import java.util.Date;

/**
 * Defines criteria and additional information used for creating digests for topics. Posts of topics which satisfy
 * these criteria are only selected.
 */
public class DigestContext {

    private final Date startDate;
    private final Date endDate;
    private final int maxSize;
    private final DigestEventType digestEventType;

    /**
     * @param digestEventType DigestEvent.Type to be used in firing DigestEvent
     * @param maxSize Maximum number of posts to be included in digest
     */
    public DigestContext(final DigestEventType digestEventType, final int maxSize) {
        final Date currentDate = new Date();
        this.endDate = currentDate;
        final Calendar c = Calendar.getInstance();
        c.setTime(currentDate);
        c.add(digestEventType.getFieldType(), digestEventType.getInterval());
        this.startDate = c.getTime();
        this.maxSize = maxSize;
        this.digestEventType = digestEventType;
    }

    /**
     * @return Date after which posts added are included in digest.
     */
    public Date getStartDate() {
		return null;
	}

    /**
     * @return Date before which posts added are included in digest.
     */
    public Date getEndDate() {
		return null;
	}

    /**
     * @return Maximum number of posts included in digest.
     */
    public int getMaxSize() {
		return 0;
	}

    /**
     * @return Type of digest event.
     */
    public DigestEventType getDigestEventType() {
		return null;
	}
}
