/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.digest;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Dictionary;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.osgi.service.event.Event;

/**
 * Event fired when digest is created.
 */
public class DigestEvent extends Event implements Serializable {

    private static final long serialVersionUID = 1L;
    public static final String PROP_DIGEST_TOPIC_PATH = "digest.topic.path";
    public static final String PROP_DIGEST_TYPE = "digest.type";
    public static final String PROP_DIGEST_DATE_START = "digest.date.start";
    public static final String PROP_DIGEST_DATE_END = "digest.date.end";
    public static final String PROP_DIGEST_POSTS_COUNT = "digest.post.count";
    public static final String PROP_DIGEST_POSTS_PATHS = "digest.posts.paths";
    public static final String PROP_DIGEST_TOPICS_COUNT = "digest.topic.count";
    public static final String PROP_DIGEST_POSTS_PATHS_MAP = "digest.posts.paths.map";

    public DigestEvent(final String topic, final Dictionary<String, Object> properties) {
        super(topic, properties);
    }

    /**
     * This constructor should be used to create a Digest Event given an OSGi Event.
     * @param event an OSGi event that is known to be a digest event
     */
    public DigestEvent(final Event event) {
        super(event.getTopic(), buildPropertiesFromEvent(event));
    }

    private static Dictionary<String, Object> buildPropertiesFromEvent(final Event event) {
		return null;
	}

    /**
     * @return Digest Type of event
     */
    public DigestEventType getDigestType() {
		return null;
	}

    /**
     * @return absolute path of topic whose digest has been created
     */
    public String getTopicPath() {
		return null;
	}

    /**
     * @Deprecated
     * @see #getDigestPostsPathMap()
     * @return list of paths of digest posts in order
     */
    public List<String> getDigestPostsPaths() {
		return null;
	}

    /**
     * @return mapping of topics to paths of digest posts
     */
    public Map<String, List<String>> getDigestPostsPathMap() {
		return null;
	}

    /**
     * @return start date of digest.Posts added after startDate are only included in digest
     */
    public Date getDigestStartDate() {
		return null;
	}

    /**
     * @return end date of digest.Posts added after endDate are NOT included in digest.
     */
    public Date getDigestEndDate() {
		return null;
	}

    /**
     * @return number of posts contained in digest
     */
    public int getDigestPostCount() {
		return 0;
	}

    /**
     * @return number of topics contained in digest
     */
    public int getDigestTopicCount() {
		return 0;
	}

    /**
     * Retrieves the digest event from the given generic {@link org.osgi.service.event.Event}.
     * @param event The event.
     * @return The digest event or <code>null</code> if the given event is not a digest event.
     */
    public static DigestEvent fromEvent(final String topic, final Event event) {
		return null;
	}
}
