/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.digest;

/**
 * Provides digest creation functionality for generic commenting. By implementing this interface, running digest tasks
 * will execute <code>generate(DigestContext context)</code> on daily, weekly, fortnightly or monthly basis.
 * @since CQ 5.6.0
 */

public interface DigestService {
    /**
     * Generates digest for all topics. List of latest posts which satisfy criteria defined in context are chosen.
     * Digest event with digestEventType as defined in context are fired for digests created.
     * @param context The {@link DigestContext} used for creating digest
     */
    void generateDigest(DigestContext context) {
	}
}
