/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.index;

import java.util.Map;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;

import com.adobe.cq.social.ugc.api.UgcIndexProperty;

/**
 * An extension for extending existing search collection indices and adding extra index properties for nodes of the
 * specified resource type.
 */
public interface CommentSCIndexExtension {

    /**
     * Check the primary type and return true if the node belongs in this index.
     * @return true if the node belongs in this index.
     */
    boolean checkPrimaryType(String primaryType) {
		return false;
	}

    /**
     * Check the resource and return true if the node belongs in this index.
     * @return true if the node belongs in this index.
     */
    boolean checkResource(Resource resource) {
		return false;
	}

    /**
     * Given a node, return a map of UgcIndexProperties.
     * @param props the current extention properties to be indexed.
     * @param node the node being indexed.
     * @return a map of UgcIndexProperties.
     */
    Map<String, UgcIndexProperty> getUgcIndexProperties(Map<String, UgcIndexProperty> props,
        ResourceResolver resolver, Node node) throws RepositoryException {
		return null;
	}

    /**
     * Return the name of the index.
     * @return the name of the index.
     */
    String getName() {
		return null;
	}

    /**
     * Given a resource, return a context url.
     * @param resource the resource to process.
     * @param the context url for the given resource.
     */
    String getContextURL(Resource resource) {
		return null;
	}
}
