/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.moderation.api;

import java.util.List;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.commons.client.endpoints.Operation;
import com.adobe.cq.social.commons.client.endpoints.OperationExtension;
import com.adobe.cq.social.ugcbase.events.SocialEvent;

/**
 * Hook operation to enable clients register callback during an execution of an operation.
 */
public interface ModerationOperationExtension extends OperationExtension<Resource> {
    /**
     * Operation types.
     */
    public enum ModerationOperation implements Operation, SocialEvent.SocialActions {

        /** Deny operation. */
        DENY,
        /** Flag operation. */
        FLAG,
        /** Unflag operation. */
        UNFLAG,
        /** Allow operation. */
        ALLOW,
        /** Close operation. */
        CLOSE,
        /** Reopen (reverse of Close operation). */
        REOPEN
    };

    /**
     * Get the list of operations that this operation extension is interested in.
     * @return a list of {@link ModerationOperation}
     */
    @Override
    List<Operation> getOperationsToHookInto() {
		return null;
	}
}
