/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.notification;

import java.util.HashMap;
import java.util.Map;

import javax.jcr.Session;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.ToggleUtil;
import com.day.cq.security.Authorizable;
import com.day.cq.workflow.WorkflowException;
import com.day.cq.workflow.WorkflowService;
import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.exec.Workflow;
import com.day.cq.workflow.exec.WorkflowData;
import com.day.cq.workflow.model.WorkflowModel;

/**
 *
 */
public abstract class AbstractSubscribable implements Subscribable {

    private final WorkflowService workflowService;

    private static final Logger LOG = LoggerFactory.getLogger(AbstractSubscribable.class);

    /**
     * @param service {@link WorkflowService}
     */
    protected AbstractSubscribable(final WorkflowService service) {
        this.workflowService = service;
    }

    /**
     * Starts workflow to subscribe the passed user to this subscribable.
     * @param authorizable subscribing user.
     * @param workflowModel Name of the subscription workflow model.
     * @param session {@link Session} to initiate the workflow with.
     * @param dataPath Workflow data item ath.
     * @return {@link Workflow} instance created, null otherwise.
     * @throws WorkflowException exception starting workflow.
     */
    protected Workflow startWorkflow(final Authorizable authorizable, final String workflowModel,
        final Session session, final String dataPath) throws WorkflowException {
			return null;
		}
}
