/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.notification;

import org.apache.sling.api.resource.ValueMap;

/**
 * Subscription details of a single subscription entry.
 */
public interface SubscriptionEntryDetail {

    /**
     * enum which defines rules of subscription entry.
     */
    enum SubscriptionEntryRule {
        /**
         * if the entry has allow as true.
         */
        ALLOW,
        /**
         * if entry has allow as false.
         */
        DENY,
    }

    /**
     * Get subscription channel.
     * @return returns channel.
     */
    String getChannel() {
		return null;
	}

    /**
     * Get subscription actions.
     * @return actions.
     */
    Iterable<String> getActions() {
		return null;
	}

    /**
     * Get subscription type.
     * @return type.
     */
    String getType() {
		return null;
	}

    /**
     * Get subscription entry path.
     * @return path
     */
    String getPath() {
		return null;
	}

    /**
     * Is subscription entry exact or tree.
     * @return true if exact, false otherwise.
     */
    boolean isExact() {
		return false;
	}

    /**
     * get subscription entry rule.
     * @return rule.
     */
    SubscriptionEntryRule getRule() {
		return null;
	}

    /**
     * @return {@link ValueMap} of the parent node.
     */
    ValueMap getParentConfiguration() {
		return null;
	}

}
