/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.ugc;

import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.sling.api.resource.Resource;

import com.day.cq.replication.ReplicationException;
import com.day.cq.replication.Replicator;

/**
 * Implement this interface to support delete within the moderation UI.
 */
public interface DeleteExtension {

    /**
     * @return name of extension.
     */
    public String getName() {
		return null;
	}

    /**
     * Return true if the given resource is a match and this extension should be used to delete it.
     * @param resource the resource to check.
     * @return true if the given resource is a match and this extension should be used to produce the reply node.
     */
    public boolean checkResourceType(Resource resource) {
		return false;
	}

    /**
     * Delete the given resource.
     * @param target the resource to delete.
     * @param replicator the Replicator used to forward replicate the deletes.
     * @param session the session used for replication.
     */
    public void delete(Resource target, Replicator replicator, Session session) throws RepositoryException,
        ReplicationException {
	}

}
