/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.commons.ugc;

import javax.jcr.Node;

import org.apache.sling.api.resource.Resource;

import com.adobe.granite.security.user.UserProperties;

/**
 * Implement this interface to support replies to specified content types within the moderation UI.
 */
public interface ReplyExtension {

    /**
     * @return name of extension.
     */
    public String getName() {
		return null;
	}

    /**
     * Return true if the given resource is a match and this extension should be used to produce the reply node.
     * @param resource the resource to check.
     * @return true if the given resource is a match and this extension should be used to produce the reply node.
     */
    public boolean checkResourceType(Resource resource) {
		return false;
	}

    /**
     * Given the author and message, create a reply.
     * @param authorId the id of the author.
     * @param authorUserProperties the userProperties of the author.
     * @param target the target resource to reply to.
     * @param message the reply message.
     * @return the new reply node.
     */
    public Node createReply(Resource target, String authorId, UserProperties authorUserProperties, String message) {
		return null;
	}

}
