/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.forum.api;

import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.activation.DataSource;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.granite.security.user.UserProperties;
import com.day.cq.security.Authorizable;
import com.day.cq.security.profile.Profile;
import com.day.cq.tagging.Tag;

/**
 * The abstract class that implements <code>Post</code> interface specifies the contract for a forum post.
 * @deprecated Use {link {@link com.adobe.cq.social.forum.client.api.AbstractPost} instead
 */
@Deprecated
public abstract class AbstractPost implements Post {

    /**
     * {@inheritDoc}
     */
    @Override
    public Date getCreated() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ForumUser getCreatedBy() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Date getModified() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ForumUser getModifiedBy() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Date getSelfModified() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ForumUser getSelfModifiedBy() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getId() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getLimit() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getPath() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getParentRelativePath() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post getTopic() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post getParent() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isPinned() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isTopic() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Iterator<Post> getPosts() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Post> getPosts(final int page) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Post> getPosts(final int page, final SlingHttpServletRequest request) throws RepositoryException {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ValueMap getProperties() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getRepliesCount() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getRepliesCount(final SlingHttpServletRequest request) {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getUrl() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getUrl(final int pageIndex, final boolean includePostId, final boolean includeTopicBucketId) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getUrl(final boolean withPageIndex) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Forum getForum() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Post> getPosts(final int offset, final int limit) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Post> getPosts(final int offset, final int limit, final boolean sortDateDescending) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post getLatestPost() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void subscribe(final Authorizable authorizable) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void subscribe(final Authorizable authorizable, final String workflowModel) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void subscribe(final Authorizable authorizable, final String workflowModel, final Session session) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void unsubscribe(final Authorizable authorizable) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void unsubscribe(final Authorizable authorizable, final String workflowModel) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void unsubscribe(final Authorizable authorizable, final String workflowModel, final Session session) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isSubscribed(final Authorizable authorizable) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Tag[] getTags() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getNumberOfParticipants() {
		return 0;
	}

    /**
     * {@inheritDoc}
     * @deprecated Use {@link #getUserProperties()} instead.
     */
    @Deprecated
    @Override
    public Profile getProfile() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public UserProperties getUserProperties() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getPageIndex() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getUrl(final int index) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post getPost(final String id) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isSpam() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isModerated() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isClosed() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isApproved() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post addPost(final ResourceResolver resourceResolver, final Post post) throws ForumException {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Post addPost(final ResourceResolver resourceResolver, final Post post,
        final List<DataSource> fileAttachments) throws ForumException {
			return null;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getMessage() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getSubject() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getTagsAsString() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public void setLatestPost(final Post post) {
	}

    /**
     * {@inheritDoc}
     */
    public void setRepliesCount(final int count) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getNumberOfPages() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getIndex() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getDefaultTopicResourceType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getDefaultPostResourceType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Resource getResource() {
		return null;
	}

    @Override
    public void subscribe(final Authorizable authorizable, final String workflowModel,
        final ResourceResolver resourceResolver) {
		}

    @Override
    public void unsubscribe(final Authorizable authorizable, final String workflowModel,
        final ResourceResolver resourceResolver) {
		}

    @Override
    public String getSubscriptionPath() {
		return null;
	}
}
