/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.forum.api;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.commons.digest.DigestEventType;
import com.day.cq.security.Authorizable;

/**
 * Provides forum topic digest subscription service
 */
public interface ForumDigestSubscriptionService {

    /**
     * Subscription type constant for forum digest subscription.
     */
    public static final String TYPE = "forumdigest";

    public static final String SELECTOR_FORUM_DIGEST_TYPE = "socialforumdigest";

    public DigestEventType getDigestSubscriptionType(final Resource resource, final Authorizable authorizable) {
		return null;
	}

    /**
     * Gets the digest subscription type.
     * @param topic the topic
     * @param authorizable the authorizable
     * @return the digest subscription type
     */
    public DigestEventType getDigestSubscriptionType(final com.adobe.cq.social.forum.client.api.Post topic,
        final Authorizable authorizable) {
		return null;
	}

    /**
     * Gets the digest subscription type.
     * @param forum the forum
     * @param authorizable the authorizable
     * @return the digest subscription type
     */
    public DigestEventType getDigestSubscriptionType(final com.adobe.cq.social.forum.client.api.Forum forum,
        final Authorizable authorizable) {
		return null;
	}

    /**
     * A method to get the current type of forum digest subscription a user has for a topic
     * @param topic The topic
     * @param authorizable User Authorizable instance
     * @return type of forum digest subscription the user has
     */
    public DigestEventType getDigestSubscriptionType(final com.adobe.cq.social.forum.api.Post topic,
        final Authorizable authorizable) {
		return null;
	}

    /**
     * A method to check if user has a forum digest subscription of a specific type.
     * @param topic The topic
     * @param type The ForumDigestEvent.Type
     * @param authorizable User Authorizable instance
     * @return true if user is subscribed else false
     */
    public boolean isSubscribed(com.adobe.cq.social.forum.api.Post topic, DigestEventType type,
        Authorizable authorizable) {
		return false;
	}

    /**
     * A method to subscribe a user to a forum digest event.
     * <p/>
     * @param topic topic to be subscribed to
     * @param type ForumDigestEvent.Type to be subscribed to
     * @param authorizable user who will be subscribed.
     * @throws ForumException thrown if any error occurred during subscribing
     */
    public void subscribe(com.adobe.cq.social.forum.api.Post topic, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * A method to unsubscribe a user from a forum event.
     * @param topic topic to unsubscribe from
     * @param type ForumDigestEvent.Type to unsubscribe from
     * @param authorizable user who will be unsubscribed
     * @throws ForumException thrown if any error occurred during un subscribing
     */
    public void unsubscribe(com.adobe.cq.social.forum.api.Post topic, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * A method to subscribe a user to a forum digest event.
     * <p/>
     * @param topic topic to be subscribed to
     * @param type ForumDigestEvent.Type to be subscribed to
     * @param authorizable user who will be subscribed.
     * @throws ForumException thrown if any error occurred during subscribing
     */
    public void subscribe(com.adobe.cq.social.forum.client.api.Post topic, DigestEventType type,
        Authorizable authorizable) throws ForumException {
	}

    /**
     * A method to unsubscribe a user from a forum event.
     * @param topic topic to unsubscribe from
     * @param type ForumDigestEvent.Type to unsubscribe from
     * @param authorizable user who will be unsubscribed
     * @throws ForumException thrown if any error occurred during un subscribing
     */
    public void unsubscribe(com.adobe.cq.social.forum.client.api.Post topic, DigestEventType type,
        Authorizable authorizable) throws ForumException {
	}

    /**
     * A method to get the current type of forum digest subscription a user has for a {@link Forum}.
     * @param forum The {@link Forum}
     * @param authorizable User Authorizable instance
     * @return type of forum digest subscription the user has
     */
    DigestEventType getDigestSubscriptionType(com.adobe.cq.social.forum.api.Forum forum, Authorizable authorizable) {
		return null;
	}

    /**
     * A method to check if user has a forum digest subscription of a specific type for a {@link Forum}.
     * @param forum The {@link Forum}
     * @param type The {@link DigestEventType}
     * @param authorizable User Authorizable instance
     * @return true if user is subscribed, false otherwise.
     */
    boolean isSubscribed(com.adobe.cq.social.forum.api.Forum forum, DigestEventType type, Authorizable authorizable) {
		return false;
	}

    /**
     * Checks if is subscribed.
     * @param path the path
     * @param authorizable the authorizable
     * @return true, if is subscribed
     */
    boolean isSubscribed(String path, Authorizable authorizable) {
		return false;
	}

    /**
     * A method to subscribe a user to a forum digest event.
     * <p/>
     * @param forum {@link Forum} to be subscribed to
     * @param type {@link DigestEventType} to be subscribed to
     * @param authorizable user who will be subscribed.
     * @throws ForumException thrown if any error occurred during subscribing
     */
    void subscribe(com.adobe.cq.social.forum.api.Forum forum, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * A method to unsubscribe a user from a digest event.
     * @param forum {@link Forum} to unsubscribe from
     * @param type {@link DigestEventType} to unsubscribe from
     * @param authorizable user who will be unsubscribed
     * @throws ForumException thrown if any error occurred during un subscribing
     */
    void unsubscribe(com.adobe.cq.social.forum.api.Forum forum, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * A method to subscribe a user to a forum digest event.
     * <p/>
     * @param forum {@link Forum} to be subscribed to
     * @param type {@link DigestEventType} to be subscribed to
     * @param authorizable user who will be subscribed.
     * @throws ForumException thrown if any error occurred during subscribing
     */
    void subscribe(com.adobe.cq.social.forum.client.api.Forum forum, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * A method to unsubscribe a user from a digest event.
     * @param forum {@link Forum} to unsubscribe from
     * @param type {@link DigestEventType} to unsubscribe from
     * @param authorizable user who will be unsubscribed
     * @throws ForumException thrown if any error occurred during un subscribing
     */
    void unsubscribe(com.adobe.cq.social.forum.client.api.Forum forum, DigestEventType type, Authorizable authorizable)
        throws ForumException {
	}

    /**
     * Checks if is subscribed.
     * @param forum the forum
     * @param type the type
     * @param authorizable the authorizable
     * @return true, if is subscribed
     */
    boolean isSubscribed(com.adobe.cq.social.forum.client.api.Forum forum, DigestEventType type,
        Authorizable authorizable) {
		return false;
	}

    /**
     * Checks if is subscribed.
     * @param topic the topic
     * @param type the type
     * @param authorizable the authorizable
     * @return true, if is subscribed
     */
    boolean isSubscribed(com.adobe.cq.social.forum.client.api.Post topic, DigestEventType type,
        Authorizable authorizable) {
		return false;
	}

    /**
     * Subscribe.
     * @param resource the resource
     * @param type the type
     * @param authorizable the authorizable
     */
    void subscribe(Resource resource, DigestEventType type, Authorizable authorizable) {
	}

    /**
     * Unsubscribe.
     * @param resource the resource
     * @param type the type
     * @param authorizable the authorizable
     * @throws ForumException the forum exception
     */
    void unsubscribe(Resource resource, DigestEventType type, Authorizable authorizable) throws ForumException {
	}
}
