/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.forum.api;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.jcr.RepositoryException;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.ConfigurationPolicy;
import org.apache.felix.scr.annotations.Reference;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.forum.impl.RelatedUgcNodeIndexerExtension;
import com.adobe.cq.social.ugc.api.RelatedSearch;
import com.adobe.cq.social.ugcbase.SocialResource;
import com.adobe.cq.social.ugcbase.SocialResourceProvider;
import com.adobe.cq.social.ugcbase.SocialResourceUtils;
import com.adobe.cq.social.ugcbase.SocialUtils;
import com.day.cq.wcm.api.PageManagerFactory;
import com.day.cq.wcm.webservicesupport.Configuration;
import com.day.cq.wcm.webservicesupport.ConfigurationManager;

/**
 * Utility methods for performing related search.
 */
@Component(metatype = true, immediate = true, policy = ConfigurationPolicy.OPTIONAL,
        label = "%relatedSearchUtil.name", description = "%relatedSearchUtil.description")
public class RelatedSearchUtil {

    /**
     * Logger.
     */
    private static Logger log = LoggerFactory.getLogger(RelatedSearchUtil.class);

    /**
     * The Page Manager Factory.
     */
    @Reference
    private PageManagerFactory pageManagerFactory;

    /**
     * The Configuration Manager.
     */
    @Reference
    private ConfigurationManager configManager;

    /**
     * Related search.
     */
    @Reference
    private RelatedSearch relatedSearch;

    /**
     * Social Utils Service
     */
    @Reference
    private SocialUtils socialUtils;
    private static SocialUtils staticSocialUtils;

    /**
     * Static related search.
     */
    private static RelatedSearch relatedSearchStatic;

    /**
     * Static page manager factory.
     */
    private static PageManagerFactory pageManagerFactoryStatic;

    /**
     * Static configuration manager.
     */
    private static ConfigurationManager configManagerStatic;

    /**
     * Activate the component <code>RelatedSearch</code>.
     * @param context The ODGi Component context
     */
    protected final void activate(final ComponentContext context) {
	}

    /**
     * Deactivate the component <code>RelatedSearch</code>.
     * @param context The ODGi Component context
     */
    protected final void deactivate(final ComponentContext context) {
	}

    /**
     * Return a list of related posts, given a query.
     * @param resolver The resource resolver.
     * @param query The string to search for.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component we want to search on.
     * @param mltFields Node properties to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents.
     * @throws RepositoryException - thrown if there is error accessing repository.
     */
    public static List<Post> getRelatedPosts(final ResourceResolver resolver, final String query,
        final String resourceTypeFilter, final String componentFilter, final String[] mltFields,
        final int maxResults, final int minTermFreq, final int minDocFreq) throws RepositoryException {
			return null;
		}

    /**
     * Return a list of related posts, given a query.
     * @param resolver The resource resolver.
     * @param query The string to search for.
     * @param statusFilter The filter on the status.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component we want to search on.
     * @param mltFields Node properties to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents.
     * @throws RepositoryException - thrown if there is error accessing repository.
     */
    public static List<Post> getRelatedPosts(final ResourceResolver resolver, final String query,
        final String statusFilter, final String resourceTypeFilter, final String componentFilter,
        final String[] mltFields, final int maxResults, final int minTermFreq, final int minDocFreq)
        throws RepositoryException {
			return null;
		}

    /**
     * This method returns a SocialResourceProvider for the given Resource.
     * @param res - A Social Resource
     * @return Return a SocialResourceProvider, or null if none exists
     */
    private static SocialResourceProvider getSocialResourceProvider(final Resource res) {
		return null;
	}
}
