/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.group.api;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.jcr.api.SlingRepository;

import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.WCMException;
import com.day.cq.wcm.msm.api.RolloutManager;

/**
 * <code>GroupMSMService</code> provides a service managing MSM rollouts.
 */
public interface GroupMSMService {

    /**
     * Create a live copy from the blueprint. Returns the master page of the live copy.
     * @param repository sling repository.
     * @param resolver resource resolver.
     * @param rolloutMgr rollout manager.
     * @param liveCopyName live copy node name.
     * @param liveCopyTitle live copy page title.
     * @param bluePrintPath blue print site path.
     * @param liveCopyPath live copy site path.
     * @param properties live copy properties.
     * @return the master page of the live copy.
     * @throws GroupException - thrown if unable to create a live copy.
     * @throws RepositoryException - thrown if unable to create a live copy.
     * @throws WCMException - thrown if unable to create a live copy.
     */
    Page createLiveCopy(SlingRepository repository, ResourceResolver resolver, RolloutManager rolloutMgr,
        String liveCopyName, String liveCopyTitle, String bluePrintPath, String liveCopyPath, ValueMap properties)
        throws GroupException, RepositoryException, WCMException {
		return null;
	}

}
