/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.group.api;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.granite.security.user.UserProperties;
import com.adobe.granite.security.user.UserPropertiesManager;
import com.adobe.granite.security.user.UserPropertiesService;
import com.adobe.granite.socialgraph.Direction;
import com.adobe.granite.socialgraph.GraphNode;
import com.adobe.granite.socialgraph.Relationship;
import com.adobe.granite.socialgraph.SocialGraph;
import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.PageManager;

/**
 * <code>GroupUtil</code> provides various methods managing community groups.
 */
public class GroupUtil {

    private static final Logger log = LoggerFactory.getLogger(GroupUtil.class);

    /**
     * Validate if a community group name is unique.
     * @param resolver resource resolver.
     * @param name community group name.
     * @param groupRoot community group site path.
     * @return <code>true</code> if a community group name is unique.
     */
    public static boolean validateGroupName(final ResourceResolver resolver, final String name, final String groupRoot) {
		return false;
	}

    /**
     * Returns the number of the group members.
     * @param userPropertiesService user properties service.
     * @param resourceResolver resource resolver.
     * @param groupId group id.
     * @return Number of the members of this Group. This includes both declared members and all authorizables that are
     *         indirect group members.
     */
    public static int getNumberOfMembers(final UserPropertiesService userPropertiesService,
        final ResourceResolver resourceResolver, final String groupId) {
			return 0;
		}

    /**
     * Returns a iterator of UserProperties for the group members.
     * @param userPropertiesService user properties service.
     * @param resourceResolver resource resolver.
     * @param groupId group id.
     * @return Iterator of UserProperties which are members of this Group. This includes both declared members and all
     *         authorizables that are indirect group members.
     */
    public static Iterator<UserProperties> getMembers(final UserPropertiesService userPropertiesService,
        final ResourceResolver resourceResolver, final String groupId) {
			return null;
		}

    /**
     * Returns true if an authorizable is a group member.
     * @param userPropertiesService user properties service.
     * @param resourceResolver resource resolver.
     * @param authId authorizable id.
     * @param groupId group id.
     * @return <code>true</code> if an authorizable is a group member.
     */
    public static boolean isMember(final UserPropertiesService userPropertiesService,
        final ResourceResolver resourceResolver, final String authId, final String groupId) {
			return false;
		}

    /**
     * Establish Social Graph relations of the group members.
     * @param userPropertiesService user properties service.
     * @param resourceResolver resource resolver.
     * @param groupId group id.
     * @return List of UserProperties which are members of this Group. This includes both declared members and all
     *         authorizables that are indirect group members.
     */
    private static List<UserProperties> establishMemberRelation(final UserPropertiesService userPropertiesService,
        final ResourceResolver resourceResolver, final String groupId) {
			return null;
		}

    /**
     * Get a community page that contains the target path.
     * @param resourceResolver resource resolver.
     * @param targetPath target path.
     * @return community page path.
     */
    public static String getCommunityRootPagePath(final ResourceResolver resolver, final String targetPath) {
		return null;
	}

    /**
     * Get all member group IDs of the user. If the given userID is empty, get the logged in user ID.
     * @param resourceResolver resource resolver.
     * @param userID user ID.
     * @return List of member group IDs of the user.
     */
    public static List<String> getAllMemberGroups(final ResourceResolver resourceResolver, final String userID) {
		return null;
	}

    /**
     * Get all component of given resource type in the users member communities. If the given userID is empty, get the
     * logged in user ID.
     * @param resourceResolver resource resolver.
     * @param rootPath community root path.
     * @param componentType component's resource type.
     * @param userID user ID.
     * @return List of calendar paths that are accessible for the user.
     */
    public static List<String> getComponentsInMemberCommunities(final ResourceResolver resourceResolver,
        final String rootPath, final String componentType, final String userID) {
			return null;
		}

}
