/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import javax.script.ScriptEngine;

import org.apache.felix.scr.annotations.Activate;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.scripting.api.AbstractScriptEngineFactory;
import org.osgi.service.component.ComponentContext;

import com.adobe.cq.social.commons.client.api.BaseSocialComponent;
import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.commons.client.api.ClientUtilityFactory;
import com.adobe.cq.social.commons.client.api.SocialComponent;
import com.adobe.cq.social.commons.client.api.SocialComponentFactory;
import com.adobe.cq.social.commons.client.api.SocialComponentFactoryManager;
import com.adobe.cq.social.handlebars.api.TemplateHelpersService;
import com.adobe.cq.social.ugcbase.SocialUtils;
import com.adobe.granite.xss.XSSAPI;
import com.github.jknack.handlebars.Handlebars;

/**
 * A factory for creating HandlebarsScriptingEngine objects.
 */
@Component
@Service
public class HandlebarsScriptingEngineFactory extends AbstractScriptEngineFactory {

    /** The Constant SCRIPT_EXTENSIONS defining the script extensions that it can process. */
    public static final String[] SCRIPT_EXTENSIONS = {"hbs"};

    /** The Constant HANDLEBARS used to perform Handlebar lib operations. */
    public static final Handlebars HANDLEBARS = new Handlebars();// .with(new HighConcurrencyTemplateCache());

    @Reference
    protected TemplateHelpersService templateHelperService;

    /** The SocialComponentFactoryManager srf. */
    @Reference
    protected SocialComponentFactoryManager srf;

    /** The ResourceResolverFactory rrf. */
    @Reference
    private ResourceResolverFactory rrf;

    @Reference
    private SocialUtils socialUtils;

    /** The xss api. */
    @Reference
    private XSSAPI xssAPI;

    /** The template context provider service. */
    @Reference
    private TemplateContextProviderService contextProviderService;

    @Reference
    private ClientUtilityFactory clientUtilFactory;
    /** The admin resolver. */
    private ResourceResolver adminResolver;

    /**
     * Instantiates a new handlebars scripting engine factory.
     */
    public HandlebarsScriptingEngineFactory() {
        super();
        setEngineVersion(getLanguageVersion());

        setExtensions(SCRIPT_EXTENSIONS);
        setNames("handlebars");
    }

    /**
     * Activate.
     * @param context the context
     * @throws LoginException the login exception
     */
    @Activate
    protected void activate(final ComponentContext context) throws LoginException {
	}

    /**
     * @see javax.script.ScriptEngineFactory#getLanguageName().
     * @return The language name served by the servicing engine.
     */
    @Override
    public String getLanguageName() {
		return null;
	}

    /**
     * @see javax.script.ScriptEngineFactory#getLanguageVersion().
     * @return Version of the HBS engine
     */
    @Override
    public String getLanguageVersion() {
		return null;
	}

    /**
     * @see javax.script.ScriptEngineFactory#getScriptEngine()
     * @return The HandlebarsScriptingEngine
     */
    @Override
    public ScriptEngine getScriptEngine() {
		return null;
	}

    /**
     * Gets the social component for resource.
     * @param resource Resource parameter
     * @param request The SlingHttpServletRequest
     * @return r the social component <code>SocialComponent</code>
     */
    protected SocialComponent getSocialComponentForResource(final Resource resource,
        final SlingHttpServletRequest request) {
			return null;
		}

    /**
     * Gets the context provider service.
     * @return The templates context provider service
     */
    protected TemplateContextProviderService getContextProviderService() {
		return null;
	}

    public TemplateHelpersService getTemplateHelperService() {
		return null;
	}

}
