/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;

import org.apache.commons.lang3.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.handlebars.api.TemplateContextProvider;
import com.adobe.cq.social.handlebars.api.TemplateHelpersService;
import com.day.cq.wcm.api.WCMMode;
import com.github.jknack.handlebars.Context;
import com.github.jknack.handlebars.Handlebars;
import com.github.jknack.handlebars.Handlebars.SafeString;
import com.github.jknack.handlebars.Helper;
import com.github.jknack.handlebars.Options;
import com.github.jknack.handlebars.Template;
import com.github.jknack.handlebars.context.MapValueResolver;
import com.github.jknack.handlebars.io.TemplateSource;

/**
 * The Class IncludeHelper.
 */
public class IncludeHelper implements Helper<Object> {

    /** The Constant PATH. */
    private static final String PATH = "path";

    /** The Constant RESOURCE_TYPE. */
    private static final String RESOURCE_TYPE = "resourceType";

    /** The Constant TEMPLATE. */
    private static final String TEMPLATE = "template";

    /** The Constant AUTHORING_DISABLED. */
    private static final String AUTHORING_DISABLED = "authoringDisabled";

    /** The Constant SEPARATOR. */
    private static final String SEPARATOR = "/";

    /** The Constant ID. */
    private static final String ID = "id";

    /** The Constant LOG. */
    private static final Logger LOG = LoggerFactory.getLogger(IncludeHelper.class);

    public static final String name = "include";

    /** The resolver. */
    private final ResourceResolver resolver;

    private final TemplateContextProviderService contextProviderService;

    /**
     * Instantiates a new include helper.
     * @param request the request
     * @param response the response
     * @param adminResolver a handle to an admin resource resolver to search for scripts
     * @throws NoSuchMethodException the no such method exception
     */
    public IncludeHelper(final ResourceResolver adminResolver,
        final TemplateContextProviderService contextProviderService) throws NoSuchMethodException {
        this.resolver = adminResolver;
        this.contextProviderService = contextProviderService;
    }

    /**
     * Include.
     * @param context the context
     * @param options the options
     * @return the safe string
     * @throws IOException Signals that an I/O exception has occurred.
     * @throws ServletException the servlet exception
     */
    private SafeString include(final String context, final Options options) throws IOException, ServletException {
		return null;
	}

    /**
     * Include.
     * @param context the context
     * @param options the options
     * @return the safe string
     * @throws IOException Signals that an I/O exception has occurred.
     * @throws NoSuchMethodException the no such method exception
     * @throws ServletException the servlet exception
     */
    private SafeString include(final Map<String, Object> context, final Options options) throws IOException,
        ServletException {
			return null;
		}

    @SuppressWarnings("unchecked")
    @Override
    public CharSequence apply(final Object context, final Options options) throws IOException {
		return null;
	}
}
