/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

import org.apache.commons.io.IOUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestDispatcherOptions;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.SyntheticResource;
import org.apache.sling.api.wrappers.SlingHttpServletRequestWrapper;

/**
 * The Class SlingIncludeHelper.
 */
public class SlingIncludeHelper {

    /** The request. */
    private final SlingHttpServletRequest request;

    /** The response. */
    private final SlingHttpServletResponse response;

    /**
     * Instantiates a new sling include helper.
     * @param request the request
     * @param response the response
     * @param resource the resource
     */
    public SlingIncludeHelper(final SlingHttpServletRequest request, final SlingHttpServletResponse response) {
        this.request = request;
        this.response = response;
    }

    /**
     * Sling include.
     * @param resourcePath the resource path
     * @param resourceType the resource type
     * @param selector the selector
     * @return the string
     * @throws ServletException the servlet exception
     * @throws IOException Signals that an I/O exception has occurred.
     */
    public String slingInclude(final String resourcePath, final String resourceType, final String selector)
        throws ServletException, IOException {
			return null;
		}

    /**
     * Extends the HttpServletResponse to wrap the response and capture the results.
     */
    private static final class CaptureResponseWrapper extends HttpServletResponseWrapper {

        /** The encoding. */
        private final String encoding;

        /** The ops. */
        private final ServletOutputStream ops;

        /** The is binary response. */
        private boolean isBinaryResponse = false;

        /** The writer. */
        private PrintWriter writer = null;

        /**
         * Construct a new CaptureResponseWrapper.
         * @param response the response to wrap
         * @param ops the output stream to write to
         */
        CaptureResponseWrapper(final HttpServletResponse response, final ServletOutputStream ops) {
            super(response);
            this.encoding = response.getCharacterEncoding();
            this.ops = ops;
        }

        /**
         * Returns true if the response is binary.
         * @return true, if is binary response
         */
        public boolean isBinaryResponse() {
			return false;
		}

        /*
         * (non-Javadoc)
         * @see javax.servlet.ServletResponseWrapper#flushBuffer()
         */
        @Override
        public void flushBuffer() throws IOException {
		}

        /*
         * (non-Javadoc)
         * @see javax.servlet.ServletResponseWrapper#getOutputStream()
         */
        @Override
        public ServletOutputStream getOutputStream() throws IOException {
			return null;
		}

        /*
         * (non-Javadoc)
         * @see javax.servlet.ServletResponseWrapper#getWriter()
         */
        @Override
        public PrintWriter getWriter() throws IOException {
			return null;
		}

    }

    /**
     * Extends the ServletOutputStream to capture the results into a byte array.
     */
    private static final class BufferedServletOutputStream extends ServletOutputStream {

        /** The baops. */
        private final ByteArrayOutputStream baops = new ByteArrayOutputStream();

        /** The encoding. */
        private final String encoding;

        /**
         * Constructs a new BufferedServletOutputStream.
         * @param encoding the encoding string
         */
        public BufferedServletOutputStream(final String encoding) {
            this.encoding = encoding;
        }

        /**
         * Gets the byte buffer as a string.
         * @return the byte buffer
         * @throws IOException Signals that an I/O exception has occurred.
         */
        public String getBuffer() throws IOException {
			return null;
		}

        /*
         * (non-Javadoc)
         * @see java.io.OutputStream#close()
         */
        @Override
        public void close() throws IOException {
		}

        /*
         * (non-Javadoc)
         * @see java.io.OutputStream#write(int)
         */
        @Override
        public void write(final int b) throws IOException {
		}

    }
}
