/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.handlebars;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestDispatcherOptions;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.servlets.SlingSafeMethodsServlet;
import org.apache.sling.api.wrappers.SlingHttpServletRequestWrapper;

import com.adobe.granite.xss.XSSAPI;

/**
 * This servlet helps handle sling:includes that are involed during client side rendering.
 */
@Component
@Service
@Properties({@Property(name = "sling.servlet.paths", value = "/services/social/includehelper")})
public class SlingIncludeServlet extends SlingSafeMethodsServlet {

    private static final String SELECTOR = "selector";

    private static final String RESOURCE_TYPE = "resourceType";

    private static final String RESOURCE_PATH = "resourcePath";

    /** The Constant CONTENT_TYPE. */
    protected static final String CONTENT_TYPE = "application/json";

    /** The Constant ENCODING. */
    protected static final String ENCODING = "utf-8";

    /** The Constant DEFAULT_TIDY. */
    protected static final Boolean DEFAULT_TIDY = Boolean.FALSE;

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** The xss. */
    @Reference
    private XSSAPI xss;

    /*
     * (non-Javadoc)
     * @see org.apache.sling.api.servlets.SlingSafeMethodsServlet#doGet(org.apache.sling.api.SlingHttpServletRequest,
     * org.apache.sling.api.SlingHttpServletResponse)
     */
    @Override
    protected void doGet(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}
}
