/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.felix.scr.annotations.Activate;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Deactivate;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferenceCardinality;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.osgi.service.component.ComponentContext;

import com.adobe.cq.social.handlebars.api.TemplateContextProvider;

/**
 * The Class TemplateContextProviderServiceImpl.
 */
@Component(label = "Template Context Provider Factory", description = "Template Context Provider Factory",
        metatype = true)
@Service(value = TemplateContextProviderService.class)
@Reference(name = "templateContextProviders", referenceInterface = TemplateContextProvider.class,
        cardinality = ReferenceCardinality.OPTIONAL_MULTIPLE, policy = ReferencePolicy.DYNAMIC,
        bind = "bindTemplateContextProviders", unbind = "unbindTemplateContextProviders")
public class TemplateContextProviderServiceImpl implements TemplateContextProviderService {

    /** The context. */
    private ComponentContext context;

    /** The bound providers. */
    private final List<TemplateContextProvider> boundProviders = new LinkedList<TemplateContextProvider>();

    /** The providers. */
    private final Map<String, List<TemplateContextProvider>> providers = Collections
        .synchronizedMap(new HashMap<String, List<TemplateContextProvider>>());

    /**
     * Gets the providers.
     * @param resourceType the resource type
     * @return the providers
     */
    @Override
    public List<TemplateContextProvider> getProviders(final String resourceType) {
		return null;
	}

    /**
     * Adds the provider.
     * @param provider the provider
     */
    public void addProvider(final TemplateContextProvider provider) {
	}

    /**
     * Removes the provider.
     * @param provider the provider
     */
    public void removeProvider(final TemplateContextProvider provider) {
	}

    /**
     * Activate.
     * @param componentContext the component context
     */
    @Activate
    protected void activate(final ComponentContext componentContext) {
	}

    /**
     * Deactivate.
     * @param componentContext the component context
     */
    @Deactivate
    protected void deactivate(final ComponentContext componentContext) {
	}

    /**
     * Unbind template context providers.
     * @param provider the provider
     */
    protected void unbindTemplateContextProviders(final TemplateContextProvider provider) {
	}

    /**
     * Bind template context providers.
     * @param provider the provider
     */
    protected void bindTemplateContextProviders(final TemplateContextProvider provider) {
	}
}
