/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.handlebars;

import java.util.HashSet;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Set;

import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;

/**
 * Iterator that lists possible locations for finding a template given a resource type. Mostly duplicated from Slings
 * org.apache.sling.servlets.resolver.internal.helper.LocationIterator.
 */
public class TemplateLocationIterator implements Iterator<String> {

    // The resource for which this iterator is created. This resource
    // gives the initial resource type and the first resource super type
    // private final Resource resource;

    // The resource resolver used to find resource super types of
    // resource types
    private final ResourceResolver resolver;

    // The search path of the resource resolver
    private final String[] searchPath;

    // counter into the search path array
    private int pathCounter;

    // The resource type to use for the next iteration loop
    private String resourceType;

    // The current relative path generated from the resource type
    private String relPath;

    // the next absolute path to return from next(). This is null
    // if there is no more location to return
    private String nextLocation;

    /** Set of used resource types to detect a circular resource type hierarchy. */
    private final Set<String> usedResourceTypes = new HashSet<String>();

    /**
     * Creates an instance of this iterator starting with a location built from the resource type of the
     * <code>resource</code>.
     * @param resourceType the initial resource type.
     * @param resolver The resource resolver
     */
    public TemplateLocationIterator(final String resourceType, final ResourceResolver resolver) {
        this.resolver = resolver;

        String[] tmpPath = resolver.getSearchPath();
        if (tmpPath == null || tmpPath.length == 0) {
            tmpPath = new String[]{"/"};
        }
        this.searchPath = tmpPath;

        // we start with the first resource type
        this.resourceType = resourceType;

        this.usedResourceTypes.add(this.resourceType);

        this.nextLocation = this.seek();
    }

    /**
     * Returns <code>true</code> if there is another entry
     */
    @Override
    public boolean hasNext() {
		return false;
	}

    /**
     * Returns the next entry of this iterator.
     * @throws NoSuchElementException if {@link #hasNext()} returns <code>false</code>.
     */
    @Override
    public String next() {
		return null;
	}

    /**
     * @throws UnsupportedOperationException
     */
    @Override
    public void remove() {
	}

    private String seek() {
		return null;
	}

    /**
     * Returns the resource super type of the given resource type:
     * <ol>
     * <li>If the resource type is the base resource type <code>null</code> is returned.</li>
     * <li>If the resource type is the resource type of the resource the resource super type from the resource is
     * returned.</li>
     * <li>Otherwise the resource super type is tried to be found in the resource tree. If one is found, it is
     * returned.</li>
     * <li>Otherwise null is returned.</li>
     * </ol>
     */
    private String getResourceSuperType(final String resourceType) {
		return null;
	}

}
