/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

import javax.servlet.ServletException;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;

import com.adobe.cq.social.handlebars.api.TemplateHelpersService;
import com.day.cq.rewriter.linkchecker.LinkCheckerSettings;
import com.github.jknack.handlebars.Handlebars;
import com.github.jknack.handlebars.Template;
import com.github.jknack.handlebars.io.TemplateSource;

/**
 * The Class TemplateServlet.
 */
@Component
@Service(value = javax.servlet.Servlet.class)
@Properties({@Property(name = "sling.servlet.methods", value = "GET", propertyPrivate = true),
    @Property(name = "sling.servlet.resourceTypes", value = "sling/servlet/default", propertyPrivate = true),
    @Property(name = "sling.servlet.extensions", value = {"hbs", "chbs"}, propertyPrivate = true),
    @Property(name = "sling.servlet.paths", value = "/services/social/templates")})
public class TemplateServlet extends SlingAllMethodsServlet {

    private static final String EXT = "ext";

    private static final String SELECTOR = "selector";

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** The rrf. */
    @Reference
    private final ResourceResolverFactory rrf = null;

    @Reference
    private final TemplateHelpersService templateHelperService = null;

    @Reference
    private TemplateContextProviderService contextProviderService;

    private static final String RESOURCE_TYPE = "resourceType";

    /*
     * (non-Javadoc)
     * @see org.apache.sling.api.servlets.SlingSafeMethodsServlet#doGet(org.apache.sling.api.SlingHttpServletRequest,
     * org.apache.sling.api.SlingHttpServletResponse)
     */
    @Override
    protected void doGet(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws ServletException, IOException {
		}

    /**
     * Write script block prolog.
     * @param writer the writer
     * @param name the name
     */
    private void writeScriptBlockProlog(final PrintWriter writer, final String name) {
	}

    /**
     * Write script block epilog.
     * @param writer the writer
     */
    private void writeScriptBlockEpilog(final PrintWriter writer) {
	}

    /**
     * Write hb wrapper.
     * @param writer the writer
     * @param function the function
     */
    private void writeHBWrapper(final PrintWriter writer, final String function) {
	}
}
