/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.handlebars;

import java.io.InputStream;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;

import org.apache.commons.lang3.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.handlebars.api.TemplateContextProvider;

/**
 * The Class TemplateUtils.
 */
public class TemplateUtils {

    /** The Constant LOG. */
    private static final Logger LOG = LoggerFactory.getLogger(TemplateUtils.class);

    /**
     * This method returns a list of templates for a give <code>Resource</code> and <code>ResourceResolver</code>.
     * @param resolver The resource resource resolver
     * @param baseResource The resource
     * @return map a collection of templates
     */
    public static Map<String, Resource> collectTemplates(final ResourceResolver resolver, final Resource baseResource) {
		return null;
	}

    /**
     * This method finds a template for a give <code>Resource</code> and <code>ResourceResolver</code>. This does not
     * use the same weighting strategy as the Sling Script Resolver.
     * @param resolver The resource resource resolver
     * @param baseResource The resource
     * @param scriptName The name of the script
     * @return the template resource
     */
    public static Resource findTemplate(final ResourceResolver resolver, final String resourceType,
        final String scriptName) {
			return null;
		}

    /**
     * This method returns the template code as an Input Stream.
     * @param res The resource
     * @return stream The inputstream of the template
     */
    public static InputStream getTemplateStream(final Resource res) {
		return null;
	}

    /**
     * Utility method to Return the Merged Context given a list of context providers.
     * @param resourceContext Map of resource contexts
     * @param contextProviders List of template context providers
     * @param request the sling http servlet request
     * @param resource The social component resource
     * @return mergedContext a map object with the merged context
     */
    public static Map<String, Object> getMergedContexts(final Map<String, Object> resourceContext,
        final List<TemplateContextProvider> contextProviders, final SlingHttpServletRequest request) {
			return null;
		}
}
