/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.journal;

/**
 * Used to filter entries based on their draft status.
 */
public class DraftEntryFilter implements JournalEntryFilter {

    boolean draftStatus;

    /**
     * Creates a <code>DraftEntryFilter</code>.
     * @param status <code>true</code> to include drafts only, or <code>false</code> for published entries only
     */
    public DraftEntryFilter(final boolean status) {
        draftStatus = status;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean pass(final JournalEntry entry) {
		return false;
	}
}
