/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.journal;

import javax.servlet.http.HttpServletRequest;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.ResourceResolver;

/**
 * <code>JournalManager</code> is a central interface to manage journals and journal entries. To retrieve a
 * JournalManager, please use {@link ResourceResolver#adaptTo(Class)}.
 */
public interface JournalManager {

    static final String ATTR_JOURNAL = "journal";

    /**
     * Returns the <code>Journal</code> at the specified path, or <code>null</code> if no journal can be found.
     * @param path The journal path
     * @return The journal
     */
    Journal getJournal(String path) {
		return null;
	}

    /**
     * Returns the <code>Journal</code> for the specified request. The corresponding resource will be retrieved from
     * the request, and the journal will be instantiated only once per request.
     * @param req The request
     * @return The journal
     */
    Journal getJournal(SlingHttpServletRequest req) {
		return null;
	}

    /**
     * Returns the <code>Jouranl</code> at the specified path, or <code>null</code> if no journal can be found. The
     * request is needed for certain operations.
     * @param req The request
     * @param path The journal path
     * @return The journal
     */
    Journal getJournal(SlingHttpServletRequest req, String path) {
		return null;
	}

    /**
     * Creates a <code>Jouranl</code> at <code>path</code> using the specified title and description.
     * @param path The path of the journal
     * @param title The title of the journal
     * @return The journal
     */
    Journal createJournal(String path, String title) {
		return null;
	}

    /**
     * Returns the <code>JournalEntry</code> at the specified path or <code>null</code> if no journal entry can be
     * found.
     * @param path The journal entry path
     * @return The journal entry
     */
    JournalEntry getJournalEntry(String path) {
		return null;
	}

    /**
     * Returns the <code>JournalEntry</code> for the specified request and resource. If the resource is
     * <code>null</code> , it will be retrieved from the request.
     * @param req The request
     * @param path The journal entry path (optional)
     * @return The journal entry
     */
    JournalEntry getJournalEntry(SlingHttpServletRequest req, String path) {
		return null;
	}

    /**
     * Returns the selected view for the journal. The value can be one of:
     * <ul>
     * <li>{@link Journal#VIEW_DEFAULT} (default)</li>
     * <li>{@link Journal#VIEW_DEFAULT}</li>
     * <li>{@link Journal#VIEW_NEW}</li>
     * <li>{@link Journal#VIEW_SEARCH}</li>
     * <li>{@link Journal#VIEW_ARCHIVE}</li>
     * </ul>
     * @param req The request
     * @return The view
     */
    String getView(final HttpServletRequest req) {
		return null;
	}

}
