/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.journal;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.CollabUtil;
import com.adobe.cq.social.commons.CommentSystem;
import com.adobe.granite.security.user.UserProperties;
import com.day.cq.commons.jcr.JcrUtil;
import com.day.cq.security.profile.Profile;
import com.day.crx.JcrConstants;

/**
 * <code>JournalUtil</code> provides various tool methods revolving around {@link Journal}s.
 */
public final class JournalUtil {

    private static final Logger log = LoggerFactory.getLogger(JournalUtil.class);

    /**
     * JournalUtil is a singleton.
     */
    private JournalUtil() {
    }

    /**
     * Given a page path and archive date, construct and return the parent path for a journal entry with that given
     * archive date.
     * @param pagePath The path of the page.
     * @param archiveDate The archive date of the journal entry.
     * @return the parent path for a journal entry with that given archive date.
     */
    public static String getParentPath(final String pagePath, final Date archiveDate) {
		return null;
	}

    /**
     * Given a JournalEntry text UGC resource, return the JournalEntry object.
     * @param resource the JournalEntry text UGC resource.
     * @return the JournalEntry object.
     * @throws RepositoryException repository issue.
     */
    public static JournalEntry getJournalEntryUGC(final Resource resource) throws RepositoryException {
		return null;
	}

    /**
     * Delete the given JournalEntry. It is assumed that the caller has verified that the resource is in fact a
     * JournalEntry prior to calling this method.
     * @param resource the JournalEntry to delete.
     * @return a list of paths to replicate.
     * @throws RepositoryException repository issue.
     */
    public static List<String> deleteEntry(final Resource resource) throws RepositoryException {
		return null;
	}

    /**
     * Indicates whether the user within the given resource resolver has enough permissions to post to the given
     * journal. If no posts to this journal have yet been made, the permissions on the
     * {@link com.adobe.cq.social.commons.CommentSystem#PATH_UGC} path are checked instead.
     * @param resolver {@link org.apache.sling.api.resource.ResourceResolver}
     * @param journal The {@link Journal}
     * @return <code>true</code> if the user may post.
     */
    public static boolean mayCreateEntry(final ResourceResolver resolver, final Journal journal) {
		return false;
	}

    /**
     * Indicates whether the user within the given session and profile has enough permissions to post to the given
     * journal.
     * @param session The {@link javax.jcr.Session}
     * @param authorizable The {@link com.day.cq.security.profile.Profile}
     * @param entry The {@link JournalEntry}
     * @return <code>true</code> if the user may post.
     * @deprecated Use {@link #mayEditEntry(final Session, final UserProperties, final JournalEntry)} instead.
     */
    @Deprecated
    public static boolean mayEditEntry(final Session session, final Profile authorizable, final JournalEntry entry) {
		return false;
	}

    /**
     * Indicates whether the user within the given session and profile has enough permissions to post to the given
     * blog.
     * @param session The {@link javax.jcr.Session}
     * @param authorizable The {@link com.adobe.granite.security.user.UserProperties;}
     * @param entry The {@link JournalEntry}
     * @return <code>true</code> if the user may post.
     */
    public static boolean mayEditEntry(final Session session, final UserProperties authorizable,
        final JournalEntry entry) {
			return false;
		}
}
