/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.journal;

/**
 * Used to filter journal entries by the path of their parent(s).
 */
public class ParentPathEntryFilter implements JournalEntryFilter {

    private final String parentPath;

    /**
     * Creates a <code>ParentPathEntryFilter</code> using the specified parent path.
     * @param path The parent path (or substring matching at the end)
     */
    public ParentPathEntryFilter(final String path) {
        parentPath = path;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean pass(final JournalEntry entry) {
		return false;
	}
}
