/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

package com.adobe.cq.social.journal.trackback;

import java.io.IOException;

import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;
import org.apache.sling.jcr.api.SlingRepository;
import org.apache.sling.jcr.resource.JcrResourceResolverFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.CommentSystem;
import com.adobe.cq.social.journal.JournalEntry;
import com.adobe.cq.social.journal.JournalException;
import com.day.cq.xss.XSSProtectionException;
import com.day.cq.xss.XSSProtectionService;
import com.day.text.Text;

/**
 * This servlet adds trackbacks to journal entries.
 */
@Component(metatype = false)
@Service(value = javax.servlet.Servlet.class)
@Properties({
    @Property(name = "service.description", value = "Trackback Servlet"),
    @Property(name = "sling.servlet.resourceTypes", value = "cq/Page"),
    @Property(name = "sling.servlet.methods", value = "POST"),
    @Property(name = "sling.servlet.selectors", value = "trackback"),
    @Property(name = TrackbackServlet.PROPERTY_REVERSE_REPLICATE,
            boolValue = TrackbackServlet.DEFAULT_REVERSE_REPLICATE)})
public class TrackbackServlet extends SlingAllMethodsServlet {

    /** A serialVersionUID for this class. */
    private static final long serialVersionUID = 1L;

    /** A reference to the XSSProtectionService. */
    @Reference
    private XSSProtectionService xssProtectionService;

    /** A reference to the JcrResourceResolverFactory. */
    @Reference
    protected JcrResourceResolverFactory jcrResourceResolverFactory;

    /** A reference to the SlingRepository. */
    @Reference
    protected SlingRepository repository;

    /**
     * The name of the property that contains defines whether the comment should be reverse-replicated.
     */
    final static String PROPERTY_REVERSE_REPLICATE = "reverseReplicate";

    /**
     * The reverse replication state.
     */
    final static boolean DEFAULT_REVERSE_REPLICATE = true;

    private boolean reverseReplicate;

    /** The logger for this class. */
    private final Logger log = LoggerFactory.getLogger(getClass());

    @Override
    protected void doPost(final SlingHttpServletRequest request, final SlingHttpServletResponse response)
        throws IOException {
		}

    private void createTrackbackNode(final Session session, final SlingHttpServletRequest request)
        throws JournalException, XSSProtectionException {
		}

    private String success() {
		return null;
	}

    private String error(final String message) {
		return null;
	}

    protected boolean hasPermission(final Session session, final String path) {
		return false;
	}
}
