/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.api;

import org.apache.sling.api.adapter.Adaptable;

/**
 * defines the nodes containing private messages.
 * @deprecated @since AEM 6.0. Use {@link com.adobe.cq.social.messaging.client.api.MessageBoxSocialComponent} instead.
 */
@Deprecated
public interface MessageBox extends Adaptable {

    /**
     * message box resource type value.
     */
    String RESOURCE_TYPE_VALUE = "/libs/social/messaging/components/messagebox";

    /**
     * enum to specify different type of supported counts.
     */
    enum CountType {
        /**
         * count of unread messages which have been marked as deleted.
         */
        DeletedUnreadMessageCount,
        /**
         * count of unread messages which have not been marked as deleted.
         */
        NonDeletedUnreadMessageCount,
        /**
         * count of read messages which have been marked as deleted.
         */
        DeletedReadMessageCount,
        /**
         * count of read messages which have not been marked as deleted.
         */
        NonDeletedReadMessageCount,
        /**
         * count of all the messages present irrespective of read and deleted flags.
         */
        TotalCount
    }

    /**
     * get message count as per the passed count type.
     * @param countType type of count needed.
     * @return count.
     */
    long getCount(CountType countType) {
		return 0L;
	}

    /**
     * get relative path of this message box from its user.
     * @return relative path from user.
     */
    String getPath() {
		return null;
	}

    /**
     * get size of message box in bytes.
     * @return size of message box in bytes.
     */
    long getSize() {
		return 0L;
	}
}
