/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.client.api;

import java.util.Set;

import javax.jcr.RepositoryException;

import com.adobe.cq.social.commons.client.api.SocialComponent;

/**
 * Compose message as social component.
 */
public interface ComposeMessageSocialComponent extends SocialComponent {
    /**
     * @return true if the component has been opened in forward mode.
     */
    public boolean isToBeForwarded() {
		return false;
	}

    /**
     * @return true if the component has been opened in reply all mode.
     */
    public boolean isReplyAll() {
		return false;
	}

    /**
     * Information about logged in user.
     * @return {@link com.adobe.cq.social.messaging.client.api.MessagingUser}
     * @throws javax.jcr.RepositoryException {@link javax.jcr.RepositoryException}
     */
    public MessagingUser getLoggedInUser() throws RepositoryException {
		return null;
	}

    /**
     * @return message which is being forwarded/replied.
     * @throws RepositoryException {@link RepositoryException}
     */
    public MessageSocialComponent getMessage() throws RepositoryException {
		return null;
	}

    /**
     * @return get form id of the containing form.
     */
    public String getFormID() {
		return null;
	}

    /**
     * @return {@link FormData} of the containing form.
     * @throws RepositoryException
     */
    public Set<FormData> getFormData() throws RepositoryException {
		return null;
	}

}
