/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.client.api;

import java.util.List;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.LoginException;

import com.adobe.cq.social.commons.client.api.SocialCollectionComponent;
import com.adobe.cq.social.commons.comments.api.PageInfo;
import com.adobe.cq.social.messaging.api.Usage;

/**
 * Represents a Messaging MessageBox.
 */
public interface MessageBoxSocialComponent extends SocialCollectionComponent {
    /** property to customize folders to look up the messages in for this message box. **/
    final String PN_FOLDER_PATHS = "folderPaths";

    /**
     * @return {@link PageInfo}
     */
    public PageInfo getPageInfo() {
		return null;
	}

    /**
     * @return paths under which this message box will search for messages.
     */
    public List<String> getFolderPaths() {
		return null;
	}

    /**
     * @return unread message count.
     */
    public MessageCounts getMessageCounts() {
		return null;
	}

    /**
     * get the usage statistics of the user.
     * @return {@link com.adobe.cq.social.messaging.api.Usage}
     * @throws javax.jcr.RepositoryException {@link javax.jcr.RepositoryException} if some exception occurs in
     *             calculating the statistics.
     * @throws org.apache.sling.api.resource.LoginException {@link org.apache.sling.api.resource.LoginException}
     */
    public Usage getUserStatistics() throws RepositoryException, LoginException {
		return null;
	}
}
