/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.client.api;

import javax.jcr.RepositoryException;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.commons.client.api.QueryRequestInfo;
import com.adobe.cq.social.commons.client.api.SocialCollectionComponentFactory;
import com.adobe.cq.social.commons.client.api.SocialComponent;
import com.adobe.cq.social.commons.client.api.SocialComponentFactory;
import com.adobe.cq.social.messaging.api.MessagingService;
import com.adobe.cq.social.messaging.client.impl.MessageBoxSocialComponentImpl;

@Component(label = "AEM Social Communities MessageBoxSocialComponentFactory")
@Service(value = {SocialCollectionComponentFactory.class, SocialComponentFactory.class})
public class MessageBoxSocialComponentFactory extends AbstractMessagingComponentFactory implements
    SocialCollectionComponentFactory {

    private static final Logger LOG = LoggerFactory.getLogger(MessageBoxSocialComponentFactory.class);
    private static final String MESSAGE_BOX_RESOURCE_TYPE = "social/messaging/components/hbs/messagebox";

    @Reference
    private MessagingService messagingService;

    /**
     * Throws UnsupportedOperationException.  Message boxes cannot be created without a valid sling request.
     * @param resource - A resource.
     * @return Throws UnsupportedOperationException.
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource) {
		return null;
	}

    @Override
    public SocialComponent getSocialComponent(final Resource resource, final SlingHttpServletRequest slingRequest) {
		return null;
	}

    /**
     * Throws UnsupportedOperationException.  Message boxes cannot be created without a valid sling request.
     * @param resource A resource.
     * @param clientUtilities A {@Link ClientUtilities} object.
     * @param queryRequestInfo A {@Link QueryRequestInfo} object.
     * @return Throws UnsupportedOperationException.
     */
    @Override
    public SocialComponent getSocialComponent(final Resource resource, final ClientUtilities clientUtilities,
        final QueryRequestInfo queryRequestInfo) {
			return null;
		}

    @Override
    public String getSupportedResourceType() {
		return null;
	}
}
