/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.client.api;

/**
 * Represents counts of messages in a message box.
 */
public interface MessageCounts {
    /**
     * @return count of not trashed unread messages.
     */
    long getNonDeletedUnreadCount() {
		return 0L;
	}

    /**
     * @return count of not trashed read messages.
     */
    long getNonDeletedReadCount() {
		return 0L;
	}

    /**
     * @return count of trashed unread messages.
     */
    long getDeletedUnreadCount() {
		return 0L;
	}

    /**
     * @return count of trashed+read messages.
     */
    long getDeletedReadCount() {
		return 0L;
	}
}
