/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.messaging.client.api;

import java.util.Calendar;
import java.util.List;
import java.util.Map;

import com.adobe.cq.social.commons.client.api.SocialComponent;
import com.adobe.cq.social.messaging.api.MessageException;

/**
 * Represents a single Social Messaging message.
 */
public interface MessageSocialComponent extends SocialComponent {

    /**
     * Resource type for message.
     */
    public static final String MESSAGE_RESOURCE_TYPE = "social/messaging/components/hbs/message";

    /**
     * @return
     */
    public Map<String, Object> getCustomProperties() {
		return null;
	}

    /**
     * @return message subject.
     */
    public String getSubject() {
		return null;
	}

    /**
     * @return message content.
     */
    public String getContent() {
		return null;
	}

    /**
     * @return message's timestamp.
     */
    public Calendar getTimestamp() {
		return null;
	}

    /**
     * Get message attachments.
     * @return {@link Attachment}s.
     * @throws MessageException {@link MessageException} if there is error fetching attachments.
     */
    public List<Attachment> getAttachments() throws MessageException {
		return null;
	}

    /**
     * Get message sender.
     * @return {@link MessagingUser}.
     */
    public MessagingUser getSender() {
		return null;
	}

    /**
     * Get recipients of a message.
     * @return list of {@link MessagingUser}.
     */
    public List<MessagingUser> getRecipients() {
		return null;
	}

    /**
     * @return true if message is read, false otherwise.
     */
    public boolean isRead() {
		return false;
	}

    /**
     * @return message id.
     */
    public String getMessageID() {
		return null;
	}

    /**
     * @return relative path of this message's message box to user's node.
     */
    public String getMessageBoxRelativePath() {
		return null;
	}

    /**
     * @return absolute path of this message's message box.
     */
    public String getMessageBoxPath() {
		return null;
	}
}
