/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.moderation.util.common;

import com.day.cq.workflow.WorkflowException;

/**
 * <code>SocialModerationException</code> is the exception for all Social Moderation Actions.
 */
public class SocialModerationException extends WorkflowException {

    /** A serialVersionUID for this class. */
    private static final long serialVersionUID = 1L;

    private int errorCode;

    public SocialModerationException(final String msg) {
        super(msg);
    }

    public SocialModerationException(final Throwable cause) {
        super(cause);
    }

    public SocialModerationException(final String msg, final Throwable cause) {
        super(msg, cause);
    }

    public SocialModerationException(final String message, final int errorCode) {
        super(message);
        this.errorCode = errorCode;
    }

    public SocialModerationException(final String message, final int errorCode, final Throwable t) {
        super(message, t);
        this.errorCode = errorCode;
    }

    public int getErrorCode() {
		return 0;
	}

}
