/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.sc.lucene;

import java.io.IOException;

import org.apache.lucene.store.IndexOutput;

class JCRIndexOutput extends IndexOutput {

    private final JCRDirectory directory;

    private final String name;

    private byte[] data;

    private int length;

    private int position = 0;

    private boolean dirty = false;

    public JCRIndexOutput(final JCRDirectory directory, final String name) throws IOException {
        this.directory = directory;
        this.name = name;
        this.data = directory.readFile(name);
        if (data != null) {
            length = data.length;
        } else {
            data = new byte[1024];
            length = 0;
        }
    }

    private synchronized void grow(final int n) {
	}

    @Override
    public synchronized void writeByte(final byte b) throws IOException {
	}

    @Override
    public synchronized void writeBytes(final byte[] b, final int offset, final int length) throws IOException {
	}

    @Override
    public synchronized void flush() throws IOException {
	}

    @Override
    public synchronized void close() throws IOException {
	}

    @Override
    public synchronized long getFilePointer() {
		return 0L;
	}

    @Override
    public synchronized void seek(final long pos) throws IOException {
	}

    @Override
    public synchronized long length() throws IOException {
		return 0L;
	}

}
