/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.sc.lucene;

/**
 * <code>TransformConstants</code> defines constants for query processing.
 */
public interface TransformConstants {

    /**
     * No transformation is done on the term enum.
     */
    int TRANSFORM_NONE = 0;

    /**
     * The underlying term enum is transformed to lower case characters.
     */
    int TRANSFORM_LOWER_CASE = 1;

    /**
     * The underlying term enum is transformed to upper case characters.
     */
    int TRANSFORM_UPPER_CASE = 2;

}
