/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.scoring.api;

/**
 * A model for score update instructions.
 */
public class ScoreOperation {

    /**
     * name of score to be added/updated.
     */
    private String scoreName;

    /**
     * boolean value to indicate whether score needs to be incremented or decremented.
     */
    private boolean isIncrement;

    /**
     * boolean value to indicate whether score needs to be updated in absolute value or percentage measure.
     */
    private boolean isAbsolute;

    /**
     * long measure to quantify the update operation.
     */
    private long scoreValue;

    /**
     * Returns the score name from model.
     * @return name of the score.
     */
    public String getScoreName() {
		return null;
	}

    /**
     * Set the name of score to given value.
     * @param scoreName - name of score.
     */
    public void setScoreName(final String scoreName) {
	}

    /**
     * Indicates whether update is increment value. If not, it is decrement operation.
     * @return true if its increment operation else false.
     */
    public boolean isIncrement() {
		return false;
	}

    /**
     * Set to true for increment operation. If not, set to false.
     * @param increment - boolean value to indicate update operation.
     */
    public void setIncrement(final boolean increment) {
	}

    /**
     * Indicate whether update is through absolute or percentage measure.
     * @return true if the update is absolute else false.
     */
    public boolean isAbsolute() {
		return false;
	}

    /**
     * Set to true for absolute value operation else false.
     * @param absolute - boolean value to indicate measure.
     */
    public void setAbsolute(final boolean absolute) {
	}

    /**
     * Return the score value of the operation.
     * @return long value of operation.
     */
    public long getScoreValue() {
		return 0L;
	}

    /**
     * Set the score value to operation.
     * @param scoreValue - long value of the quantity.
     */
    public void setScoreValue(final long scoreValue) {
	}

}
