/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.scoring.api;

/**
 * ScoringConstants contains the constants used by Scoring bundle.
 */
public final class ScoringConstants {

    /**
     * Indicates the name of badges property of the scoring node.
     */
    public static final String ATTRIBUTE_BADGES = "badges";

    /**
     * Indicates the name of the scoring node.
     */
    public static final String SCORING_NODE = "scoring";

    /**
     * Indicates path of badge segments.
     */
    public static final String BADGE_PATH = "segments/scoring";

    /**
     * Indicates the path to the scoring script executor.
     */
    public static final String SCORING_SCRIPT = "/libs/social/scoring/scripts/ScriptExecutor.ecma";

    /**
     * Indicates the resource type of granite activity.
     */
    public static final String RESOURCE_TYPE_ACTIVITY = "granite/activitystreams/components/activity";

    /**
     * Overriding the default constructor for the Constants class.
     */
    private ScoringConstants() {
    }
}
