/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.storage;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.adapter.AdapterFactory;
import org.apache.sling.api.resource.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.storage.buckets.NestedBucketStorageSystem;
import com.adobe.cq.social.storage.buckets.impl.NestedBucketStorageSystemImpl;
import com.adobe.cq.social.storage.index.Index;
import com.adobe.cq.social.storage.index.IndexCounter;
import com.adobe.cq.social.storage.index.impl.IndexCounterImpl;
import com.adobe.cq.social.storage.index.impl.IndexImpl;

/**
 * BucketStorageAdapterFactory which enables the NestedBucketStorageSystem obtains the OSGi BucketStorageService
 */

@Component(metatype = false, label = "AEM Social Communities Bucket Storage Adapter Factory",
        description = "Provides adapter functionality for bucket storage object")
@Service
@Property(name = "service.description", value = "AEM Social Communities Bucket Storage Adapter Factory")
@SuppressWarnings("UnusedDeclaration")
public class BucketStorageAdapterFactory implements AdapterFactory {

    private static Logger log = LoggerFactory.getLogger(BucketStorageAdapterFactory.class);
    private static final Class<NestedBucketStorageSystem> NESTED_BUCKET_STORAGE_SYSTEM =
        NestedBucketStorageSystem.class;
    private static final Class<IndexCounter> INDEX_COUNTER_CLASS = IndexCounter.class;
    private static final Class<Index> INDEX_CLASS = Index.class;

    @SuppressWarnings("UnusedDeclaration")
    @Property(name = "adapters")
    public static final String[] ADAPTER_CLASSES = {NESTED_BUCKET_STORAGE_SYSTEM.getName(),
        INDEX_COUNTER_CLASS.getName(), INDEX_CLASS.getName()};

    @SuppressWarnings("UnusedDeclaration")
    @Property(name = "adaptables")
    public static final String[] ADAPTABLE_CLASSES = {Resource.class.getName()};

    @Override
    public <AdapterType> AdapterType getAdapter(final Object adaptable, final Class<AdapterType> type) {
		return null;
	}

    @SuppressWarnings("unchecked")
    private <AdapterType> AdapterType getAdapter(final Resource resource, final Class<AdapterType> type) {
		return null;
	}

}
