/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.storage.index;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.ResourceResolver;

public class AbstractBaseIndexManager<K, E> implements IndexManager<K, E> {

    protected Map<String, Indexer<K, E>> indexers = new HashMap<String, Indexer<K, E>>();
    protected Map<String, KeyIndexer<E>> keyIndexers = new HashMap<String, KeyIndexer<E>>();

    /**
     * {@inheritDoc}
     */
    @Override
    public long getSize(final String indexName, final ResourceResolver resolver) throws RepositoryException {
		return 0L;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public long getNumberOfPages(final String indexName, final int pageSize, final ResourceResolver resolver)
        throws RepositoryException {
			return 0L;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getIndex(final String indexName, final ResourceResolver resolver, final K key, final String endsWith) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public int getIndexLoc(final String indexName, final ResourceResolver resolver, final K key, final String endsWith) {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void unindex(final String indexName, final ResourceResolver resolver, final String keyIndexName,
        final String targetId, final K key, final String endsWith) throws RepositoryException {
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<E> getPageByNumber(final String indexName, final int pageSize, final ResourceResolver resolver,
        final int pageNumber, final String rootPath) {
			return null;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<E> getPageByOffset(final String indexName, final int pageSize, final ResourceResolver resolver,
        final int offset, final String rootPath) {
			return null;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public <C> List<C> getIndexElementPageByOffset(final String indexName, final int pageSize,
        final ResourceResolver resolver, final int offset, final String rootPath,
        final IndexElementFactory<C> resourceElementFactory) {
			return null;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public void index(final String indexName, final ResourceResolver resolver, final String keyIndexName,
        final String targetId, final E target, final K indexKey, final String indexContent)
        throws RepositoryException {
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public Indexer<K, E> getIndexer(final String indexName) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void registerIndexer(final Indexer<K, E> indexer) {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isRegistered(final String name) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void reindex(final String indexName, final ResourceResolver resolver, final String keyIndexName,
        final String targetId, final E target, final K prevIndexKey, final K indexKey, final String indexContent,
        final boolean force, final String endsWith) throws RepositoryException {
		}

    /**
     * {@inheritDoc}
     */
    @Override
    public KeyIndexer<E> getKeyIndexer(final String indexName) {
		return null;
	}

}
