/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.storage.index;

import org.apache.sling.api.resource.Resource;

/**
 * An interface representing an resource that an {@link Indexer} manages. An IndexElement consists of a resource and a
 * set of special properties that an Indexer maintains; For example, a
 * {@link com.adobe.cq.social.forum.impl.PostDateModifiedIndexer} manages number of replies and latest updated post of
 * a topics.
 */
public interface IndexElement {
    /**
     * Get the target post resource.
     * @return the target resource
     */
    Resource getResource() {
		return null;
	}

    /**
     * Get a named property and convert it into the given type. This method does not support conversion into a
     * primitive type or an array of a primitive type. It should return <code>null</code> in this case.
     * @param name The name of the property
     * @param type The class of the type
     * @return Return named value converted to type T or <code>null</code> if non existing or can't be converted.
     */
    <T> T get(String name, Class<T> type) {
		return null;
	}

    /**
     * Set a property
     * @param name the property name
     * @param value the property value
     */
    void put(String name, Object value) {
	}

}
