/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.storage.index;

import org.apache.sling.api.resource.Resource;

/**
 * An IndexElementFactory creates an instance of a {@link IndexElement} from a specified {@link Resource} and adapts
 * an instance of {@link IndexElement} to a specific Component POJO type, such as an instance of {@link Comment} or
 * {@link Post}.
 * @param <C> a specific Component POJO type, such as an instance of {@link Comment} or {@link Post}.
 */
public interface IndexElementFactory<C> {
    /**
     * Create an instance of IndexElement from a specified resource.
     * @param resource the index resource
     * @return an instance of IndexElement
     */
    IndexElement createIndexElement(Resource resource) {
		return null;
	}

    /**
     * Adapt the specified resoruceElement to the component data model.
     * @param resourceElement the resource element
     * @return a component data model such as {@link Comment}.
     */
    C adaptTo(IndexElement resourceElement) {
		return null;
	}
}
