/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.storage.index;

import org.apache.sling.api.resource.ResourceResolver;

public interface IndexHandler {

    /**
     * Handle the Event.
     * @param resourceType The resource type for this event.
     * @param eventTopics The event topics for this event.
     * @param nodePath The node path.
     * @param resourceChangedAttributes The array of changed attributes.
     * @param resourceAddedAttributes The array of added attributes.
     * @param resourceRemovedAttributes The array of removed attributes.
     * @return true if this event was handled. Return false if this event not the type of event handled by this
     *         handler.
     */
    public boolean handleEvent(ResourceResolver resolver, String resourceType, String eventTopics, String nodePath,
        String[] resourceChangedAttributes, String[] resourceAddedAttributes, String[] resourceRemovedAttributes)
        throws Exception {
		return false;
	}

    /**
     * Return the name of this IndexHandler.
     * @return the name of this IndexHandler.
     */
    public String getName() {
		return null;
	}

    /**
     * Register new resource types that should be accepted by this IndexHandler when an add event occurs.
     * @param resourceTypes new resource types that should be accepted by this IndexHandler when an add event occurs.
     */
    public void registerAddResourceTypes(String... resourceTypes) {
	}

    /**
     * Register resource types that should be accepted by this IndexHandler when a change event occurs.
     * @param resourceTypes new resource types that should be accepted by this IndexHandler when a change event
     *            occurs.
     */
    public void registerChangeResourceTypes(String... resourceTypes) {
	}

    /**
     * Unregister add resource types.
     * @param resourceTypes existing add resource types that should be unregistered.
     */
    public void unregisterAddResourceTypes(String... resourceTypes) {
	}

    /**
     * Unregister change resource types.
     * @param resourceTypes existing change resource types that should be unregistered.
     */
    public void unregisterChangeResourceTypes(String... resourceTypes) {
	}
}
