/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.storage.index;

import java.util.Collection;

/**
 * A collection of registered IndexHandlers.
 */
public interface IndexHandlerCollection {

    /**
     * Register the given IndexHandler. If an IndexHandler with the same name has already been registered, overwrite
     * it.
     * @param indexHandler the IndexHandler to register.
     */
    public void registerIndexHandler(IndexHandler indexHandler) {
	}

    /**
     * Unregister the IndexHandler with the given name.
     * @param name the name of the IndexHandler to unregister.
     */
    public void unregisterIndexHandler(String name) {
	}

    /**
     * Return the Collection of registered IndexHandlers.
     * @return the Collection of registered IndexHandlers.
     */
    public Collection<IndexHandler> getIndexHandlers() {
		return null;
	}

    /**
     * Return the IndexHandler with the given name or null if the IndexHandler is unregistered.
     * @param name the name of the IndexHandler to return.
     */
    public IndexHandler getIndexHandler(String name) {
		return null;
	}
}
