/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.storage.index;

import java.util.Comparator;
import java.util.List;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.ResourceResolver;

/**
 * An index that maps element id to current index key. Element ids are indexed in alphabetical order.
 */
public class KeyIndexer<E> extends AbstractBaseIndexer<String, E> {
    public static final int KEY_INDEX = 1;

    public static final String NAME = "key";

    private final String indexName;

    private static class StringComparator implements Comparator<String> {

        @Override
        public int compare(final String o1, final String o2) {
			return 0;
		}
    }

    /**
     * Construct a new KeyIndexer
     * @param indexName the name of this index.
     * @param basePath Base path of component being indexed. The path can be from the content or usergenerated
     *            directory.
     * @param indexPath The relative path from the root index path (derived from basePath) where this index should be
     *            stored.
     * @param writeMode If true, prepare index directory for writing. If false, assume API user will only do index
     *            reading.
     */
    public KeyIndexer(final String indexName, final ResourceResolver resolver, final String basePath,
        final String indexPath, final boolean writeMode) throws RepositoryException {
        super(resolver, basePath, indexPath, new StringComparator(), writeMode);
        this.indexName = indexName;
    }

    /**
     * Return the name of this index.
     * @return the name of this index.
     */
    @Override
    public String getName() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public List<E> getElements(final ResourceResolver resolver, final int start, final int size,
        final String forumPath) {
			return null;
		}

    /**
     * Not implemented. Key indices don't store paths to elements.
     */
    @Override
    protected E getElementFromIndex(final ResourceResolver resolver, final String elementRootPath, final String index) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String index(final ResourceResolver resolver, final E target, final String indexKey,
        final String indexContent) throws RepositoryException {
			return null;
		}

    /**
     * Not required and not supported by KeyIndexer.
     */
    @Override
    public int getIndexLoc(final ResourceResolver resolver, final String key, final String endsWith) {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String stringToK(final String key) {
		return null;
	}

    /**
     * Not implemented. Key indices don't store paths to elements.
     */
    @Override
    public <C> List<C> getIndexElements(final ResourceResolver resolver, final int start, final int size,
        final String rootPath, final IndexElementFactory<C> resourceElementFactory) {
			return null;
		}

    /**
     * Not implemented. Key indices don't store paths to elements.
     */
    @Override
    protected <C> C getComponentElementFromIndex(final ResourceResolver resolver, final String elementRootPath,
        final String index, final IndexElementFactory<C> resourceElementFactory) {
			return null;
		}

}
