/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.tally;

import org.apache.sling.api.resource.Resource;

/**
 * An utility class to work with <code>Tally</code> resources.
 */
public interface TallyManager {
    /**
     * For a given resource, tally name and class type, this method finds the tally if available, adapts it to the
     * given class type and returns.
     * @param resource the resource for which the tally is requested
     * @param tallyName the name of the tally
     * @param tallyType the class object of the specific type of tally that is requested
     * @param <TallyType> an instance of type <code>Tally</code>
     * @return returns an instance of Tally
     */
    public <TallyType extends Tally<?>> TallyType getTally(Resource resource, String tallyName,
        Class<TallyType> tallyType) {
		return null;
	}
}
