/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.tally.client.api;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;

import com.adobe.cq.social.commons.client.api.BaseSocialComponent;
import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.tally.Poll;
import com.adobe.cq.social.tally.Response;
import com.adobe.cq.social.tally.ResponseValue;
import com.adobe.cq.social.tally.Tally;
import com.adobe.cq.social.tally.TallyException;
import com.adobe.cq.social.tally.Voting;
import com.adobe.granite.security.user.UserProperties;

public class AbstractTally extends BaseSocialComponent implements TallySocialComponent {
    final private Resource resource;
    final private Tally<?> tally;

    protected final String currentUser;

    public AbstractTally(final Resource resource, final ClientUtilities clientUtils) {
        super(resource, clientUtils);
        this.resource = resource;
        final ResourceResolver resolver = this.resource.getResourceResolver();
        if (resolver.isResourceType(this.resource, Poll.RESOURCE_TYPE)) {
            this.tally = resource.adaptTo(Poll.class);
        } else if (resolver.isResourceType(this.resource, Voting.VOTING_RESOURCE_TYPE)) {
            this.tally = resource.adaptTo(Voting.class);
        } else {
            this.tally = null;
        }
        this.currentUser = resolver.getUserID();
    }

    public AbstractTally(final Tally tally, final ClientUtilities clientUtils) {
        super(tally.getTallyTarget(), clientUtils);
        this.resource = tally.getTallyTarget();
        this.tally = tally;
        final UserProperties loggedInUserProperties =
            this.resource.getResourceResolver().adaptTo(UserProperties.class);
        if (loggedInUserProperties != null) {
            this.currentUser = loggedInUserProperties.getAuthorizableID();
        } else {
            this.currentUser = null;
        }
    }

    @Override
    public String getName() {
		return null;
	}

    @Override
    public Long getTotalNumberOfResponses() {
		return null;
	}

    @Override
    public ResponseValue getCurrentUserResponse() throws TallyException {
		return null;
	}

    @Override
    public Map<String, Long> getResponseTallies() {
		return null;
	}

    public void addResponse(final String value) {
	}

    public void removeCurrentUserResponse() {
	}

    @Override
    public boolean getCanUserRespond() {
		return false;
	}
    
    protected Tally<?> getTally() {
		return null;
	}

}
