/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.tally.client.api;

import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.commons.client.api.ClientUtilities;
import com.adobe.cq.social.tally.Response;
import com.adobe.cq.social.tally.TallyException;
import com.adobe.cq.social.tally.Vote;
import com.adobe.cq.social.tally.Voting;

public class AbstractVoting extends AbstractTally implements VotingSocialComponent {
    private final Voting votingComponent;

    public AbstractVoting(final Resource resource) {
        this(resource.adaptTo(Voting.class), null);
    }

    public AbstractVoting(final Resource resource, final ClientUtilities clientUtils) {
        this(resource.adaptTo(Voting.class), clientUtils);
    }

    public AbstractVoting(final Voting votingComponent, final ClientUtilities clientUtils) {
        super(votingComponent, clientUtils);
        this.votingComponent = votingComponent;
    }

    @Override
    public long getNetCount() {
		return 0L;
	}

    @Override
    public long getPositiveCount() {
		return 0L;
	}

    @Override
    public long getNegativeCount() {
		return 0L;
	}

    @Override
    public String getPositiveLabel() {
		return null;
	}

    @Override
    public String getNegativeLabel() {
		return null;
	}

    @Override
    public boolean isCurrentUserLike() {
		return false;
	}
    
    protected Voting getVotingComponent() {
		return null;
	}

}
