/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.translation;

import java.util.HashMap;
import java.util.Map;

/**
 * HashMap that matches the language codes to the languages.
 */
public class LanguageCodeMap {
    private static final Map<String, String> HM = new HashMap<String, String>();
    private static final Map<String, String> SPECIAL_CODES = new HashMap<String, String>();
    static {

        HM.put("ar_AE", "Arabic");
        HM.put("bg", "Bulgarian");
        HM.put("zh_CN", "Simplified Chinese");
        HM.put("cs_ZH", "Traditional Chinese");
        HM.put("cs_CZ", "Czech");
        HM.put("da", "Danish");
        HM.put("nl_NL", "Dutch");
        HM.put("en_US", "English");
        HM.put("et", "Estonian");
        HM.put("fi_FI", "Finnish");
        HM.put("fr_FR", "French");
        HM.put("de_DE", "German");
        HM.put("el_GR", "Greek");
        HM.put("ht", "Haitian Creole");
        HM.put("he", "Hebrew");
        HM.put("hu", "Hungarian");
        HM.put("id", "Indonesian");
        HM.put("it_IT", "Italian");
        HM.put("ja_JP", "Japanese");
        HM.put("ko_KR", "Korean");
        HM.put("lv", "Latvian");
        HM.put("no_NO", "Norwegian");
        HM.put("pl_PL", "Polish");
        HM.put("pt_BR", "Portuguese");
        HM.put("ro_RO", "Romanian");
        HM.put("ru_RU", "Russian");
        HM.put("sk", "Slovak");
        HM.put("sl", "Slovenian");
        HM.put("es_ES", "Spanish");
        HM.put("sv_SE", "Swedish");
        HM.put("th", "Thai");
        HM.put("tr_TR", "Turkish");
        HM.put("uk", "Ukrainian");
        HM.put("vi", "Vietnamese");

        // key:language code in other systems, value: language code in CLS-MT
        SPECIAL_CODES.put("zh-cn", "zh_CN");
        SPECIAL_CODES.put("zh-tw", "cs_ZH");
    }

    /**
     * Compares two language codes to see if they are the same language, for example, language code in CQ is en for
     * English, while en_US in CLSMT, it will return true if compare the two codes.
     * @param languageCode1 The first language code to compare with language two
     * @param languageCode2 The second language code to compare with language one
     * @return boolean
     */
    public static boolean sameLanguageCode(final String languageCode1, final String languageCode2) {
		return false;
	}

    /**
     * @param languageCode The language code which is going to be converted to the CLSMT language code
     * @return String Returns the CLSMT language code.
     */
    public static String getCLSMTLanguageCode(final String languageCode) {
		return null;
	}

    /**
     * @param languageCode Get the language name from the CLSMT language code
     * @return String
     */
    public static String getLanguage(final String languageCode) {
		return null;
	}
}
