/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.ugc.api;

import java.util.List;
import java.util.Map;

import javax.jcr.RepositoryException;

/**
 * Interface for performing related search.
 */
public interface RelatedSearch {

    /**
     * Return a list of related elements, given a query.
     * @param scName The name of the search collection.
     * @param query The string to search for.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component to filter on.
     * @param statusFilter The status to filter on.
     * @param mltFields Node properties to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents.
     * @throws RepositoryException thrown when there are issues with repository.
     */
    List<String> findMLT(String scName, String query, String statusFilter, String resourceTypeFilter,
        String componentFilter, String[] mltFields, int maxResults, int minTermFreq, int minDocFreq)
        throws RepositoryException {
		return null;
	}

    /**
     * Return a list of related elements, given a query.
     * @param scName The name of the search collection.
     * @param query The string to search for.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component to filter on.
     * @param mltFields Node properties to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents.
     * @throws RepositoryException thrown when there are issues with repository.
     */
    List<String> findMLT(String scName, String query, String resourceTypeFilter, String componentFilter,
        String[] mltFields, int maxResults, int minTermFreq, int minDocFreq) throws RepositoryException {
		return null;
	}

    /**
     * Return a list of categories [Facets] and their counts.
     * @param scName The name of the search collection.
     * @param fieldName The field name to be retrieved [Ex, Author, CategoryDate, cq:Tags]
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component to filter on.
     * @param count The maximum results returned.
     * @return The map of Categories[values] and their counts.
     * @throws RepositoryException thrown when there are issues with repository.
     */
    Map<String, Integer> findFacets(String scName, String fieldName, String resourceTypeFilter,
        String componentFilter, int count) throws RepositoryException {
		return null;
	}
}
