/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.ugc.api;

import java.util.Collection;
import java.util.List;

/**
 * Responsible for writing a UgcFilter as a JCR SQL2 query.
 */
public class UgcFilterQueryWriter {

    private static final String SELECT = "SELECT";
    private static final char SELECT_ALL = '*';
    private static final String FROM = "FROM";
    private static final String WHERE = "WHERE";
    private static final String ORDER_BY = "ORDER BY";
    private static final String CONTAINS = "CONTAINS";
    private static final String IS_DESCENDANT_NODE = "ISDESCENDANTNODE";
    private static final String IS_SAME_NODE = "ISSAMENODE";
    private static final String IS_CHILD_NODE = "ISCHILDNODE";
    private static final String ASCENDING = "ASC";
    private static final String DESCENDING = "DESC";
    private static final String AND = "AND";
    private static final String OR = "OR";
    private static final String NOT = "NOT";
    private static final String AS = "AS";
    private static final char OPEN_FROM = '[';
    private static final char CLOSE_FROM = ']';
    private static final char SPACING = ' ';
    private static final char OPEN_GROUP = '(';
    private static final char CLOSE_GROUP = ')';
    private static final char OPEN_ORDER_NAME = '[';
    private static final char CLOSE_ORDER_NAME = ']';
    private static final char ORDERING_SEPARATOR = ',';

    private static final char VARIABLE_IDENTIFIER = '$';

    private static final char OPEN_SINGLE_QUOTE = '\'';
    private static final char CLOSE_SINGLE_QUOTE = '\'';
    private static final char OPEN_FUNCTION = '(';
    private static final char CLOSE_FUNCTION = ')';
    private static final char FUNCTION_PARAM_SEPARATOR = ',';
    private static final char SELECTOR_NAME = 'c';
    private static final char SELECTOR_SEPARATOR = '.';

    private static final char EQUAL = '=';
    private static final char LESS_THAN = '<';
    private static final char GREATER_THAN = '>';
    private static final String LESS_THAN_OR_EQUAL = "<=";
    private static final String GREATER_THAN_OR_EQUAL = ">=";
    private static final String NOT_EQUAL = "<>";

    /**
     * Writes a JCR SQL2 query from the given UgcFilter.
     * @param ugcFilter UgcFilter to write as a JCR SQL2 query.
     * @return String containing the JCR SQL2 query.
     */
    public String write(final UgcFilter ugcFilter) {
		return null;
	}

    /**
     * Adds sort information to the query if present.
     * @param query StringBuffer containing the query.
     * @param ugcFilter UgcFilter containing sort information.
     */
    private void handleSort(final StringBuffer query, final UgcFilter ugcFilter) {
	}

    /**
     * QueryWriterConstraintVisitor is a ConstraintVisitor implementation which traverses the constraint hierarchy in
     * order to construct a JCR SQL2 where clause from the constraints that have been added to a UgcFilter.
     */
    private static class QueryWriterConstraintVisitor extends DefaultConstraintVisitor implements ConstraintVisitor {

        private boolean first = true;
        private final StringBuffer query;

        /**
         * Creates a new QueryWriterConstraintVisitor with a StringBufer containing a partially constructed query.
         * @param query StringBuffer to write the where clause to.
         */
        public QueryWriterConstraintVisitor(final StringBuffer query) {
            super();
            this.query = query;
        }

        /**
         * Write a SetConstraint in JCR SQL2 format.
         * @param setConstraint SetConstraint to write
         */
        @Override
        public void visitSetConstraint(final SetConstraint setConstraint) {
		}

        /**
         * Write a PathConstraint in JCR SQL2 format.
         * @param pathConstraint PathConstraint to write.
         */
        @Override
        public void visitPathConstraint(final PathConstraint pathConstraint) {
		}

        /**
         * Write a ValueConstraint in JCR SQL2 format.
         * @param valueConstraint ValueConstraint to write.
         */
        @Override
        public void visitValueConstraint(final ValueConstraint valueConstraint) {
		}

        /**
         * Write a ConstraintGroup in JCR SQL2 format.
         * @param constraintGroup ConstraintGroup to write.
         */
        @Override
        public void visitConstraintGroup(final ConstraintGroup constraintGroup) {
		}

        /**
         * Write a RangeConstraint in JCR SLQ2 format.
         * @param rangeConstraint RangeConstraint to write.
         */
        @Override
        public void visitRangeConstraint(final RangeConstraint<?> rangeConstraint) {
		}

        /**
         * Write a FullTextConstraint in JCR SLQ2 format.
         * @param fullTextConstraint FullTextConstraint to write.
         */
        @Override
        public void visitFullTextConstraint(final FullTextConstraint fullTextConstraint) {
		}

        /**
         * Writes a value to the query. If the value is a variable, long or integer it is written without quotes,
         * otherwise it is wrapped in single quotes.
         * @param query StringBuffer containing the query being constructed.
         * @param value Value to write.
         */
        protected void writeValue(final StringBuffer query, final Object value) {
		}

        /**
         * Writes negation in JCR SQL2 format if present in the constraint.
         * @param constraint Constraint to check for negation.
         */
        protected void writeNegation(final Constraint constraint) {
		}

        /**
         * Writes the operator in JCR SQL2 format if it is not the first constraint being handled.
         * @param constraint Constraint containing the operator.
         */
        protected void writeOperator(final Constraint constraint) {
		}

    }

}
