/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.ugcbase;

import org.apache.sling.api.SlingException;

/**
 * <code>CollabException</code> is a generic exception for all failures in Social Collaboration.
 */
public class SocialException extends SlingException {

    /** A serialVersionUID for this class. */
    private static final long serialVersionUID = -1096711330785730585L;

    /**
     * Constructs a new CollabException with the specified message and cause.
     * @param message The detailed message
     */
    public SocialException(final String message) {
        super(message);
    }

    /**
     * Constructs a new CollabException with the specified message and cause.
     * @param message The detailed message
     * @param cause The cause
     */
    public SocialException(final String message, final Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a new CollabException with the specified message and cause.
     * @param cause The cause
     */
    public SocialException(final Throwable cause) {
        super(cause);
    }

}
