/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.ugcbase;

import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;

import org.apache.sling.api.resource.ModifyingResourceProvider;
import org.apache.sling.api.resource.QueriableResourceProvider;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceProvider;
import org.apache.sling.api.resource.ResourceResolver;

import com.day.cq.wcm.webservicesupport.Configuration;

public interface SocialResourceProvider extends ResourceProvider, ModifyingResourceProvider,
    QueriableResourceProvider {

    Iterator<Resource> listChildren(String path, ResourceResolver resourceResolver, int offset, int size,
        List<Entry<String, Boolean>> sortBy) {
		return null;
	}

    long countChildren(Resource parent) {
		return 0L;
	}

    void setCloudConfig(Configuration cloudConfig) {
	}

    String getASIPath() {
		return null;
	}

    /**
     * Return a list of related posts, given a query.
     * @param resolver The resource resolver.
     * @param query The string to search for.
     * @param statusFilter The filter on the status.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component we want to search on.
     * @param mltFields Resource properties to search on. NOTE: Only first one is used
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents. Or an empty list if no documents are found or the Solr server cannot be
     *         queried.
     * @deprecated Solr and Lucene only use the first mltField when using a stream as the document (our use case) See:
     *             https://issues.apache.org/jira/browse/SOLR-5351?
     */
    @Deprecated
    Iterator<Resource> getMLTResults(ResourceResolver resolver, String query, String statusFilter,
        String resourceTypeFilter, String componentFilter, String[] mltFields, int maxResults, int minTermFreq,
        int minDocFreq) {
		return null;
	}

    /**
     * Return a list of related posts, given a query.
     * @param resolver The resource resolver.
     * @param query The string to search for.
     * @param statusFilter The filter on the status.
     * @param resourceTypeFilter The resource type to filter on.
     * @param componentFilter The path of the component we want to search on.
     * @param mltField Resource property to search on.
     * @param maxResults The maximum results returned.
     * @param minTermFreq The frequency which terms will be ignored in the source doc
     * @param minDocFreq The frequency at which words will be ignored which do not occur in at least this many docs.
     * @return The list of matching documents. Or an empty list if no documents are found or the Solr server c cannot
     *         be queried.
     */
    Iterator<Resource> getMLTResults(ResourceResolver resolver, String query, String statusFilter,
        String resourceTypeFilter, String componentFilter, String mltField, int maxResults, int minTermFreq,
        int minDocFreq) {
		return null;
	}

    /**
     * Return a result list of resources given a component and a query.
     * @param resolver The resource resolver.
     * @param component The component for filtering on
     * @param query The lucene query
     * @param sortFields fields to use in sort and sort direction
     * @param offset starting offset to return results at
     * @param limit maximum number of results to return
     * @return The matching documents.
     */
    SocialResourceSearchResult<Resource> find(ResourceResolver resolver, String component, String query,
        List<SearchSortField> sortFields, int offset, int limit) {
		return null;
	}
}
