/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.upgradesexecutor;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.jcr.Item;
import javax.jcr.Session;

import org.apache.sling.jcr.api.SlingRepository;
import org.apache.sling.launchpad.api.StartupHandler;
import org.apache.sling.launchpad.api.StartupMode;
import org.apache.sling.startupfilter.StartupInfoProvider;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;
import org.osgi.framework.ServiceRegistration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.compat.codeupgrade.CodeUpgradeTask;

/** Run CodeUpgradeTasks, synchronously in the Activator.start() method */ 
public class Activator implements BundleActivator {
    private final Logger log = LoggerFactory.getLogger(getClass());
    
    /** If this property is true, upgrades execute whatever the StartupMode is.
     *  Useful for troubleshooting the upgrade code. */
    public static final String FORCE_UPGRADES_PATH = "/var/upgrade/status/upgradesExecutor.forceUpgrades";

    /** Provides informational status messages in the 503 responses that CQ
     *  returns during startup.
     */
    class InfoProvider implements StartupInfoProvider {

        private String progressInfo = "Initializing";
        private volatile CodeUpgradeTask task;
        
        public String getProgressInfo() {
			return null;
		}
        
        void say(String info) {
		}
        
        void setTask(CodeUpgradeTask t) {
		}
    };
    
    /** When this bundle starts, execute all available CodeUpgradeTasks
     *  if StartupMode is UPDATE.
     */
    public void start(BundleContext context) throws Exception {
	}

    public void stop(BundleContext context) throws Exception {
	}
    
    private void runUpgradeTasks(BundleContext context, InfoProvider ip) throws InvalidSyntaxException {
	}
}