/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
/**
 * AdobePatentID="3435US01"
 */
package com.adobe.cq.wcm.launches.utils;

import java.util.Calendar;

import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.resource.Resource;

import com.adobe.cq.launches.api.LaunchResourceStatus;
import com.adobe.cq.launches.api.LaunchResourceStatus.LaunchStatusType;
import com.day.cq.wcm.api.Page;
import com.day.text.Text;

import static com.adobe.cq.wcm.launches.impl.LaunchConstants.LAUNCHES_ROOT_PATH;

/**
 * Utilities for WCM launches.
 */
public class LaunchUtils {

    /**
     * Content tree level where to find the launch (starts at 0)
     */
    private static final int LAUNCH_NAME_LEVEL = 2;

    /**
     * Returns the resource of the launch the provided resource belongs to
     *
     * @param resource Resource to check
     * @return Resource of the launch the provided resource belongs to
     */
    public static Resource getLaunchResource(Resource resource) {
		return null;
	}

    /**
     * Returns the launch resource path corresponding to the provided launch-based path
     *
     * @param path The launch-based path
     * @return Launch resource path corresponding to the provided launch-based path
     *         or <code>null</code> if provided path does not belong to a launch
     */
    public static String getLaunchPath(String path) {
		return null;
	}

    /**
     * Returns the launch resource path from the provided launch name
     *
     * @param launchName The launch name
     * @return Launch resource path from the provided launch name
     */
    public static String getLaunchPathFromName(String launchName) {
		return null;
	}

    /**
     * Returns the production resource path corresponding to the provided launch-based resource path
     *
     * @param path The launch-based resource path
     * @return Production resource path corresponding to the provided launch-based resource path
     *         or the provided path if it isn't a launch-based resource path
     */
    public static String getProductionResourcePath(String path) {
		return null;
	}

    /**
     * Returns <code>true</code> if the provided path is a launch-based path
     *
     * @param path The path to check
     * @return <code>true</code> if the provided path is a launch-based path
     */
    public static boolean isLaunchBasedPath(String path) {
		return false;
	}

    /**
     * Returns <code>true</code> if the provided path is a launch-based path
     * within the provided launch path
     *
     * @param path       The path to check
     * @param launchPath The launch path
     * @return <code>true</code> if the provided path is a launch-based path
     * within the provided launch path
     */
    static boolean isLaunchBasedPath(String path, String launchPath) {
		return false;
	}

    /**
     * Returns <code>true</code> if the provided path is a launch resource path
     *
     * @param path Path to check
     * @return <code>true</code> if the provided path is a launch resource path
     */
    public static boolean isLaunchResourcePath(String path) {
		return false;
	}

    /**
     * Returns the launch resource path corresponding to a provided path and a launch name
     *
     * @param path       The path to build the launch resource path from
     * @param launchName Launch name
     * @return Returns the resource path within the provided launch or <code>null</code> if the provided path is already
     *         a launch-based resource path from a different launch than the provided one
     */
    public static String buildLaunchResourcePath(String path, String launchName) {
		return null;
	}
    
}
