/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.auth.saml.configuration;

import java.io.IOException;
import java.io.InputStream;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;

import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.api.resource.ValueMap;

/**
 * Defines configuration of the saml identity provider.
 *
 * This class currently contains a hard coded set of configuration information
 * specific to sitecatalyst post binding, however it should evolve to support
 * a more dynamic IDP metadata based set of configuration information.
 *
 * TODO LK Rewrite Certificate Handling after we have a proper KeyStore in Granite
 * @author jasonhightower
 */
public class IdpConfiguration {
	/**
	 * Url where saml requests should be sent.
	 */
	private String idpPostUrl;

    /**
     * Url where saml logout requests should be sent.
     */
    private String idpLogoutPostUrl;

    /**
     * Path where the public key of the IdP can be found
     */
    private String KEY_ROOT = "/etc/key/saml";

    /**
     * Name of the node holding the public certificate of the IdP
     */
    private String IDP_CERT = "idp_cert";

    private ResourceResolverFactory resourceResolverFactory;

    /**
     * Sets the ResourceResolverFactory instance to use when creating a ResourceResolver.
     * @param resourceResolverFactory ResourceResolverFactory instance used to create a ResourceResolver.
     */
    public void setResourceResolverFactory(final ResourceResolverFactory resourceResolverFactory) {
	}

    /**
	 * Creates a new instance of IdpConfiguration.
	 */
	public IdpConfiguration() {
		super();
	}

	/**
	 * Sets the url where saml requests should be sent.
	 * @param idpPostUrl String containing the url where saml requests should be sent.
	 */
	public void setIdpPostUrl(final String idpPostUrl) {
	}
	
	public void setIdpLogoutPostUrl(final String idpLogoutPostUrl) {
	}

	/**
	 * Gets the url where saml requests should be sent.
	 * @return String containing the url where saml requests should be sent.
	 */
	public String getIdpPostUrl() {
		return null;
	}

    public Certificate getCertificate() {
		return null;
	}

    public String getIdpLogoutPostUrl() {
		return null;
	}

}
