/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.auth.saml.configuration;

import java.security.Key;

import com.adobe.granite.auth.saml.util.KeyProvider;

/**
 * Defines configuration information for the service provider.
 * 
 * @author jasonhightower
 */
public class SpConfiguration {

	/**
	 * String id that identifies the service provider with the identity provider.
	 */
	private String entityId;
	
	/**
	 * KeyProvider used to retrieve the Key for decrypting saml messages.
	 */
	private KeyProvider keyProvider;

    /***
     * Use encryption for SAML Messages
     */
    private boolean useEncryption;

    /**
	 * Creates a new instance of SpConfiguration with the given KeyProvider.
	 * @param keyProvider KeyProvider used to retrieve a key for decrypting saml messages.
	 */
	public SpConfiguration(final KeyProvider keyProvider) {
		super();
		this.keyProvider = keyProvider;
	}
	
	/**
	 * Sets the id that identifies the service provider with the identity provider.
	 * @param entityId String containing the service provider id.
	 */
	public void setEntityId(final String entityId) {
	}
	
	/**
	 * Gets the id that identifies the service provider with the identity provider.
	 * @return String containing the service provider id.
	 */
	public String getEntityId() {
		return null;
	}
	
	/**
	 * Gets the private Key used to decrypt saml messages.
	 * @return Key used to decrypt saml messages.
	 */
	public Key getDecryptionKey() {
		return null;
	}
	
    public boolean getUseEncryption() {
		return false;
	}

    public void setUseEncryption(boolean useEncryption) {
	}
}
