/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.auth.saml.util;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;

import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.granite.auth.saml.util.io.Siphon;


/**
 * KeyProvider implementation which retrieves the private key and public certificate from a
 * specific location in the JCR repository.
 * <p/>
 * TODO LK Rewrite this after we get a proper KeyStore in Granite
 *
 * @author jasonhightower
 */
public class SlingKeyProvider implements KeyProvider {

    /**
     * Root path where the private key and public certificate are stored.
     */
    static final String KEY_ROOT = "/etc/key/saml";

    /**
     * Name of the node where the private key is stored.
     */
    static final String PRIVATE_KEY = "private";

    /**
     * Name of the node where the public key is stored.
     */
    static final String PUBLIC_CERT = "public";

    /**
     * ResourceResolverFactory used to acquire an administrative ResourceResolver.
     */
    private ResourceResolverFactory resourceResolverFactory;

    private Siphon siphon = new Siphon();

    /**
     * Creates a new instance of JcrKeyProvider.
     */
    public SlingKeyProvider() {
        super();
    }

    /**
     * Sets the ResourceResolverFactory instance to use when creating a ResourceResolver.
     *
     * @param resourceResolverFactory ResourceResolverFactory instance used to create a ResourceResolver.
     */
    public void setResourceResolverFactory(final ResourceResolverFactory resourceResolverFactory) {
	}

    // -- KeyProvider --


    public Key getDecryptionKey() {
		return null;
	}

    public Certificate getPublicCertificate() {
		return null;
	}

}
