/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.oauth.server;

import aQute.bnd.annotation.ProviderType;

/**
 * The <code>OAuth2AuthorizationEndpoint</code> provides a simple API to 
 * handle client information of an OAuth Authorization Server  as defined in 
 * http://tools.ietf.org/html/rfc6749
 *
 */
@ProviderType
public interface OAuth2AuthorizationServer {
    
    /**
     * Get the client name of the given OAuth client 
     * 
     * @param clientId The OAuth clientId
     * @return the client name of the given OAuth client or 
     * <code>null</code> if the client does not exist
     */
    public String getClientName(String clientId) {
		return null;
	}
}
