/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.granite.translation.api;

import org.apache.sling.api.resource.Resource;

/**
 * The TranslationServiceFactory is responsible for creating TranslationService objects for a specific
 * connector.  It also registers the connector with the TranslationManager using a unique identifier ("Name").
 */
public interface TranslationServiceFactory {

    /**
     * Creates a new TranslationService object specific to this Factory.
     * @param resource The resource containing the content to be translated.  May be null.
     *
     * @return A TranslationService instance for the given factory.
     */
    TranslationService createTranslationService(Resource resource) throws TranslationException {
		return null;
	}

    /**
     * @return Name of the service property indicating the particular implementation this factory provides,
     * e.g. adobe.
     */
    String getServiceFactoryName() {
		return null;
	}

    /**
     * Unique name of the service property indicating the particular implementation this factory provides,
     * e.g. microsoft.
     */
    static final String PROPERTY_TRANSLATION_FACTORY = "translationFactory";

}