/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import com.adobe.granite.xss.XSSAPI;

/**
 * A builder to generate HTML attributes. This builder is designed to be secured
 * using {@link XSSAPI}. It will encode the value automatically. If the value is
 * <code>null</code>, it will be ignored.
 */
public class AttrBuilder {
    private final HttpServletRequest req;

    private final XSSAPI xssAPI;

    private Map<String, String> data = new LinkedHashMap<String, String>();

    private Set<String> classes = new HashSet<String>();

    public AttrBuilder(HttpServletRequest req, XSSAPI xssAPI) {
        this.req = req;
        this.xssAPI = xssAPI;
    }

    /**
     * Adds relationship. Currently it is implemented as <code>class</code>
     * attribute.
     */
    public void addRel(String value) {
	}

    /**
     * Adds <code>class</code> attribute with the given value.
     */
    public void addClass(String value) {
	}

    /**
     * Adds an attribute that behave like <code>href</code> attribute. i.e. the
     * value will be prepended with context path (if absolute path) and checked
     * using {@link XSSAPI#getValidHref(String)}.
     */
    public void addHref(String name, String value) {
	}

    /**
     * Adds <code>disabled</code> attribute.
     */
    public void addDisabled(boolean disabled) {
	}

    /**
     * Adds <code>checked</code> attribute.
     */
    public void addChecked(boolean checked) {
	}

    /**
     * Adds <code>selected</code> attribute.
     */
    public void addSelected(boolean selected) {
	}
    
    /**
     * Adds <code>multiple</code> attribute.
     */
    public void addMultiple(boolean multiple) {
	}

    /**
     * Adds boolean attribute (behaves like <code>disabled</code>) for the given name.
     * When the given value is <code>true</code>, it will be printed as "disabled='disabled'", instead of "disabled='true'".
     * When the given value is <code>false</code>, it will NOT be printed, instead of "disabled='false'".
     */
    public void addBoolean(String name, boolean value) {
	}

    /**
     * Adds the given name as data-* attribute.
     */
    public void addOther(String name, String value) {
	}

    /**
     * Adds the given data as data-* attributes. Entries with keys specified in
     * exclusions parameter or having namespace (e.g. jcr:primaryType) will be
     * excluded.
     */
    public void addOthers(Map<String, Object> data, String... exclusions) {
	}
    
    /**
     * Adds attribute with the given name. The value will be added to existing attribute using space-delimited convention.
     * e.g. class="class1 class2" 
     */
    public void add(String name, Boolean value) {
	}
    
    /**
     * Adds attribute with the given name. The value will be added to existing attribute using space-delimited convention.
     * e.g. class="class1 class2" 
     */
    public void add(String name, Integer value) {
	}
    
    /**
     * Adds attribute with the given name. The value will be added to existing attribute using space-delimited convention.
     * e.g. class="class1 class2" 
     */
    public void add(String name, Double value) {
	}

    /**
     * Adds attribute with the given name. The value will be added to existing attribute using space-delimited convention.
     * e.g. class="class1 class2" 
     */
    public void add(String name, String value) {
	}
    
    /**
     * Sets attribute with the given name. Existing value previously set will be replaced by the given value.
     */
    public void set(String name, String value) {
	}
    
    private void addNoCheck(String name, String v) {
	}
    
    /**
     * Returns <code>true</code> if there is no attribute in this builder; <code>false</code> otherwise.
     */
    public boolean isEmpty() {
		return false;
	}

    /**
     * Builds the attributes in the form of ( <attr-name>='<attr-value>')*.
     */
    public String build() {
		return null;
	}
    
    /**
     * Builds the attributes in the form of ( <attr-name>='<attr-value>')*.
     */
    public void build(Writer out) throws IOException {
	}
}
