/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.net.URLDecoder;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.Cookie;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;

/**
 * Is a toolkit to receive the client state for DOM attributes out of Coral UI's util.state.
 * It's purpose is to receive the values from the HTTP request and either transform it to
 * an JSON object or to add them to an existing AttrBuilder
 */
public class ClientState {

    private final String COOKIE_NAME = "cui-state";
    private final String STATE_GLOBAL_NAMESPACE = "global";

    private SlingHttpServletRequest slingRequest;
    private JSONObject json = null;

    public ClientState(SlingHttpServletRequest slingRequest) {
        this.slingRequest = slingRequest;

        Cookie cookie = slingRequest.getCookie(COOKIE_NAME);

        try {
            String cookieVal = URLDecoder.decode(cookie.getValue(), "UTF-8");
            json = new JSONObject(cookieVal);
        } catch (Exception ex) {
            json = null;
        }
    }

    private void addAttribute(AttrBuilder attr, String attribute, JSONObject attributeJson) throws JSONException {
	}

    /**
     * Returns all attributes from the global namespace for the given selector
     *
     * @param selector
     * @return
     */
    public JSONObject getState(String selector) {
		return null;
	}

    /**
     * Returns all attributes from a given namespace for the given selector
     *
     * @param selector
     * @param namespace
     * @return
     */
    public JSONObject getState(String selector, String namespace) {
		return null;
	}

    /**
     * Returns all attributes which keys are included in the attributes array
     * from the global namespace for the given selector
     *
     * @param selector
     * @param attributes
     * @return
     */
    public JSONObject getState(String selector, String[] attributes) {
		return null;
	}

    /**
     * Returns all attributes which keys are included in the attributes array
     * from a given namespace for the given selector
     *
     * @param selector
     * @param attributes
     * @param namespace
     * @return
     */
    public JSONObject getState(String selector, String[] attributes, String namespace) {
		return null;
	}

    /**
     * Adds all attributes from the global namespace for the given selector to an AttrBuilder
     *
     * @param attr
     * @param selector
     * @return
     */
    public boolean restoreState(AttrBuilder attr, String selector) {
		return false;
	}

    /**
     * Adds all attributes from a given namespace for the given selector to an AttrBuilder
     *
     * @param attr
     * @param selector
     * @param namespace
     * @return
     */
    public boolean restoreState(AttrBuilder attr, String selector, String namespace) {
		return false;
	}

    /**
     * Adds all attributes which keys are included in the attributes array
     * from the global namespace for the given selector to an AttrBuilder
     *
     * @param attr
     * @param selector
     * @param attributes
     * @return
     */
    public boolean restoreState(AttrBuilder attr, String selector, String[] attributes) {
		return false;
	}

    /**
     * Adds all attributes which keys are included in the attributes array
     * from a given namespace for the given selector to an AttrBuilder
     *
     * @param attr
     * @param selector
     * @param attributes
     * @param namespace
     * @return
     */
    public boolean restoreState(AttrBuilder attr, String selector, String[] attributes, String namespace) {
		return false;
	}
}
