/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.util.Map;
import java.util.Map.Entry;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.apache.sling.jcr.resource.JcrResourceConstants;

/**
 * A builder to create a layout. A layout is a configuration map consisting a set of properties. A layout at very least
 * requires a <code>name</code> property.
 */
public class LayoutBuilder {
    private static final String NAME = "name";

    private JSONObject result;
    private String resourceType;
    private ValueMap vm;

    /**
     * Builds a layout from the given config. The actual layout resource is retrieved based on {@link Config#LAYOUT}
     * path. This method doesn't set default resource type of layout, use {@link #from(Config, String)} or
     * {@link ComponentHelper#getLayout()} instead.
     */
    public static LayoutBuilder from(Config config) {
		return null;
	}

    /**
     * Builds a layout from the given config. The actual layout resource is retrieved based on {@link Config#LAYOUT}
     * path. The given defaultResourceType will be used when sling:resourceType property of the resource is not set.
     */
    public static LayoutBuilder from(Config config, String defaultResourceType) {
		return null;
	}

    /**
     * Builds a layout from the given resource. This method doesn't set default resource type of layout, use
     * {@link #from(Resource, String)} or {@link ComponentHelper#getLayout()} instead.
     */
    public static LayoutBuilder from(Resource resource) {
		return null;
	}

    /**
     * Builds a layout from the given resource. The given defaultResourceType will be used when sling:resourceType
     * property of the resource is not set.
     */
    public static LayoutBuilder from(Resource resource, String defaultResourceType) {
		return null;
	}
    
    private void init() {
	}

    /**
     * <code>true</code> if this layout has name. <code>false</code> otherwise.
     */
    public boolean hasName() {
		return false;
	}

    /**
     * Returns the name of this layout.
     */
    public String getName() {
		return null;
	}

    /**
     * Sets the name of this layout.
     */
    public void setName(String name) {
	}

    /**
     * Returns the resource type of this layout. This will be used to point to the renderer of the layout using standard
     * Sling mechanism.
     */
    public String getResourceType() {
		return null;
	}

    /**
     * Sets the resource type of this layout.
     */
    public void setResourceType(String resourceType) {
	}

    /**
     * Adds the given key-value pair of property to this layout.
     */
    public void add(String key, Object value) {
	}

    /**
     * Adds a map of properties to this layout. Entry with key having a namespace (e.g. jcr:primaryType) will be
     * excluded.
     */
    public void add(Map<String, Object> data) {
	}

    /**
     * Returns this layout as JSON.
     */
    public JSONObject toJSON() {
		return null;
	}
}
