/***************************************************************************/
/*                                                                         */
/*                      ADOBE CONFIDENTIAL                                 */
/*                      _ _ _ _ _ _ _ _ _ _                                */
/*                                                                         */
/*  Copyright 2006, Adobe Systems Incorporated                             */
/*  All Rights Reserved.                                                   */
/*                                                                         */
/*  NOTICE: All information contained herein is, and remains the property  */
/*  of Adobe Systems Incorporated and its suppliers, if any.  The          */
/*  intellectual and technical concepts contained herein are proprietary   */
/*  to Adobe Systems Incorporated and its suppliers and may be coveredby   */
/*  U.S. and Foreign Patents, patents in process, and are protected by     */
/*  trade secret or copyright law.  Dissemination of this information or   */
/*  reproduction of this material is strictly forbidden unless prior       */
/*  written permission is obtained from Adobe Systems Incorporated.        */
/*                                                                         */
/***************************************************************************/

package com.adobe.versioncue.nativecomm.msg;

import java.util.Date;

/**
 * @author  <a href="mailto:tnaroska@adobe.com">Timo Naroska</a>
 * @version $Revision: #1 $
 */
public final class NCDate extends NCType
{
	// --------------------------------------------------------------------------- Private Variables

	/** long value */
	private final long millis; 

	// -------------------------------------------------------------------------- Public Constructor

	/** Public constructor
	 * @param value date value
	 */
	public NCDate(Date value)
	{
		this.millis = value.getTime();
	}

	/** Public constructor
	 * @param millis date value
	 */
	public NCDate(long millis)
	{
		this.millis = millis;
	}

	// ------------------------------------------------------------------------------ Public Methods

	/** @return date value */
	public long millis()
	{
		return 0L;
	}

	/** @return date value */
	public Date date()
	{
		return null;
	}

	@Override
	public int getType()
	{
		return 0;
	}

	@Override
	public int hashCode()
	{
		return 0;
	}

	@Override
	public boolean equals(Object other)
	{
		return false;
	}

	@Override
	public String toString()
	{
		return null;
	}
}
