/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.activitystreams.api;

import com.adobe.granite.security.user.UserProperties;
import com.adobe.granite.security.user.UserPropertiesManager;
import com.day.cq.security.profile.Profile;
import com.day.cq.security.profile.ProfileManager;
import org.apache.sling.api.resource.Resource;

import javax.jcr.Session;
import java.util.Iterator;

public class Utils {
    /**
     * Returns the formatted name of the activity creator.
     * @param session JCR session
     * @param profileManager Profile manager for the profile lookup
     * @param activity Lookup for this <code>Activity</code> creator
     * @return The formatted name if creator is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     * @deprecated Use {@link #getCreatedByFormattedName(com.adobe.granite.security.user.UserPropertiesManager, Activity)} instead.
     */
    @Deprecated
    public static String getCreatedByFormattedName(Session session, ProfileManager profileManager, Activity activity) throws Exception {
		return null;
	}

    /**
     * Returns the formatted name of the activity creator.
     * @param session JCR session
     * @param profileManager Profile manager for the profile lookup
     * @param activity Lookup for this <code>Activity</code> creator
     * @return The formatted name if creator is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     * @deprecated Use {@link #getCreatedByAvatar(com.adobe.granite.security.user.UserPropertiesManager, Activity)} instead.
     */
    @Deprecated
    public static String getCreatedByAvatar(Session session, ProfileManager profileManager, Activity activity) throws Exception {
		return null;
	}

    /**
     * Returns the formatted name of an authorizable.
     * @param session JCR session
     * @param profileManager Profile manager for the profile lookup
     * @param authorizableId Lookup for this authorizable
     * @return The formatted name if authorizable is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     * @deprecated Use {@link #getFormattedName(com.adobe.granite.security.user.UserPropertiesManager, String)} instead.
     */
    @Deprecated
    public static String getFormattedName(Session session, ProfileManager profileManager, String authorizableId) throws Exception {
		return null;
	}

    /**
     * Returns the formatted name of the activity creator.
     * @param upm User Properties manager for the profile lookup
     * @param activity Lookup for this <code>Activity</code> creator
     * @return The formatted name if creator is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     */
    public static String getCreatedByFormattedName(UserPropertiesManager upm, Activity activity) throws Exception {
		return null;
	}

    /**
     * Returns the formatted name of the activity creator.
     * @param upm User Properties manager for the profile lookup
     * @param activity Lookup for this <code>Activity</code> creator
     * @return The formatted name if creator is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     */
    public static String getCreatedByAvatar(UserPropertiesManager upm, Activity activity) throws Exception {
		return null;
	}

    /**
     * Returns the formatted name of an authorizable.
     * @param upm User Properties manager for the profile lookup
     * @param authorizableId Lookup for this authorizable
     * @return The formatted name if authorizable is found. Empty string otherwise
     * @throws Exception If exception during profile lookup
     */
    public static String getFormattedName(UserPropertiesManager upm, String authorizableId) throws Exception {
		return null;
	}
}
