/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons;

import static com.day.cq.commons.jcr.JcrConstants.JCR_DESCRIPTION;
import static com.day.cq.commons.jcr.JcrConstants.JCR_TITLE;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.RepositoryException;
import javax.jcr.observation.Event;
import javax.jcr.observation.EventIterator;
import javax.jcr.observation.EventListener;
import javax.jcr.observation.ObservationManager;
import javax.jcr.query.Query;
import javax.jcr.query.QueryManager;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Small tool to gather all consoles once. and update if changed.
 * If the console util object is not needed anymore {@link #dispose()}
 * should be called.
 */
public class ConsoleUtil implements EventListener {

    private static final String NT_CONSOLE = "cq:Console";

    private static final String PR_CONSOLE_TITLE = "consoleTitle";
    private static final String PR_CONSOLE_DESCRIPTION = "consoleDescription";
    private static final String PR_VANITY_PATH = "sling:vanityPath";

    private static final String QUERY_BASE = "SELECT * FROM ";
    private static final String QUERY_CONSOLE = QUERY_BASE + NT_CONSOLE;

    private static final String CLAUSE_ORDER = " ORDER BY sling:vanityOrder DESC";

    private final QueryManager queryManager;

    private final ObservationManager observationManger;

    private boolean observationRegistered;

    private final String[] queries;

    private Collection<Console> consoles;

    private final static Logger log = LoggerFactory.getLogger(ConsoleUtil.class);

    /**
     * Construct a Tool with Query- and Observation-facility to gather list of cq:Console node types.
     * If this object is not needed anymore {@link #dispose()} should be called.
     * @param queryManager to search for consoles
     * @param observationManger to update list if changes
     * @param searchPath resolvers search path to limit search
     */
    public ConsoleUtil(QueryManager queryManager, ObservationManager observationManger, String[] searchPath) {
        this.queryManager = queryManager;
        this.observationManger = observationManger;
        this.queries = new String[searchPath.length];
        if (searchPath.length>0) {
            for (int i=0;i<searchPath.length;i++) {
                StringBuffer whereClaus = new StringBuffer(" WHERE ");
                String path = searchPath[i];
                whereClaus.append(" jcr:path LIKE '").append(path);
                if (!path.endsWith("/")) {
                    whereClaus.append("/");
                }
                whereClaus.append("%'");
                this.queries[i] = QUERY_CONSOLE + whereClaus.toString() + CLAUSE_ORDER;
            }
        }
        this.observationRegistered = false;
    }

    /**
     * Dispose this object.
     * Remove the observation listener.
     */
    public void dispose() {
	}

    private void removeObservationListener() {
	}

    /**
     * @return access the list of paths known to the repository
     */
    public Collection<Console> getPaths() {
		return null;
	}

    //------------------------------------------------< EventListener >---------
    /**
     * Just clean list until requested next time
     * @param eventIterator of all events of this save
     */
    public void onEvent(EventIterator eventIterator) {
	}

    /**
     * @return search all nodes for specified console type using query-manager
     * @throws RepositoryException in case of error accessing repository
     */
    private Collection<Console> collectConsoles() throws RepositoryException {
		return null;
	}
}
