/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons.jcr;

import javax.jcr.RepositoryException;
import javax.jcr.Session;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.sling.api.SlingException;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.jcr.api.SlingRepository;
import org.apache.sling.jcr.resource.JcrResourceResolverFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Abstract SCR-Service which registers for a
 * {@link org.apache.sling.jcr.resource.JcrResourceResolverFactory JcrContentManager} and
 * a {@link org.apache.sling.jcr.api.SlingRepository Repository}.<br>
 * Can be used for services with Repository-Access.<br>
 *
 * @deprecated CQ 5.6 - extending this class made it too easy to use admin access without really
 *     noticing it (#42007).
 */
@Component(componentAbstract = true, metatype = false)
@Reference(name = "repository", referenceInterface = SlingRepository.class, policy = ReferencePolicy.STATIC)
public abstract class AbstractRepositoryService {

    /**
     * admin session
     */
    private Session adminSession;

    @Reference(policy = ReferencePolicy.STATIC)
    protected JcrResourceResolverFactory resourceManagerFactory;

    private SlingRepository repository;

    protected Logger logger = LoggerFactory.getLogger(AbstractRepositoryService.class);

    protected final void bindRepository(SlingRepository repo) {
	}

    protected final void unbindRepository(SlingRepository repo) {
	}

    protected Session createSession(SlingRepository repo) throws RepositoryException {
		return null;
	}
    
    protected SlingRepository getRepository() {
		return null;
	}

    protected void closeSession(Session session) {
	}

    protected Session getAdminSession() {
		return null;
	}

    protected ResourceResolver getResourceResolver() throws SlingException {
		return null;
	}

}
