/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.api.jobs;

import java.util.Date;
import java.util.Set;
import java.util.zip.ZipOutputStream;

import org.apache.sling.api.resource.Resource;

public interface AssetDownloadService {
    /**
     * Test URL params to see if this request should go to S7 (has image format or image presets)
     * @param configResource 
     *          Resource
     * @param downloadSet 
     *          Set<Resource>: Set of JcrNodeResource, which includes assets' info
     * @param downloadAssets
     *          boolean
     * @param downloadRenditions
     *          boolean
     * @param downloadSubassets
     *          boolean
     * @param s7ExportSettings
     *          String: it could be an imagePreset or a string of several modifiers; No s7export if this is null
     * @param exportDate
     *          Date: the export could be scheduled or execute immediately if this is null
     * @param out 
     *          ZipOutputStream, pass the output stream filter for the archive downloading
     * @param downloadName 
     *          String: download job name
     * @param emailRecipients 
     *          String: email recipients
     * @return boolean 
     *          true: if download is processed successfully; false if otherwise
     * @return String: downloadUrl if the archive file is stored in jcr
     */	
    String assetDownload(final Resource configResource, Set<Resource> downloadSet, boolean downloadAssets, boolean downloadRenditions, boolean downloadSubassets, String s7ExportSettings, Date date, ZipOutputStream out, String downloadName, String emailRecipients) {
		return null;
	}
}
