/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.dam.commons.util;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.jcr.RepositoryException;

import com.day.cq.search.Predicate;
import com.day.cq.search.PredicateConverter;
import com.day.cq.search.PredicateGroup;
import com.day.cq.search.eval.FulltextPredicateEvaluator;
import com.day.cq.search.eval.JcrPropertyPredicateEvaluator;

import com.day.cq.search.eval.RangePropertyPredicateEvaluator;
import com.day.cq.tagging.impl.search.TagSearchPredicateEvaluator;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;

import org.apache.sling.api.resource.ValueMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class GQLConverter {

    private static final String OR_OP               = "OR";
    private static final String TAGS_PROP           = "tags";
    private static final String DATERANGE_PRED      = "daterange";
    private static final String RANGEPROP_PRED      = "rangeproperty";
    private static final String JCR_PROPERTIES_PATH = "/var/dam/content/formitems";

    private static final Logger log = LoggerFactory.getLogger(GQLConverter.class);

    /**
     * Parse and converts GQL statement from fulltext in conditions to QueryBuilder PredicateGroup.
     *
     * @param conditions the map containing initial conditions and fulltext to be processed
     * @param resolver   to resolve node containing gql to jcr properties mapping
     * @return PredicateGroup containing conditions merged with new conditions formed from fulltext
     * @throws RepositoryException
     */
    public static PredicateGroup buildQuery(Map conditions, ResourceResolver resolver) throws RepositoryException {
		return null;
	}

    /**
     * Collects fulltext from all fulltext predicates in predicateGroup which are valid GQL expressions
     * and also removes such predicates from predicateGroup
     * @param predicateGroup PredicateGroup to be processed
     * @return List of valid gql expressions
     *
     */
    private static List<String> getValidGQLStatements(PredicateGroup predicateGroup) {
		return null;
	}

    /**
     * @param resolver to resolve node containing jcr properties mapping
     * @return map containing gql to jcr properties mapping
     * @throws RepositoryException
     */
    private static Map<String, String> getJcrPropertyMapping(ResourceResolver resolver) throws RepositoryException {
		return null;
	}

    /**
     * DAM level customization for different conditions
     *
     * @param predicateGroup PredicateGroup to be transformed
     * @param jcrPropertyMap mapping of properties to jcr properties
     */
    private static void transformPredicates(PredicateGroup predicateGroup, Map<String, String> jcrPropertyMap) {
	}

    private static void modifyPredicate(PredicateGroup parentGroup, Predicate predicate, int index, Map<String, String> jcrPropertyMap) {
	}
}