/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.commons.util;

import org.apache.commons.lang.StringUtils;

import com.day.cq.dam.api.Asset;
import com.day.image.Layer;

/**
 * The <code>OrientationUtil</code> helps in adjusting a {@link com.day.image.Layer}
 * to the orientation stored in the image's EXIF or TIFF metadata.
 */
public class OrientationUtil {
    public static final short ORIENTATION_NORMAL = 1;
    public static final short ORIENTATION_MIRROR_HORIZONTAL = 2;
    public static final short ORIENTATION_ROTATE_180 = 3;
    public static final short ORIENTATION_MIRROR_VERTICAL = 4;
    public static final short ORIENTATION_MIRROR_HORIZONTAL_ROTATE_270_CW = 5;
    public static final short ORIENTATION_ROTATE_90_CW = 6;
    public static final short ORIENTATION_MIRROR_HORIZONTAL_ROTATE_90_CW = 7;
    public static final short ORIENTATION_ROTATE_270_CW = 8;
    
    /** EXIF orientation property */
    static final String EXIF_ORIENTATION = "exif:Orientation";
    /** TIFF orientation property */
    static final String TIFF_ORIENTATION = "tiff:Orientation";

    /**
     * Check if asset contains metadata for orientation.
     * @param asset The asset
     * @return      <code>true</code> if orientation metadata exists
     */
    public static boolean hasOrientationMetadata(Asset asset) {
		return false;
	}

    /**
     * Get the exif orientation flag from the asset metadata.
     * @param asset the asset
     * @return the EXIF orientation flag (1-8)
     */
    public static short getOrientation(Asset asset) {
		return 0;
	}
    
    /**
     * Adjust the given layer to the orientation stored in the asset's metadata.
     * @param asset The asset
     * @param layer The layer
     */
    public static void adjustOrientation(Asset asset, Layer layer) {
	}
}
