/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.commons.util;

import java.util.Map;
import java.util.HashMap;

import org.apache.sling.api.resource.ModifiableValueMap;
import org.apache.sling.api.resource.PersistenceException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.granite.asset.api.Asset;
import com.adobe.granite.asset.api.AssetManager;
import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.dam.api.DamConstants;
import com.day.cq.dam.api.s7dam.constants.S7damConstants;
import com.day.cq.dam.api.s7dam.set.ImageSet;
import com.day.cq.dam.api.s7dam.set.MediaSet;
import com.day.cq.dam.api.s7dam.set.SpinSet;
import com.day.cq.dam.api.s7dam.set.SwatchSet;
/**
 * Helper methods for S7 Sets
 */
public class S7SetHelper {
	private static String MIME_TYPE = "Multipart/Related; type=application/x-";

	/**
	 * Helper method to create S7 <code>ImageSet</code>
	 * 
	 * @param parent
	 *            parent {@link Resource} where new set to be created
	 * @param name
	 *            name of the set to be created.
	 * @param props
	 *            additional properties to be saved i.e. jcr:title
	 * @return an instance of {@link ImageSet}
	 * @throws {@link PersistenceException} if there is any issue in creating
	 *         the set. 
	 *         {@link IllegalArgumentException} if the parent resource
	 *         is null or name is null
	 */
	public static ImageSet createS7ImageSet(Resource parent, String name,
			Map<String, Object> props) throws PersistenceException {
				return null;
			}

	private static Resource createS7Set(Resource parent, String name,
			Map<String, Object> props, String type) throws PersistenceException {
				return null;
			}

    private static Resource createS7Set(Resource parent, String name,
                                        Map<String, Object> props,
                                        String type,
                                        Map<String, Object> metadata) throws PersistenceException {
											return null;
										}
	/**
	 * Helper method to create S7 <code>SwatchSet</code>
	 * 
	 * @param parent
	 *            parent {@link Resource} where new set to be created
	 * @param name
	 *            name of the set to be created.
	 * @param props
	 *            additional properties to be saved i.e. jcr:title
	 * @return an instance of {@link SwatchSet}
	 * @throws {@link PersistenceException} if there is any issue in creating
	 *         the set. 
	 *         {@link IllegalArgumentException} if the parent resource
	 *         is null
	 */
	public static SwatchSet createS7SwatchSet(Resource parent, String name,
			Map<String, Object> props) throws PersistenceException {
				return null;
			}
	
	/**
     * Helper method to create S7 VideoSet
     * 
     * @param parent
     *            parent {@link Resource} where new set to be created
     * @param name
     *            name of the set to be created.
     * @param props
     *            additional properties to be saved i.e. jcr:title
     * @return an instance of {@link MediaSet}
     * @throws {@link PersistenceException} if there is any issue in creating
     *         the set. 
     *         {@link IllegalArgumentException} if the parent resource
     *         is null
     */
    public static MediaSet createS7VideoSet(Resource parent, String name,
            Map<String, Object> props) throws PersistenceException {
				return null;
			}
    
    /**
     * Helper method to create S7 Mixed Media Set
     * 
     * @param parent
     *            parent {@link Resource} where new set to be created
     * @param name
     *            name of the set to be created.
     * @param props
     *            additional properties to be saved i.e. jcr:title
     * @return an instance of {@link MediaSet}
     * @throws {@link PersistenceException} if there is any issue in creating
     *         the set. 
     *         {@link IllegalArgumentException} if the parent resource
     *         is null
     */
    public static MediaSet createS7MixedMediaSet(Resource parent, String name,
            Map<String, Object> props) throws PersistenceException {
				return null;
			}
    
    /**
     * Helper method to create spin Set
     * 
     * @param parent
     *            parent {@link Resource} where new set to be created
     * @param name
     *            name of the set to be created.
     * @param props
     *            additional properties to be saved i.e. jcr:title
     * @return an instance of {@link MediaSet}
     * @throws {@link PersistenceException} if there is any issue in creating
     *         the set. 
     *         {@link IllegalArgumentException} if the parent resource
     *         is null
     */
    public static SpinSet createS7SpinSet(Resource parent, String name,
            Map<String, Object> props) throws PersistenceException {
				return null;
			}

  	/**
	 * Checks whether the given resource represent a S7 set or not.
	 * @param resource resource instance
	 * @return <code>true</code> if the resource represent a S7 set
	 *         <code>false</code> if the resource is not a S7 set
	 * 
	 * @throws <code>NullPointerException</code> if resource is null
	 */
    public static boolean isS7Set(Resource resource) {
		return false;
	}
}
