/*
 * Copyright 1997-2010 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.handler.ffmpeg;

import java.io.File;
import java.util.ArrayList;
import java.util.Dictionary;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.SystemUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.commons.osgi.OsgiUtil;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Finds an executable on a configurable search path.
 *
 */ 
@Component(metatype = true, label = "Day CQ Executable Locator", description = "Locates command line executables")
@Service
@Properties({ @Property(name="service.description", value="CQ Executable Locator") })
public class LocatorImpl implements ExecutableLocator {

    private static final Logger log = LoggerFactory.getLogger(LocatorImpl.class);

    @Property(value={"/opt/local/bin", "/usr/local/bin", "PATH"})
    public static final String PROP_SEARCH_PATH = "executable.searchpath";

    private static final String PATH_ENV = "PATH";

    private static final String[] FALLBACK_SEARCH_PATH = { PATH_ENV };

    private List<String> searchPath;

    private File last;

    /**
     * Default constructor for SCR.
     */
    public LocatorImpl() {
    }

    /**
     * Constructor for non-OSGi component usage.
     * @param searchPath list of search paths
     */
    public LocatorImpl(String[] searchPath) {
        setSearchPath(searchPath);
    }

    protected void activate(final ComponentContext componentContext) {
	}

    protected void setSearchPath(String[] sp) {
	}

    public synchronized String getPath(String cmd) {
		return null;
	}

    public static String[] getPathEnv() {
		return null;
	}
}
