/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.handler.standard.msoffice;

import static com.day.cq.dam.api.DamConstants.DC_CREATOR;
import static com.day.cq.dam.api.DamConstants.DC_DESCRIPTION;
import static com.day.cq.dam.api.DamConstants.DC_TITLE;
import org.apache.poi.hpsf.wellknown.PropertyIDMap;


public class IdToNameMap extends PropertyIDMap {

    private static final PropertyIDMap summaryMap = new PropertyIDMap(18, (float) 1.0);
    private static final PropertyIDMap documentPropertyMap = new PropertyIDMap(17, (float) 1.0);
    static {
        summaryMap.put(PID_TITLE, DC_TITLE);
        summaryMap.put(PID_SUBJECT, DC_DESCRIPTION);
        summaryMap.put(PID_AUTHOR, DC_CREATOR);
        summaryMap.put(PID_KEYWORDS, "Keywords");
        summaryMap.put(PID_COMMENTS, "Comments");
        summaryMap.put(PID_TEMPLATE, "Template");
        summaryMap.put(PID_LASTAUTHOR, "LastAuthor");
        summaryMap.put(PID_REVNUMBER, "RevNumber");
        summaryMap.put(PID_EDITTIME, "EndTime");
        summaryMap.put(PID_LASTPRINTED, "LastPrinted");
        summaryMap.put(PID_CREATE_DTM, "CreateDateTime");
        summaryMap.put(PID_LASTSAVE_DTM, "LastSaveDateTime");
        summaryMap.put(PID_PAGECOUNT, "PageCount");
        summaryMap.put(PID_WORDCOUNT, "WordCount");
        summaryMap.put(PID_CHARCOUNT, "CharCount");
        summaryMap.put(PID_THUMBNAIL, "Thumbnail");
        summaryMap.put(PID_APPNAME, "creatortool");
        summaryMap.put(PID_SECURITY, "Security");
    }
    static {
        documentPropertyMap.put(PID_DICTIONARY, "Dictionary");
        documentPropertyMap.put(PID_CODEPAGE, "CodePage");
        documentPropertyMap.put(PID_CATEGORY, "Category");
        documentPropertyMap.put(PID_PRESFORMAT, "PresentationFormat");
        documentPropertyMap.put(PID_BYTECOUNT, "ByteCount");
        documentPropertyMap.put(PID_LINECOUNT, "LineCount");
        documentPropertyMap.put(PID_PARCOUNT, "ParCount");
        documentPropertyMap.put(PID_SLIDECOUNT, "SlideCount");
        documentPropertyMap.put(PID_NOTECOUNT, "NoteCount");
        documentPropertyMap.put(PID_HIDDENCOUNT, "HiddenCount");
        documentPropertyMap.put(PID_MMCLIPCOUNT, "MMClipCount");
        documentPropertyMap.put(PID_SCALE, "Scale");
        documentPropertyMap.put(PID_HEADINGPAIR, "HeadingPair");
        documentPropertyMap.put(PID_DOCPARTS, "DocParts");
        documentPropertyMap.put(PID_MANAGER, "Manager");
        documentPropertyMap.put(PID_COMPANY, "Company");
        documentPropertyMap.put(PID_LINKSDIRTY, "LinksDirty");
    }

    public IdToNameMap(java.util.Map map) {
        super(map);
    }

    static String getSummaryPropertyName(long id) {
		return null;
	}
    
    static String getDocumentPropertyName(long id) {
		return null;
	}
}
