/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.handler.standard.ooxml;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Service;
import org.apache.poi.xslf.usermodel.XMLSlideShow;
import org.apache.poi.xslf.usermodel.XSLFSlide;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.granite.asset.api.AssetManager;
import com.day.cq.dam.api.Asset;
import com.day.cq.dam.api.Rendition;
import com.day.image.Layer;

/**
 * Asset Handler for Open XML PPTX files, handles sub assets for PPTX as well.
 *
 */
@Component(inherit = true, metatype = false)
@Service
public class MSPowerPointOOXMLHandler extends OpenOfficeHandler {
	private static final String SUB_ASSET_PREFIX = "slide_";

	private static final String PPTX_EXT = ".pptx";

	private static final Logger log = LoggerFactory.getLogger(MSPowerPointOOXMLHandler.class);

	public static final String MIMETYPE_PPTX
    			= "application/vnd.openxmlformats-officedocument.presentationml.presentation";

	@Override
	public boolean canHandleSubAssets() {
		return false;
	}
	
	/**
     * {@inheritDoc}
     */
	@Override
    public String[] getMimeTypes() {
		return null;
	}
	
	private void removeSubAssets(final Asset asset, AssetManager assetManager) {
	}
    
	/**
	 * {@inheritDoc}
	 */
	@Override
    public List<String> processSubAssets(final Asset asset) {
		return null;
	}
	
	/**
     * To extract each slide, we need to delete not required slide and then save.
     * This process must be repeated for each slide that we want to extract.
     * 
     * extractSlide extracts a slide, given the slideNumber (starts at 1)
     */
    private XMLSlideShow extractSlide(final Asset asset, int slideNumber) {
		return null;
	}
    
    @Override
    public BufferedImage getImage(final Rendition rendition, Dimension dim) throws IOException {
		return null;
	}
}
