/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.scene7.api;

import com.day.cq.dam.api.Asset;

/**
 * The {@code Scene7DAMAssetService} is responsible for obtaining S7 related information about already imported DAM
 * assets.
 */
public interface Scene7DAMService {

    /**
     * For a DAM imported Scene7 asset, this method returns the file reference of the asset from Scene7.
     * This is actually the URL used to retrieve the Scene7 asset from the Scene7 public servers.
     * In case a DAM asset cannot be identified as an imported Scene7 asset, this method will return null.
     * @param asset the DAM asset
     * @return the URL to the Scene7 asset; null if the asset is not imported from Scene7
     */
    String getS7FileReference(Asset asset) {
		return null;
	}

    /**
     * For a DAM imported Scene7 asset, this method returns the file reference of the asset from Scene7.
     * This is actually the URL used to retrieve the Scene7 asset from the Scene7 public servers.
     * In case a DAM asset cannot be identified as an imported Scene7 asset, this method will return null.
     * @param asset the DAM asset
     * @param configPath Optional path to indicate what cloud configuration to use. If null, an attempt will be made to
     *                   extract the cloud config from the asset.
     * @return the URL to the Scene7 asset; null if the asset is not imported from Scene7
     */
    String getS7FileReference(Asset asset, String configPath) {
		return null;
	}
}
