/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.scene7.api;

import org.apache.sling.api.resource.ResourceResolver;

/**
 * The <code>Scene7Service</code> provides methods for interacting with the official Scene7 API.
 */
public interface Scene7UploadService {

    /**
     * Uploads a file at a given repository path to the Scene7 server.
     * 
     * @param path
     *            Path to the file in the repository
     * @param cloudServiceConfigPath
     * @param resolver               Sling ResourceResolver
     * @return String 'success' if upload finished successfully or a
     *         representation of the job handle if upload failed.
     */
    String uploadFile(String path, String cloudServiceConfigPath, ResourceResolver resolver) {
		return null;
	}

    /**
     * Uploads a folder at a given repository path to the Scene7 server.
     * 
     * @param path
     *            to the folder
     * @param cloudServiceConfigPath
     * @param resolver
     * @return String 'success' if upload finished successfully or a
     *         representation of the job handle if upload failed.
     */
    String uploadFolder(String path, String cloudServiceConfigPath, ResourceResolver resolver) {
		return null;
	}

    /**
     * Synchronises a file at a given repository path back into the Scene7 server.
     * 
     * @param path
     *            Path to the file in the repository
     * @param resolver
     *            Sling ResourceResolver
     * @return String 'success' if upload finished successfully or a representation of the job handle if upload failed.
     */
    String synchronizeFile(String path, ResourceResolver resolver) {
		return null;
	}

    /**
     * Moves an S7 managed file ( a file that has an associated S7 assetHandle) at a given repository path back into the Scene7 server.
     * 
     * @param path
     *            Path to the file in the repository
     * @param resolver
     *            Sling ResourceResolver
     * @return String 'success' if upload finished successfully or a representation of the job handle if upload failed.
     */
    String moveFile(String path, ResourceResolver resolver) {
		return null;
	}

    /**
     * Moves a folder (including sub folders/assets) back to the Scene7 server.
     * 
     * @param dstpath
     *            destination path to the file in the repository
     * @param srcpath
     *            Original path of the folder in the repository
     * @param resolver
     *            Sling ResourceResolver
     * @return String 'success' if upload finished successfully or a representation of the job handle if upload failed.
     */
    String moveFolder(String dstpath, String srcpath, ResourceResolver resolver) {
		return null;
	}
}
