/*
 * Copyright 1997-2004 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.graphics.chart;

import java.awt.Color;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.day.cq.graphics.Graph;
import com.day.image.Font;
import com.day.image.Layer;
import com.day.image.LineStyle;

/**
 * @author tripod
 */
public final class Axis {

    public static final int TYPE_NORMAL = 0;
    public static final int TYPE_INVERT = 1;
    public static final int TYPE_LOG = 2;
    public static final int TYPE_LOGINV = 3;
    public static final int TYPE_CATEG = 4;
    public static final int TYPE_CATEGINV = 5;

    public static final int NO_AXIS = '0';
    public static final int X_AXIS = 'x';
    public static final int Y_AXIS = 'y';
    public static final int U_AXIS = 'u';
    public static final int V_AXIS = 'v';

    public static final int LABEL_ABOVE = 0x00; /* for label type */
    public static final int LABEL_BELOW = 0x01;
    public static final int LABEL_RIGHT = 0x00;
    public static final int LABEL_LEFT = 0x10;
    public static final int LABEL_CENTER = 0x20;

    public static final int LABEL_TYPE_NUMBER = 0; /* uses labelformat with sprintf  */
    public static final int LABEL_TYPE_DATE = 1; /* uses labelformat with strftime */

    public static final int TITLE_POS_NONE = 0;
    public static final int TITLE_POS_ABOVE = 1;
    public static final int TITLE_POS_BELOW = 2;
    public static final int TITLE_POS_BOTH = 3;

    int width;
    int height;
    LineStyle style;

    // main ticks
    int tickfrom;
    int tickto;
    int tickdistance; // pixels
    int numticks;
    LineStyle tickstyle;

    // sub ticks
    int subtickfrom;
    int subtickto;
    // Color subtickColor;
    int subtickspertick;
    LineStyle subtickstyle;

    // labeling
    Font labelfont;
    Color labelcolor;
    int labeldx;
    int labeldy;
    int labelalign;
    int labelcs;
    int labelwidth;
    private String labelformat; // format string for sprintf
    private String sublabelformat; // format string for sprintf
    int labeltype;

    // range
    private double rangemin;
    private double rangemax;
    private double rangestep;
    private double rangescale;
    private double rangeoffset;
    private boolean rangeminset;
    private boolean rangemaxset;
    private boolean rangestepset;
    private boolean rangescaleset;
    private boolean rangeoffsetset;

    int rangetype; // see above ??

    // title
    int titlepos;
    double inflate = 1;

    // internal hack :-)
    int[] tickpos = new int[256];
    double[] ticksample = new double[256];

    // the axisdrawer 'method'
    private AxisDrawer axisDrawer;
    private int axisType;

    private Axis(Graph graph, int axisType) {
        setType(axisType);
    }

    public static Axis getInstance(Graph graph, int type)
            throws IllegalArgumentException {
				return null;
			}

    public static Axis getInstance(Graph graph) {
		return null;
	}

    public Layer draw(Graph graph, boolean doDraw) {
		return null;
	}

    private static interface AxisDrawer {
        public Layer draw(Graph graph, boolean doDraw) {
			return null;
		}
    }

    private final class XAxis implements AxisDrawer {

        public Layer draw(Graph graph, boolean doDraw) {
			return null;
		}

    }

    private final class YAxis implements AxisDrawer {
        public Layer draw(Graph graph, boolean doDraw) {
			return null;
		}
    }

    private final class VAxis implements AxisDrawer {
        public Layer draw(Graph graph, boolean doDraw) {
			return null;
		}
    }

    private class UAxis implements AxisDrawer {
        public Layer draw(Graph graph, boolean doDraw) {
			return null;
		}
    }

    //---------- internal ------------------------------------------------------

    /* package use */

    static String formatlabel(int type, String format, String label) {
		return null;
	}

    //---------- getter and setter for data ------------------------------------

    public double getRangemin() {
		return 0.0d;
	}

    public void setRangemin(double rangemin) {
	}

    public double getRangemax() {
		return 0.0d;
	}

    public void setRangemax(double rangemax) {
	}

    public double getRangestep() {
		return 0.0d;
	}

    public void setRangestep(double rangestep) {
	}

    public double getRangescale() {
		return 0.0d;
	}

    public void setRangescale(double rangescale) {
	}

    public double getRangeoffset() {
		return 0.0d;
	}

    public void setRangeoffset(double rangeoffset) {
	}

    public String getLabelformat() {
		return null;
	}

    public void setLabelformat(String labelformat) {
	}

    public String getSublabelformat() {
		return null;
	}

    public void setSublabelformat(String sublabelformat) {
	}

    public void setType(int type) throws IllegalArgumentException {
	}

    public int getType() {
		return 0;
	}

    //--------------------------------------------------------------------------

    public void setStyle(LineStyle style) {
	}

    public void setWidth(int width) {
	}

    public void setHeight(int height) {
	}

    public void setTickfrom(int tickfrom) {
	}

    public void setTickto(int tickto) {
	}

    public void setTickdistance(int tickdistance) {
	}

    public void setNumticks(int numticks) {
	}

    public void setTickstyle(LineStyle tickstyle) {
	}

    public void setSubtickfrom(int subtickfrom) {
	}

    public void setSubtickto(int subtickto) {
	}

    public void setSubtickspertick(int subtickspertick) {
	}

    public void setSubtickstyle(LineStyle subtickstyle) {
	}

    public void setLabelfont(Font labelfont) {
	}

    public void setLabelcolor(Color labelcolor) {
	}

    public void setLabeldx(int labeldx) {
	}

    public void setLabeldy(int labeldy) {
	}

    public void setLabelalign(int labelalign) {
	}

    public void setLabelcs(int labelcs) {
	}

    public void setLabelwidth(int labelwidth) {
	}

    public void setLabeltype(int labeltype) {
	}

    public void setRangetype(int rangetype) {
	}

    public void setTitlepos(int titlepos) {
	}

    public void setInflate(double inflate) {
	}

    public double getTickSample(int i) {
		return 0.0d;
	}

    public int getNumticks() {
		return 0;
	}
}