package com.day.cq.mcm.campaign;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

/**
 * Interface that represents the results of a call to a Adobe Campaign instance
 */
public interface CallResults {

    /**
     * Returns the (HTTP-) status of the call.
     *
     * @return The (HTTP-) status
     */
    int getStatus() {
		return 0;
	}

    /**
     * Retrieve a <code>Map</code> of the response headers.
     *
     * @return The response headers
     */
    Map<String, String> getResponseHeaders() {
		return null;
	}

    /**
     * Returns the body of the response as a stream.
     *
     * @return The stream to access the body of the response
     */
    InputStream bodyAsStream() throws IOException {
		return null;
	}

    /**
     * Returns the body of the response as a <code>String</code>.
     *
     * @return The body of the response
     */
    String bodyAsString() throws IOException {
		return null;
	}

    /**
     * Should be called after the results have been completely consumed by the client to
     * ensure resources are properly cleaned up
     */
    void destroy() {
	}

    /**
     * Returns the complete URL of the originating request (debugging purposes only!).
     *
     * @return The complete URL
     */
    String getCompleteURL() {
		return null;
	}

}
