package com.day.cq.mcm.campaign;

import com.day.cq.wcm.webservicesupport.Configuration;
import org.apache.sling.api.resource.Resource;

import java.util.Map;

/**
 * A service that is used to access a remote Adobe Campaign instance.
 */
public interface CampaignConnector {

    /**
     * Determines the webservice config to be used. This method respects inheritance.
     *
     * @param resource The resource to get the webservice config for
     * @return The webservice config
     * @throws ACConnectorException if there is no webservice config present
     */
    Configuration getWebserviceConfig(Resource resource) throws ACConnectorException {
		return null;
	}

    /**
     * <p>Retrieves the credentials from the specified webservice config.</p>
     *
     * @param config The webservice config
     * @return The credentials
     * @throws ACConnectorException if there were no credentials present or the credentials
     *                              could not be decrypted
     */
    CampaignCredentials retrieveCredentials(Configuration config)
            throws ACConnectorException {
		return null;
	}

    /**
     * <p>Calls a remote function on the campaign instance.</p>
     *
     * <p>Note that the caller is required to use {@link CallResults#destroy()} after
     * processing the result of the remote function call.</p>
     *
     * @param name The name of the function to be called
     * @param fctParams The parameters of the function call (name/value parameters)
     * @param credentials The credentials to be used for the call
     * @return The result of the function call
     * @throws ACConnectorException If the remote function could not be called
     */
    CallResults callFunction(String name, Map<String, String> fctParams,
                             CampaignCredentials credentials) throws ACConnectorException {
		return null;
	}

}
