/*
 * Copyright 1997-2011 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.opensocial.gadgets.servlet;

import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferenceCardinality;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.jackrabbit.api.JackrabbitSession;
import org.apache.jackrabbit.api.security.user.Authorizable;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestDispatcherOptions;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.opensocial.gadgets.servlet.security.InternalCQUserPreferencePostValidator;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * The <code>CQUserPreferenceServlet</code> stores and reads user profile
 * specific gadget configuration(s).<p/>
 * Resolves the configuration Node and forwards the request to the Default JSON
 * Renderer
 * @deprecated This class will be removed from a future version of the product.
 */
@Deprecated
@Component(metatype = false)
@Service(serviceFactory = true, value = Servlet.class)
@Properties({
        @Property(name = "service.description", value = "CQ OpenSocial User Preference Servlet"),
        @Property(name = "sling.servlet.selectors", value = "userprefs"),
        @Property(name = "sling.servlet.extensions", value = "json"),
        @Property(name = "sling.servlet.resourceTypes", value = "sling/servlet/default"),
        @Property(name = "sling.servlet.methods", value = {"GET", "POST"})
})
public class CQUserPreferenceServlet extends SlingAllMethodsServlet {

    private final static Logger log = LoggerFactory.getLogger(CQUserPreferenceServlet.class);
    private static final String PATH_GADGET_PREF = "/personalization/gadgets/";
    
    /**
     * Soco provides the implementation of this service, but it is only needed for preference
     * saves. And we'd like the opensocial servlets not to come and go if soco is updated.
     * So here we use OPTIONAL_UNARY and DYNAMIC settings along with a volatile storage modifier
     * to ensure any binding/unbinding of the service is seen as soon as feasible without
     * restarting this service.
     */
    @Reference(cardinality = ReferenceCardinality.OPTIONAL_UNARY, policy = ReferencePolicy.DYNAMIC)
    private volatile InternalCQUserPreferencePostValidator internalCQUserPreferencePostValidator;
    
    /**
     * Get user preferences from $HOME/personalization/gadgets/node-identifier if exist
     * */
    protected void doGet(SlingHttpServletRequest request, SlingHttpServletResponse response)
            throws ServletException, IOException {
			}

    /**
     * Post user preferences to $HOME/personalization/gadgets/node-identifier
     * */
    protected void doPost(SlingHttpServletRequest request, SlingHttpServletResponse response)
            throws ServletException, IOException {
			}

    private String getGadgetPath(SlingHttpServletRequest request) throws RepositoryException {
		return null;
	}

}
