/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.polling.importer;

/**
 * The <code>PollConfig</code> interface represents polling configurations
 * managed by the {@link PollingImporter} service.
 */
public interface PollConfig {

    /**
     * Returns the identification path of this configuration.
     */
    String getPath() {
		return null;
	}

    /**
     * Returns the scheme. This is used to select the appropriate
     * {@link Importer} to handle polling the data source of this configuration.
     */
    String getScheme() {
		return null;
	}

    /**
     * Returns the data source URL. This is given to the {@link Importer}
     * handling the {@link #getScheme()} of this configuration to acquire the
     * data.
     */
    String getSource() {
		return null;
	}

    /**
     * Returns the target path where the polled data is being stored. This is
     * used to create the <code>Resource</code> provided to the {@link Importer}
     * to import the data.
     */
    String getTarget() {
		return null;
	}

    /**
     * The active poll interval in seconds of this configuration.
     */
    long getInterval() {
		return 0L;
	}

    /**
     * The stored poll interval in seconds of this configuration.
     */
    long getStoredInterval() {
		return 0L;
	}
    
    /**
     * The enable state for the configuration.
     * @return
     */
    public boolean isEnabled() {
		return false;
	}
    
    /**
     * The login of this configuration.
     */
    public String getLogin() {
		return null;
	}

    /**
     * The password of this configuration.
     */
    public String getPassword() {
		return null;
	}

}