/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.replication;

import java.util.LinkedList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.nodetype.NodeType;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Implements an aggregate handler that detects hierarchy nodes as aggregate root.
 */
public class DefaultAggregateHandler implements AggregateHandler {

    /**
     * default logger
     */
    private static final Logger log = LoggerFactory.getLogger(DefaultAggregateHandler.class);

    /**
     * flag that controls if this handler should remove the nodes.
     */
    private boolean removeNodes;

    /**
     * Checks if this handler removes the nodes in the {@link #processForReplication(javax.jcr.Session, ReplicationAction)}
     * for a delete replication.
     * @return the remove nodes flag.
     */
    public boolean isRemoveNodes() {
		return false;
	}

    /**
     * Sets the flag that controls if this handler should remove the node in the
     * {@link #processForReplication(javax.jcr.Session, ReplicationAction)}. the default is <code>false</code>.
     * @param removeNodes the flag
     */
    public void setRemoveNodes(boolean removeNodes) {
	}

    /**
     * {@inheritDoc}
     *
     * @return <code>true</code> if the node is a hierarchy node.
     */
    public boolean isAggregateRoot(Node node) {
		return false;
	}

    /**
     * {@inheritDoc}
     *
     * Returns the all aggregate roots that match {@link #isAggregateRoot(javax.jcr.Node)} recursively, but only
     * for DELETE and DEACTIVATE action types.
     */
    public List<String> prepareForReplication(Session session, ReplicationActionType type, String path)
            throws ReplicationException {
				return null;
			}

    /**
     * Recursively collects the aggregate roots
     * @param root start node
     * @param paths list for the paths
     * @throws RepositoryException if an error occurrs
     */
    protected void collectAggregatePaths(Node root, List<String> paths) throws RepositoryException {
	}

    /**
     * {@inheritDoc}
     *
     * Deletes all paths passed by the action. but only for DELETE actions. The changes are not saved.
     */
    public void processForReplication(Session session, ReplicationAction action) throws ReplicationException {
	}

}