/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.replication;


/**
 * The <code>Preprocessor</code> is a service that is called
 * directly before the replication is started. All the checks
 * (permissions etc.) are already performed at this state.
 */
public interface Preprocessor {

    /**
     * Prepare a replication.
     * The processor is allowed to modify the content before
     * the replication like creating a version etc.
     * @param action The replication action
     * @param options The options
     * @throws ReplicationException
     */
    void preprocess(final ReplicationAction action,
                    final ReplicationOptions options)
    throws ReplicationException {
	}
}
