/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.replication;

/**
 * The <code>TransportContext</code> is used as context when replicating
 * content. Usually a context is created for each agent / transport handler pair.
 * The handler can use the context to store config dependant states and can assume
 * a new context for changed configuration.
 */
public interface TransportContext {

    String getName() {
		return null;
	}
    
    AgentConfig getConfig() {
		return null;
	}

    Discardable getAttribute(String name) {
		return null;
	}

    Discardable setAttribute(String name, Discardable attr) {
		return null;
	}

    interface Discardable {

        void discard() {
		}
    }
}