/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.rewriter.htmlparser;

import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.HashSet;
import java.util.Set;

import org.apache.felix.scr.annotations.Component;
import org.apache.sling.commons.osgi.OsgiUtil;
import org.xml.sax.ContentHandler;

import com.day.cq.rewriter.pipeline.Generator;
import com.day.cq.rewriter.processor.ProcessingComponentConfiguration;
import com.day.cq.rewriter.processor.ProcessingContext;

/**
 * HTML parser. Invokes a <code>DocumentHandler</code> whenever an event occurs.
 */
@Component(factory = "com.day.cq.rewriter.pipeline.Generator/htmlparser")
@Deprecated
public class HtmlParser extends Writer implements Generator {

    public static final String INCLUDE_TAGS_PROPERTY = "includeTags";

    /** Internal character buffer */
    private final CharArrayWriter buffer = new CharArrayWriter(256);

    /** Tag tokenizer */
    private final TagTokenizer tokenizer = new TagTokenizer();

    /** Tag name buffer */
    private final CharArrayWriter tagNameBuffer = new CharArrayWriter(30);

    /** Tag name */
    private String tagName;

    /** Tag inclusion list */
    private Set<String> tagInclusionSet;

    /** Registered document handler */
    private DocumentHandler documentHandler;

    /** Parse state constant */
    private final static int PS_OUTSIDE = 0;

    /** Parse state constant */
    private final static int PS_TAG = PS_OUTSIDE + 1;

    /** Parse state constant */
    private final static int PS_SCRIPT = PS_TAG + 1;

    /** Parse state constant */
    private final static int PS_COMMENT = PS_SCRIPT + 1;

    /** Parse state constant */
    private final static int PS_STRING = PS_COMMENT + 1;

    /** Tag type constant */
    private final static int TT_NONE = 0;

    /** Tag type constant */
    private final static int TT_MAYBE = 1;

    /** Tag type constant */
    private final static int TT_TAG = 2;

    /** Parse state */
    private int parseState;

    /** Parse substate */
    private int parseSubState;

    /** Previous parse state */
    private int prevParseState;

    /** Current tag type */
    private int tagType;

    /** Quote character */
    private char quoteChar;

    /** Did we already start parsing? */
    boolean started = false;

    /** indicates flag that forces a flush on the handler */
    boolean flushPending = false;

    /** flag that controls if flushing is allowed */
    boolean allowFlush = true;

    /** Only those tags are processed and passed to pipelines for processing */
    private static final Set<String> DEFAULT_INCLUSION_TAGS;
    static {
        DEFAULT_INCLUSION_TAGS = new HashSet<String>();
        DEFAULT_INCLUSION_TAGS.add("A");
        DEFAULT_INCLUSION_TAGS.add("/A");
        DEFAULT_INCLUSION_TAGS.add("IMG");
        DEFAULT_INCLUSION_TAGS.add("AREA");
        DEFAULT_INCLUSION_TAGS.add("FORM");
        DEFAULT_INCLUSION_TAGS.add("BASE");
        DEFAULT_INCLUSION_TAGS.add("LINK");
        DEFAULT_INCLUSION_TAGS.add("SCRIPT");
        DEFAULT_INCLUSION_TAGS.add("BODY");
        DEFAULT_INCLUSION_TAGS.add("/BODY");
    }

    /**
     * Default constructor.
     */
    public HtmlParser() {
        this.tagInclusionSet = DEFAULT_INCLUSION_TAGS;
    }

    /**
     * @see com.day.cq.rewriter.pipeline.Generator#init(com.day.cq.rewriter.processor.ProcessingContext,
     *      com.day.cq.rewriter.processor.ProcessingComponentConfiguration)
     */
    public void init(ProcessingContext pipelineContext,
                     ProcessingComponentConfiguration config) {
					}

    /**
     * @see com.day.cq.rewriter.pipeline.Generator#getWriter()
     */
    public PrintWriter getWriter() {
		return null;
	}

    public Set<String> getTagInclusionSet() {
		return null;
	}

    public void setTagInclusionSet(Set<String> tagInclusionSet) {
	}

    /**
     * @see com.day.cq.rewriter.pipeline.Generator#setContentHandler(org.xml.sax.ContentHandler)
     */
    public void setContentHandler(ContentHandler handler) {
	}

    /**
     * Set document handler. Allows a component to get notified about the
     * events, before characters are decomposed into attributes.
     *
     * @param documentHandler document handler
     */
    public void setDocumentHandler(DocumentHandler documentHandler) {
	}

    @Override
    public void write(char cbuf[], int off, int len) throws IOException {
	}

    @Override
    public void write(int b) throws IOException {
	}

    @Override
    public void close() throws IOException {
	}

    @Override
    public void flush() throws IOException {
	}

    /**
     * Feed characters to the parser.
     *
     * @param buf
     *            character buffer
     * @param off
     *            offset where characters start
     * @param len
     *            length of affected buffer
     */
    public void update(char[] buf, int off, int len) throws IOException {
	}

    /**
     * Return a flag indicating whether the parser has still some undigested
     * characters left.
     *
     * @return <code>true</code> if the parser still contains characters
     *         <code>false</code> otherwise
     */
    public boolean isEmpty() {
		return false;
	}

    /**
     * Finish the parsing process. This forces the parser to flush the
     * characters still held in its internal buffer, regardless of the parsing
     * state.
     */
    public void finished() throws IOException {
	}

    /**
     * Clears the internal tagname buffer and cache
     */
    protected void resetTagName() {
	}

    /**
     * Returns the tagname scanned and resets the internal tagname buffer
     *
     * @return tagname
     */
    protected String getTagName() {
		return null;
	}

    /**
     * Flush internal buffer. This forces the parser to flush the characters
     * still held in its internal buffer, if the parsing state allows.
     */
    protected void flushBuffer() throws IOException {
	}

    /**
     * Returns a flag indicating whether the specified tag should be included in
     * the parsing process.
     *
     * @param tagName
     *            tag name
     * @return <code>true</code> if the tag should be processed, else
     *         <code>false</code>
     */
    protected boolean tagIncluded(String tagName) {
		return false;
	}

    /**
     * Decompose a tag and feed it to the document handler.
     *
     * @param ch
     *            character data
     * @param off
     *            offset where character data starts
     * @param len
     *            length of character data
     */
    protected void processTag(char[] ch, int off, int len) throws IOException {
	}
}
