/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.search.eval;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.query.Row;

import org.apache.felix.scr.annotations.Component;
import org.apache.jackrabbit.util.ISO9075;
import org.apache.jackrabbit.util.Text;

import com.day.cq.search.Predicate;
import com.day.cq.search.facets.Facet;
import com.day.cq.search.facets.FacetExtractor;
import com.day.cq.search.facets.buckets.SimpleBucket;
import com.day.cq.search.facets.extractors.FacetImpl;
import com.day.text.GlobPattern;

/**
 * <code>NodenamePredicateEvaluator</code> filters the result set by matching on
 * node names (not possible with xpath query with JCR 1.0).
 * 
 * <h3>Name:</h3>
 * nodename
 *
 * <h3>Properties:</h3>
 * <dl>
 * <dt>nodename</dt>
 * <dd>node name pattern that allows wildcards: * = any or no char, ? = any char,
 * [abc] = only chars in brackets</dd>
 * <dl>
 *
 * @since 5.2
 */
@Component(metatype = false, factory="com.day.cq.search.eval.PredicateEvaluator/nodename")
public class NodenamePredicateEvaluator extends AbstractPredicateEvaluator {
    
    public static final String NODENAME = "nodename";

    @Override
    public String getXPathExpression(Predicate p, EvaluationContext context) {
		return null;
	}

    @Override
    public boolean includes(Predicate p, Row row, EvaluationContext context) {
		return false;
	}

    @Override
    public Comparator<Row> getOrderByComparator(Predicate predicate, final EvaluationContext context) {
		return null;
	}

    @Deprecated
    protected boolean containsWildcard(Predicate p) {
		return false;
	}

    protected boolean containsWildcard(String name) {
		return false;
	}

    protected boolean containsWildcardsNotSupportedWithJcrLike(String name) {
		return false;
	}

    private String convertWildcardsForJcrLike(String term) {
		return null;
	}

    @Override
    public boolean canXpath(Predicate p, EvaluationContext context) {
		return false;
	}

    @Override
    public boolean canFilter(Predicate predicate, EvaluationContext context) {
		return false;
	}
    
    @Override
    public FacetExtractor getFacetExtractor(Predicate predicate, EvaluationContext context) {
		return null;
	}
    
    private static class NodenameFacetExtractor implements FacetExtractor {
        private Map<String, SimpleBucket> nameBuckets = new HashMap<String, SimpleBucket>();
        private Predicate predicateTemplate;
        
        public NodenameFacetExtractor(Predicate predicateTemplate) {
            this.predicateTemplate = predicateTemplate;
        }
        
        public void handleNode(Node node) throws RepositoryException {
		}
        
        public Facet getFacet() {
			return null;
		}
        
        public boolean equals(Object obj) {
			return false;
		}
        
        public int hashCode() {
			return 0;
		}
    }
}
