/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.search.writer;

import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.jcr.RepositoryException;

import org.apache.felix.scr.annotations.Component;
import org.apache.jackrabbit.util.Text;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceMetadata;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;

import com.day.cq.search.Query;
import com.day.cq.search.result.Hit;

/**
 * {@linkplain SimpleHitWriter} writes common properties that are available on
 * most JCR nodes, eg. path, excerpt, name, title, lastModified, created, size
 * and mimeType.
 */
@Component(metatype = false, factory = "com.day.cq.search.writer.ResultHitWriter/simple")
public class SimpleHitWriter implements ResultHitWriter {

    public void write(Hit hit, JSONWriter writer, Query query) throws RepositoryException, JSONException {
	}
    
    public final static long KILO_BYTE = 1024;
    public final static long MEGA_BYTE = 1024 * KILO_BYTE;
    public final static long GIGA_BYTE = 1024 * MEGA_BYTE;
    public final static long TERA_BYTE = 1024 * GIGA_BYTE;
    public final static long PETA_BYTE = 1024 * TERA_BYTE;
    
    public static void writeSimpleJson(Hit hit, JSONWriter writer) throws RepositoryException, JSONException {
	}

}
