package com.day.cq.searchpromote.feed;

/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

import aQute.bnd.annotation.ProviderType;
import com.day.cq.searchpromote.SearchPromoteException;
import com.day.cq.wcm.webservicesupport.Configuration;
import org.apache.sling.api.resource.ResourceResolver;

/**
 * Provides configuration details of Search&Promote cloud services configuration.
 *
 * @author platon
 */
@ProviderType
public interface SearchPromoteConfigurationProvider {

    /**
     * The root path of the cloud configurations for Search&Promote
     */
    public String CLOUDCONFIG_ROOT = "/etc/cloudservices/search-promote";
    public String PN_ACCOUNT_NO = "accountno";
    public String PN_SITE_ROOT = "siteroot";
    public String PN_IDENTIFIER = "identifier";
    public String PN_LAST_GENERATED = "lastgenerated";

    /**
     * Looks up a cloud services configuration using a Search&Promote account number.
     * @param accountNo the S&P account number ( spXXXXXX)
     * @param resolver a {@link ResourceResolver} used to access the repository
     * @return the {@link Configuration} object for the account.
     * @throws SearchPromoteException
     */
    public Configuration getAccountConfiguration(ResourceResolver resolver, String accountNo) throws SearchPromoteException {
		return null;
	}

}
