package com.day.cq.searchpromote.feed;

/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

import aQute.bnd.annotation.ProviderType;
import com.adobe.cq.commerce.api.CommerceSession;
import com.day.cq.searchpromote.feed.impl.FeedType;

/**
 * Interface for the Search&Promote feed service.<br/>
 *
 * @author platon
 */
@ProviderType
public interface SearchPromoteFeedService {

    /**
     * Generates a product feed.<br/>
     *
     * @param feedType        the type of feed to be generated. Possible values are {@link FeedType#FULL} for a full
     *                        feed, {@link FeedType#INCREMENTAL} for incremental and {@link FeedType#DELETED} for
     *                        deleted products feed
     * @param commerceSession a {@link CommerceSession} used to retrieve the product's additional information,
     *                        such as the price. This session is obtained using the web site root specified in
     *                        the configuration object
     * @return the feed, formatted according to the service configuration (default is XML)
     * @throws FeedGeneratorException
     */
    public String generateFeed(String accountNo, CommerceSession commerceSession, FeedType feedType) throws
            FeedGeneratorException {
		return null;
	}

}
