/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.core.contentfinder;

import com.day.cq.commons.feed.StringResponseWrapper;
import org.apache.commons.collections.Predicate;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestDispatcherOptions;
import org.apache.sling.api.request.RequestPathInfo;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.commons.json.JSONArray;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.Session;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

public abstract class ViewHandler extends ContentFinderListInfoProviderHelper {
    private static final long serialVersionUID = 5964360462202342062L;

    private static final Logger LOG = LoggerFactory.getLogger(ViewHandler.class);

    /** Query clause */
    public static final String QUERY = "query";

    /** type clause */
    public static final String TYPE = "type";

    /** limit clause */
    public static final String LIMIT = "limit";

    /** default limit for result sets */
    public static final int DEFAULT_LIMIT = 20;

    // ----------------------< Servlet Methods >--------------------------------

    /**
     * @see com.day.cq.commons.servlets.AbstractPredicateServlet#doGet(org.apache.sling.api.SlingHttpServletRequest,
     *      org.apache.sling.api.SlingHttpServletResponse, org.apache.commons.collections.Predicate)
     */
    @Override
    protected void doGet(SlingHttpServletRequest request, SlingHttpServletResponse response, Predicate predicate) throws ServletException,
            IOException {
			}

    protected Collection<Hit> executeSearch(SlingHttpServletRequest request) throws ServletException {
		return null;
	}

    protected abstract ViewQuery createQuery(SlingHttpServletRequest request, Session session, String queryString) throws Exception {
		return null;
	}

    protected JSONArray getHitsArray(Iterable<Hit> hits, SlingHttpServletRequest request, Resource resource) throws JSONException {
		return null;
	}

    /**
     * Generate html output for Servlet
     */
    protected String generateHtmlOutput(Collection<Hit> hits, SlingHttpServletRequest request,
                                      SlingHttpServletResponse response) throws ServletException, IOException {
										return null;
									}
}
