/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.core.mvt;

import java.net.URI;
import java.net.URL;

import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.WCMException;

/**
 * Utility to access configuration and shortcut click through rate report.
 */
public interface MVTStatistics {

	/**
	 * Get the URL that is supposed to receive tracking data from this instance.
	 * 
	 * @return or <code>null</code> if none configured
	 */
    URL getTrackingURL() {
		return null;
	}
    
	/**
	 * Get the URI that is supposed to receive tracking data from this instance.
	 * 
	 * @return or <code>null</code> if none configured
	 */
    URI getTrackingURI() {
		return null;
	}

    /**
     * Run a click-through-rate report for the given page.
     *
     * @param page to report
     * @return report.
     * @throws WCMException in case of error running report
     */
    Iterable<Object[]> report(Page page) throws WCMException {
		return null;
	}
}