package com.day.cq.wcm.designimporter.util;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.tika.utils.CharsetUtils;

/**
 * Class for stream related utility methods
 */
public class StreamUtil {

	private static final Pattern HTTP_EQUIV_PATTERN = Pattern.compile("(?is)<meta\\s+http-equiv\\s*=\\s*['\\\"]\\s*"
			+ "Content-Type['\\\"]\\s+content\\s*=\\s*['\\\"]" + "([^'\\\"]+)['\\\"]");

	private static final Pattern META_CHARSET_PATTERN = Pattern.compile("(?is)<meta\\s+charset\\s*=\\s*['\\\\\"]([^'\\\\\"]+)['\\\\\"]");

	private static final Pattern XHTML_ENCODING_PATTERN = Pattern.compile("(?is)<\\?xml.*encoding=\"([^\"]*)\".*\\?>");

	private static final int META_TAG_BUFFER_SIZE = 8192;

    /**
     * Determines the encoding in the passed html document stream by peeking into the &lt;meta> tags or the xml declaration if it's an xhtml document
     *
     * @param stream The InputStream of the HTML document being imported
     * @return The determined charset
     * @throws IOException
     */
	public static String getEncoding(InputStream stream) throws IOException {
		return null;
	}
}
