package com.day.cq.wcm.offline;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;

import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.servlets.HtmlResponse;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.commons.servlets.HtmlStatusResponseHelper;
import com.day.cq.wcm.api.PageManager;
import com.day.cq.wcm.api.Template;
import com.day.cq.wcm.api.components.Component;
import com.day.cq.wcm.api.components.ComponentManager;


/**
 * The offline editor servlet that allows both importing and exporting of
 * Word documents that match CQ pages. A GET request on a
 * .../path/to/page.offline.doc URL will return the exported Word document
 * rendering of the identified page, and a POST request to the same URL will
 * import the attached Word document(s) under the identified page.
 */
@org.apache.felix.scr.annotations.Component
@Service
@Properties({
    @Property(name="sling.servlet.resourceTypes", value = "sling/servlet/default"),
    @Property(name="sling.servlet.paths", value = "/libs/wcm/offline/import"),
    @Property(name="sling.servlet.methods", value = {"POST", "GET"}),
    @Property(name="sling.servlet.selectors", value = {"offline", "offlinecomponents"}),
    @Property(name="sling.servlet.extensions", value = {"doc", "json"})
})
public class OfflineServlet extends SlingAllMethodsServlet {

    private static final long serialVersionUID = -7939838253258809729L;

    private static final Logger log = LoggerFactory.getLogger(OfflineServlet.class);

    @Override
    protected void doPost(
            SlingHttpServletRequest request, SlingHttpServletResponse response)
            throws ServletException, IOException {
			}

    private String formatFileName(String fileName) {
		return null;
	}

    private ValueMap getConfig(SlingHttpServletRequest request) {
		return null;
	}

    @Override
    protected void doGet(
            SlingHttpServletRequest request, SlingHttpServletResponse response)
            throws ServletException, IOException {
			}

}
