/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.siteimporter;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpState;
import org.apache.commons.httpclient.cookie.CookiePolicy;
import org.apache.commons.httpclient.params.HttpClientParams;
import org.apache.commons.httpclient.params.HttpMethodParams;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestParameter;
import org.apache.sling.api.resource.ResourceResolver;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class ImporterContext implements ProgressTracker {
    private static final Logger log = LoggerFactory
            .getLogger(ImporterContext.class);

    static final String LANG_DEFAULT = "en";

    static final HttpClientParams params = new HttpClientParams();
    static {
        params.setCookiePolicy(CookiePolicy.BROWSER_COMPATIBILITY);

        // Allow circular redirects, because some cookie-check mechanisms do
        // a single "circle" and would cause an exception otherwise.
        // Limit MAX_REDIRECT instead to prevent endless redirect loops or traps.
        params.setBooleanParameter(HttpClientParams.ALLOW_CIRCULAR_REDIRECTS, true);
        params.setIntParameter(HttpClientParams.MAX_REDIRECTS, 5);
    }

    private SlingHttpServletRequest request;
    private SlingHttpServletResponse response;
    private ResourceResolver resolver;
    private ResourcesBoard board;
    private HttpClient httpClient;

    private String projectName;
    private String title;
    private URL original;
    private String sitemap;
    private String resourceSuperType;
    private boolean overwrite;
    private String defaultLanguage;

    private final List<ServiceReference> references = new ArrayList<ServiceReference>();
    private final Map<String, Object> services = new HashMap<String, Object>();

    private final List<String> paths = new ArrayList<String>();

    private BundleContext bundleContext;


    private ImporterContext() {
        // private constructor
    }

    public static ImporterContext createContext(
            SlingHttpServletRequest request, SlingHttpServletResponse response,
            BundleContext bundleContext) throws MalformedURLException {
				return null;
			}

    public static ImporterContext createContext(
            SlingHttpServletRequest request, SlingHttpServletResponse response,
            BundleContext bundleContext, ResourcesBoard board)
            throws MalformedURLException {
				return null;
			}

    public String getProjectName() {
		return null;
	}

    public String getTitle() {
		return null;
	}

    public URL getOriginal() {
		return null;
	}

    public String getSitemap() {
		return null;
	}

    public String getResourceSuperType() {
		return null;
	}

    public boolean isOverwrite() {
		return false;
	}

    public String getContextPath() {
		return null;
	}

    public ResourceResolver getResolver() {
		return null;
	}

    public ResourcesBoard getBoard() {
		return null;
	}

    public PrintWriter getWriter() {
		return null;
	}

    public HttpClient getHttpClient() {
		return null;
	}

    public List<String> getPaths() {
		return null;
	}

    public void addPath(String path) {
	}

    public RequestParameter getThumbnail() {
		return null;
	}

    @SuppressWarnings("unchecked")
    public <T> T getService(Class<T> type) {
		return null;
	}

    public void dispose() {
	}

    // ----< ProgressTracker interface >----------------------------------------

    private int currentIndent = 0;

    public void output(String message) {
	}

    public void output(String message, String css) {
	}

    private void output(String message, String css, Exception e) {
	}

    public void error(String message) {
	}

    public void error(String message, Exception e) {
	}

    public void doIndent() {
	}

    public void undoIndent() {
	}

    public void repairIndent() {
	}

    public void flushBuffer() {
	}

    public void setDefaultLanguage(final String defaultLanguage) {
	}

    public String getDefaultLanguage() {
		return null;
	}
}
