/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.http.HttpServletRequest;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.net.URLEncoder;
import java.io.IOException;

/**
 * <code>RequestURLTag</code> writes the current request URL to the current
 * JspWriter. The body of this tag allows multiple addParam and removeParam
 * tags to modify the current request URL before it is written.
 */
public class RequestURLTag extends TagSupport {

    private static final long serialVersionUID = -5674803762870190034L;

    /**
     * Maps query parameter name to a list of values.
     */
    private Map<String, List<String>> parameters = new HashMap<String, List<String>>();

    /**
     * The request URI. Contains the web app context and the path, but no query
     * parameters. See {@link HttpServletRequest#getRequestURI()}.
     */
    private String uri;

    /**
     * Default constructor.
     */
    public RequestURLTag() {
        super();
        init();
    }

    /**
     * Removes the parameter and all its values with the given <code>name</code>.
     *
     * @param name the name of the parameter.
     */
    public void removeParam(String name) {
	}

    /**
     * Removes a value from the parameter with the given <code>name</code>.
     *
     * @param name name of the parameter.
     * @param value the value to remove.
     */
    public void removeParam(String name, String value) {
	}

    /**
     * Adds a parameter with the given <code>name</code> and <code>value</code>.
     *
     * @param name the name of the parameter.
     * @param value the value for the parameter.
     */
    public void addParam(String name, String value) {
	}

    /**
     * {@inheritDoc}
     */
    public void release() {
	}

    /**
     * {@inheritDoc}
     */
    public int doStartTag() throws JspException {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    public int doEndTag() throws JspException {
		return 0;
	}

    private void init() {
	}
}
