/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.crx.sc.qom;

import java.util.HashMap;
import java.util.Map;

import javax.jcr.ItemExistsException;
import javax.jcr.ItemNotFoundException;
import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.Value;
import javax.jcr.lock.LockException;
import javax.jcr.nodetype.ConstraintViolationException;
import javax.jcr.query.Query;
import javax.jcr.version.VersionException;

public abstract class AbstractQuery implements Query {

    private final String statement;

    private final String language;

    private final Map<String, Value> bindVariables = new HashMap<String, Value>();

    private volatile long offset = 0;

    private volatile long limit = Long.MAX_VALUE;

    protected AbstractQuery(final String statement, final String language, final String... variables) {
        this.statement = statement;
        this.language = language;
        for (final String variable : variables) {
            bindVariables.put(variable, null);
        }
    }

    @Override
    public String getStatement() {
		return null;
	}

    @Override
    public String getLanguage() {
		return null;
	}

    public long getOffset() {
		return 0L;
	}

    @Override
    public void setOffset(final long offset) {
	}

    public long getLimit() {
		return 0L;
	}

    @Override
    public void setLimit(final long limit) {
	}

    @Override
    public String[] getBindVariableNames() throws RepositoryException {
		return null;
	}

    public Value getBindValue(final String varName) {
		return null;
	}

    @Override
    public void bindValue(final String varName, final Value value) throws IllegalArgumentException,
        RepositoryException {
		}

    @Override
    public Node storeAsNode(final String absPath) throws ItemExistsException, PathNotFoundException,
        VersionException, ConstraintViolationException, LockException, UnsupportedRepositoryOperationException,
        RepositoryException {
			return null;
		}

    @Override
    public String getStoredQueryPath() throws ItemNotFoundException, RepositoryException {
		return null;
	}

}
