/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.crx.sc.qom;

import static javax.jcr.query.qom.QueryObjectModelConstants.JCR_OPERATOR_EQUAL_TO;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.query.Row;
import javax.jcr.query.qom.Constraint;
import javax.jcr.query.qom.EquiJoinCondition;
import javax.jcr.query.qom.Join;
import javax.jcr.query.qom.Literal;
import javax.jcr.query.qom.PropertyValue;
import javax.jcr.query.qom.QueryObjectModelFactory;

class EquiJoinMerger extends JoinMerger {

    private final PropertyValue leftProperty;

    private final PropertyValue rightProperty;

    public EquiJoinMerger(final Join join, final Map<String, PropertyValue> columns,
        final OperandEvaluator evaluator, final QueryObjectModelFactory factory, final EquiJoinCondition condition)
        throws RepositoryException {
        super(join, columns, evaluator, factory);

        final PropertyValue property1 =
            factory.propertyValue(condition.getSelector1Name(), condition.getProperty1Name());
        final PropertyValue property2 =
            factory.propertyValue(condition.getSelector2Name(), condition.getProperty2Name());

        if (leftSelectors.contains(property1.getSelectorName())
                && rightSelectors.contains(property2.getSelectorName())) {
            leftProperty = property1;
            rightProperty = property2;
        } else if (leftSelectors.contains(property2.getSelectorName())
                && rightSelectors.contains(property1.getSelectorName())) {
            leftProperty = property2;
            rightProperty = property1;
        } else {
            throw new RepositoryException("Invalid equi-join");
        }
    }

    @Override
    public Set<String> getLeftValues(final Row row) throws RepositoryException {
		return null;
	}

    @Override
    public Set<String> getRightValues(final Row row) throws RepositoryException {
		return null;
	}

    @Override
    public List<Constraint> getRightJoinConstraints(final List<Row> leftRows) throws RepositoryException {
		return null;
	}

    private Set<String> getValues(final PropertyValue property, final Row row) throws RepositoryException {
		return null;
	}

}
