/*
 * Copyright 1997-2004 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.io;


/**
 * This class provides a byte buffer, that is unlimited in capacity.
 *
 * @version $Revision: 1.6 $, $Date: 2004-08-22 06:56:09 +0200 (Sun, 22 Aug 2004) $
 * @author ralph
 * @since antbear
 * @audience wad
 */
public class ByteBuffer {

    /** the total length of the valid data in the buffer */
    private int length = 0;

    /** the first chunk of the list */
    private Chunk firstChunk;

    /** the last chunk of the list */
    private Chunk lastChunk;

    /**
     * Creates a new <code>ByteBuffer</code>-object
     */
    public ByteBuffer() {
	reset();
    }

    /**
     * Resets this <code>ByteBuffer</code> and clears the internal storage.
     */
    public void reset() {
	}

    /**
     * Returns the entire buffer.
     * @return a new byte buffer.
     */
    public byte[] get() {
		return null;
	}

    /**
     * Returns up to <code>num</code> bytes from this <code>ByteBuffer</code>.
     *
     * @param num the number of bytes to return
     * @return a new buffer with the containig bytes
     */
    public byte[] get(int num) {
		return null;
	}

    /**
     * Transferse up to <code>num</code> bytes to the <code>output</code> buffer
     * starting at <code>offset</code>.
     *
     * @param output the output buffer
     * @param offset the offset
     * @param length the number of bytes to transfer
     *
     * @return the number of bytes written
     */
    public int get(byte[] output, int offset, int num) {
		return 0;
	}


    /**
     * Puts <code>length</code> bytes from <code>input</code> starting at
     * <code>offset</code> to the end of this buffer.
     *
     * @param input the input buffer
     * @param offset the offset into the input buffer
     * @param length the number of bytes to transfer
     */
    public void put(byte[] input, int offset, int len) {
	}

    /**
     * Puts the bytes at the end of the buffer
     * @param bytes the bytes to add to the buffer
     */
    public void put(byte[] bytes) {
	}

    /**
     * Puts one byte at the end of the buffer
     * to be optimized.
     */
    public void put(byte b) {
	}

    /**
     * Returns the number of bytes in the queue.
     */
    public int length() {
		return 0;
	}

    /**
     * Checks if the buffer is empty.
     * @return <code>true</code> if the buffer is empty;
     *         <code>false</code> otherwise.
     */
    public boolean isEmpty() {
		return false;
	}

    /**
     * Internal class that holds chunks of byte-arrays
     */
    private static class Chunk {

	/** the minumim size of a chunk */
	private static final int SIZE = 4096;

	/** the bytes in this array */
	private byte[] bytes;

	/** the offset to valid data */
	private int start;

	/** the length of valid data */
	private int end;

	/** the next chunk in the list */
	private Chunk next;

	/**
	 * Creates an empty <code>Chunk</code>.
	 */
	private Chunk() {
	    this(null, 0, 0);
	}

	/**
	 * Creates a <code>Chunk</code> containing one byte
	 */
	private Chunk(byte b) {
	    this(null, 0, 0);
	    bytes[start]=b;
	    end++;
	}

	/**
	 * Creates a new <code>Chunk</code> with the given byte array.
	 *
	 * @param input the byte array
	 */
	private Chunk(byte[] input) {
	    this(input, 0, input.length);
	}

	/**
	 * Creates a new <code>Chunk</code> out of a given byte array.
	 *
	 * @param input the input buffer
	 * @param offset the offset in the buffer
	 * @param len    the length in the buffer
	 */

	private Chunk(byte[] input, int offset, int len) {
	    bytes = new byte[Math.max(len, SIZE)];
	    start = 0;
	    end   = len;
	    if (len>0) {
		System.arraycopy(input, offset, bytes, 0, len);
	    }
	}

	/**
	 * Copies at most <code>len</code> bytes from the beginning of the internal
	 * storage to the <code>output</code> starting at <code>offset</code>.
	 * It also adapts the internal range of valid data.
	 *
	 * @param output the output buffer
	 * @param offset the offset in the output buffer
	 * @param len the number of bytes to transfer
	 *
	 * @return the number of transfered bytes.
	 */
	private int get(byte[] output, int offset, int len) {
		return 0;
	}

	/**
	 * Copies <code>len</code> bytes at the end of the internal storage.
	 * and creates new successors if neccesairy.
	 *
	 * @param input the input buffer
	 * @param offset the offset in the input buffer
	 * @param len the length of valid data in the input buffer
	 *
	 * @return the last chunk
	 */
	private Chunk put(byte[] input, int offset, int len) {
		return null;
	}

	/**
	 * Puts one byte at the end of the internal buffer. If neccessairy, it
	 * create a successor to store the byte.
	 *
	 * @param b the byte to append
	 * @return the last chunk
	 */
	private Chunk put(byte b) {
		return null;
	}


	/**
	 * Checks if this chunk is empty.
	 * @return <code>true</code> if this chunk is empty;
	 *         <code>false</code> otherwise.
	 */
	private boolean isEmpty() {
		return false;
	}

	/**
	 * Returns the length of valid data in this chunk
	 * @return the length of this chunk
	 */
	private int length() {
		return 0;
	}
    }
}