/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2013 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package io.sightly.java.api;

import java.util.Set;

/**
 * A key-value immutable object understood by the Sightly runtime
 * @param <T> the type of values for this record
 */
public interface Record<T> {

    /**
     * Get the value of the specified property
     * @param name the name of the property
     * @return the value of the property or null if this record does not
     * have the specified property
     */
    T get(String name) {
		return null;
	}

    /**
     * Get the set of properties for this record
     * @return this record's properties
     */
    Set<String> properties() {
		return null;
	}

}
