/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/
package io.sightly.java.api;

import javax.script.Bindings;

/**
 * Basic unit of rendering. This also extends the record interface.
 * The properties for a unit are the sub-units
 */
public interface RenderUnit extends Record<RenderUnit> {

    /**
     * Render the main script template
     * @param renderContext - the rendering context
     * @param arguments - the arguments for this unit
     */
    void render(RenderContext renderContext, Bindings arguments) {
	}

}
