/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2013 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package io.sightly.java.api;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;

/**
 * Utility class which used by the Sightly engine & extensions
 * to resolve resources
 */
public class ResourceResolution {

    /**
     * Maximum number of iterations that can be performed when searching for a resource in
     * the resource superType chain
     */
    private static final int RECURSION_LIMIT = 100;

    /**
     * Resolve the resource with the given path relative to the base resource, using the
     * resource super type logic
     * @param resourceResolver The resource resolver to be used
     * @param base the base resource. It can be null if path is absolute
     * @param path the path to the resource
     * @return the retrieved resource or null if no resource was found
     * @throws java.lang.UnsupportedOperationException if the resource is not in the resource resolver's search path
     * @throws java.lang.IllegalStateException if the number of steps necessary to search for the resource on the resource
     * superType chain has reached the maximum limit
     * @throws java.lang.IllegalArgumentException if a null componentResource is provided but the path is not absolute
     */
    public static Resource resolveComponentRelative(ResourceResolver resourceResolver, Resource base, String path) {
		return null;
	}

    /**
     * Resolve the resource in the specified component
     * @param resourceResolver The resource resolver to be used
     * @param componentResource The resource for the component. It can be null if path is absolute
     * @param path the path to the resource
     * @return the retrieved resource or null if no resource was found
     * @throws java.lang.UnsupportedOperationException if the resource is not in the resource resolver's search path
     * @throws java.lang.IllegalStateException if more than {@link io.sightly.java.api.ResourceResolution#RECURSION_LIMIT} steps were
     * necessary to search for the resource on the resource superType chain
     * @throws java.lang.IllegalArgumentException if a null componentResource is provided but the path is not absolute
     */
    private static Resource resolveComponent(ResourceResolver resourceResolver, Resource componentResource, String path) {
		return null;
	}

    private static Resource recursiveResolution(ResourceResolver resourceResolver, Resource componentResource, String path) {
		return null;
	}

    private static Resource locateInSearchPath(ResourceResolver resourceResolver, String path) {
		return null;
	}

    private static boolean isInSearchPath(ResourceResolver resourceResolver, Resource resource) {
		return false;
	}

    private static Resource findSuperComponent(ResourceResolver resourceResolver, Resource base) {
		return null;
	}

    private static Resource searchPathChecked(ResourceResolver resourceResolver, Resource resource) {
		return null;
	}

    private static Resource retrieveParent(ResourceResolver resourceResolver, Resource resource) {
		return null;
	}

    private static boolean isAbsolutePath(String path) {
		return false;
	}

}
