/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package io.sightly.java.api;

/**
 * The runtime {@code SightlyParsingException} is thrown during the parsing stage for any grammar offending input.
 */
public class SightlyParsingException extends RuntimeException {

    private String offendingInput;

    public SightlyParsingException() {
    }

    public SightlyParsingException(String message) {
        super(message);
    }

    public SightlyParsingException(String message, String offendingInput) {
        super(message);
        this.offendingInput = offendingInput;
    }

    public SightlyParsingException(String message, Throwable cause) {
        super(message, cause);
    }

    public SightlyParsingException(String message, String offendingInput, Throwable cause) {
        super(message, cause);
        this.offendingInput = offendingInput;
    }

    public SightlyParsingException(Throwable cause) {
        super(cause);
    }

    public String getOffendingInput() {
		return null;
	}
}
