/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.kernel;

import java.io.IOException;
import java.util.concurrent.locks.Lock;

import javax.annotation.Nonnull;

import org.apache.jackrabbit.mk.api.MicroKernel;
import org.apache.jackrabbit.mk.api.MicroKernelException;
import org.apache.jackrabbit.oak.api.Blob;
import org.apache.jackrabbit.oak.api.CommitFailedException;
import org.apache.jackrabbit.oak.spi.commit.ChangeDispatcher;
import org.apache.jackrabbit.oak.spi.commit.CommitHook;
import org.apache.jackrabbit.oak.spi.commit.CommitInfo;
import org.apache.jackrabbit.oak.spi.state.AbstractNodeStoreBranch;
import org.apache.jackrabbit.oak.spi.state.NodeState;

import static org.apache.jackrabbit.oak.api.CommitFailedException.MERGE;

/**
 * {@code NodeStoreBranch} based on {@link MicroKernel} branching and merging.
 * This implementation keeps changes in memory up to a certain limit and writes
 * them back to the Microkernel branch when the limit is exceeded.
 */
public class KernelNodeStoreBranch extends
        AbstractNodeStoreBranch<KernelNodeStore, KernelNodeState> {

    private final BlobSerializer blobs = new BlobSerializer() {
        @Override
        public String serialize(Blob blob) {
			return null;
		}
    };

    public KernelNodeStoreBranch(KernelNodeStore kernelNodeStore,
                                 ChangeDispatcher dispatcher,
                                 Lock mergeLock,
                                 KernelNodeState base) {
        super(kernelNodeStore, dispatcher, mergeLock, base);
    }

    //----------------------< AbstractNodeStoreBranch >-------------------------

    @Override
    public KernelNodeState createBranch(KernelNodeState state) {
		return null;
	}

    @Override
    public KernelNodeState getRoot() {
		return null;
	}

    @Override
    protected KernelNodeState rebase(KernelNodeState branchHead,
                                     KernelNodeState base) {
										return null;
									}

    @Override
    protected KernelNodeState merge(KernelNodeState branchHead,
                                    CommitInfo info)
            throws CommitFailedException {
				return null;
			}

    @Nonnull
    @Override
    protected KernelNodeState reset(@Nonnull KernelNodeState branchHead,
                                    @Nonnull KernelNodeState ancestor) {
										return null;
									}

    @Override
    protected KernelNodeState persist(NodeState toPersist,
                                      KernelNodeState base,
                                      CommitInfo info) {
										return null;
									}

    @Override
    protected KernelNodeState copy(String source,
                                   String target,
                                   KernelNodeState base) {
									return null;
								}

    @Override
    protected KernelNodeState move(String source,
                                   String target,
                                   KernelNodeState base) {
									return null;
								}

//------------------------< NodeStoreBranch >-------------------------------

    @Nonnull
    @Override
    public NodeState merge(@Nonnull CommitHook hook, @Nonnull CommitInfo info)
            throws CommitFailedException {
				return null;
			}
}
