/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.plugins.index.aggregate;


import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Set;
import java.util.concurrent.atomic.AtomicReference;

import org.apache.jackrabbit.oak.api.PropertyValue;
import org.apache.jackrabbit.oak.query.fulltext.FullTextAnd;
import org.apache.jackrabbit.oak.query.fulltext.FullTextExpression;
import org.apache.jackrabbit.oak.query.fulltext.FullTextOr;
import org.apache.jackrabbit.oak.query.fulltext.FullTextTerm;
import org.apache.jackrabbit.oak.query.fulltext.FullTextVisitor;
import org.apache.jackrabbit.oak.query.index.FilterImpl;
import org.apache.jackrabbit.oak.spi.query.Cursor;
import org.apache.jackrabbit.oak.spi.query.Cursors;
import org.apache.jackrabbit.oak.spi.query.Cursors.AbstractCursor;
import org.apache.jackrabbit.oak.spi.query.Filter;
import org.apache.jackrabbit.oak.spi.query.IndexRow;
import org.apache.jackrabbit.oak.spi.query.QueryIndex.FulltextQueryIndex;
import org.apache.jackrabbit.oak.spi.state.NodeState;

import com.google.common.base.Function;
import com.google.common.base.Predicates;
import com.google.common.collect.Iterators;
import com.google.common.collect.Lists;

/**
 * A virtual full-text that can aggregate nodes based on aggregate definitions.
 * Internally, it uses another full-text index.
 */
public class AggregateIndex implements FulltextQueryIndex {

    private final FulltextQueryIndex baseIndex;

    public AggregateIndex(FulltextQueryIndex baseIndex) {
        this.baseIndex = baseIndex;
    }

    @Override
    public double getCost(Filter filter, NodeState rootState) {
		return 0.0d;
	}

    @Override
    public Cursor query(Filter filter, NodeState rootState) {
		return null;
	}

    private static Cursor newCursor(Filter f, FulltextQueryIndex index,
            NodeState state) {
				return null;
			}

    private static boolean hasCompositeExpression(FullTextExpression ft) {
		return false;
	}

    private static boolean hasNegativeContains(FullTextExpression ft) {
		return false;
	}

    private static Cursor flatten(FullTextExpression constraint,
            final Filter filter, final FulltextQueryIndex index,
            final NodeState state) {
				return null;
			}

    private static double flattenCost(FullTextExpression constraint,
            final Filter filter, final FulltextQueryIndex index,
            final NodeState state) {
				return 0.0d;
			}

    private static Cursor filterToCursor(Filter f, FulltextQueryIndex index,
            NodeState state) {
				return null;
			}

    private static Filter newAggregationFilter(Filter filter, FullTextExpression exp) {
		return null;
	}

    @Override
    public String getPlan(Filter filter, NodeState rootState) {
		return null;
	}

    @Override
    public String getIndexName() {
		return null;
	}

    @Override
    public NodeAggregator getNodeAggregator() {
		return null;
	}

    /**
     * An aggregation aware cursor.
     */
    private static class AggregationCursor extends AbstractCursor {

        private final Cursor cursor;
        private final NodeAggregator aggregator;
        private final NodeState rootState;

        private boolean init;
        private boolean closed;

        /**
         * the current row
         */
        private IndexRow currentRow;

        /**
         * the path of the current item of the cursor
         */
        private String currentPath;

        /**
         * all of the item's known aggregates
         */
        private Iterator<String> aggregates;

        /**
         * should enforce uniqueness of the aggregated paths
         */
        private Set<String> seenPaths = new HashSet<String>();

        public AggregationCursor(Cursor cursor, NodeAggregator aggregator,
                NodeState rootState) {
            this.cursor = cursor;
            this.aggregator = aggregator;
            this.rootState = rootState;
        }

        @Override
        public boolean hasNext() {
			return false;
		}

        private void fetchNext() {
		}

        @Override
        public IndexRow next() {
			return null;
		}
    }

}
