/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.plugins.index.lucene;

import java.io.Closeable;
import java.util.List;

import javax.annotation.Nonnull;

import org.apache.jackrabbit.oak.plugins.index.aggregate.NodeAggregator;
import org.apache.jackrabbit.oak.spi.commit.CommitInfo;
import org.apache.jackrabbit.oak.spi.commit.Observer;
import org.apache.jackrabbit.oak.spi.query.QueryIndex;
import org.apache.jackrabbit.oak.spi.query.QueryIndexProvider;
import org.apache.jackrabbit.oak.spi.state.NodeState;
import org.apache.lucene.analysis.Analyzer;

import com.google.common.collect.ImmutableList;

/**
 * A provider for Lucene indexes.
 * 
 * @see LuceneIndex
 */
public class LuceneIndexProvider implements QueryIndexProvider, Observer, Closeable {

    protected final IndexTracker tracker = new IndexTracker();

    protected volatile Analyzer analyzer = LuceneIndexConstants.ANALYZER;

    protected volatile NodeAggregator aggregator = null;

    public void close() {
	}

    //----------------------------------------------------------< Observer >--

    @Override
    public void contentChanged(NodeState root, CommitInfo info) {
	}

    //------------------------------------------------< QueryIndexProvider >--

    @Override @Nonnull
    public List<QueryIndex> getQueryIndexes(NodeState nodeState) {
		return null;
	}

    protected LuceneIndex newLuceneIndex() {
		return null;
	}

    /**
     * sets the default analyzer that will be used at query time
     */
    public void setAnalyzer(Analyzer analyzer) {
	}

    /**
     * sets the default node aggregator that will be used at query time
     */
    public void setAggregator(NodeAggregator aggregator) {
	}

    // ----- helper builder method

    public LuceneIndexProvider with(Analyzer analyzer) {
		return null;
	}

    public LuceneIndexProvider with(NodeAggregator analyzer) {
		return null;
	}
}
