/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.plugins.segment;

import java.util.List;
import java.util.Map;
import javax.annotation.Nonnull;
import javax.jcr.PropertyType;

import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.api.Type;
import org.apache.jackrabbit.oak.plugins.memory.AbstractPropertyState;
import org.apache.jackrabbit.oak.plugins.value.Conversions;
import org.apache.jackrabbit.oak.plugins.value.Conversions.Converter;

import static com.google.common.base.Preconditions.checkArgument;
import static com.google.common.base.Preconditions.checkElementIndex;
import static com.google.common.base.Preconditions.checkNotNull;
import static com.google.common.base.Preconditions.checkState;
import static com.google.common.collect.Lists.newArrayListWithCapacity;
import static com.google.common.collect.Maps.newHashMap;
import static java.util.Collections.emptyList;
import static java.util.Collections.emptyMap;
import static java.util.Collections.singletonList;
import static org.apache.jackrabbit.oak.api.Type.BINARY;
import static org.apache.jackrabbit.oak.api.Type.BOOLEAN;
import static org.apache.jackrabbit.oak.api.Type.DATE;
import static org.apache.jackrabbit.oak.api.Type.DECIMAL;
import static org.apache.jackrabbit.oak.api.Type.DOUBLE;
import static org.apache.jackrabbit.oak.api.Type.LONG;
import static org.apache.jackrabbit.oak.api.Type.NAME;
import static org.apache.jackrabbit.oak.api.Type.PATH;
import static org.apache.jackrabbit.oak.api.Type.REFERENCE;
import static org.apache.jackrabbit.oak.api.Type.STRING;
import static org.apache.jackrabbit.oak.api.Type.URI;
import static org.apache.jackrabbit.oak.api.Type.WEAKREFERENCE;

class SegmentPropertyState extends Record implements PropertyState {

    private final PropertyTemplate template;

    public SegmentPropertyState(RecordId id, PropertyTemplate template) {
        super(id);
        this.template = checkNotNull(template);
    }

    private ListRecord getValueList(Segment segment) {
		return null;
	}

    Map<String, RecordId> getValueRecords() {
		return null;
	}

    @Override @Nonnull
    public String getName() {
		return null;
	}

    @Override
    public Type<?> getType() {
		return null;
	}

    @Override
    public boolean isArray() {
		return false;
	}

    @Override
    public int count() {
		return 0;
	}

    @Override @Nonnull @SuppressWarnings("unchecked")
    public <T> T getValue(Type<T> type) {
		return null;
	}

    @Override
    public long size() {
		return 0L;
	}

    @Override @Nonnull
    public <T> T getValue(Type<T> type, int index) {
		return null;
	}

    @SuppressWarnings("unchecked")
    private <T> T getValue(Segment segment, RecordId id, Type<T> type) {
		return null;
	}

    @Override
    public long size(int index) {
		return 0L;
	}


    //------------------------------------------------------------< Object >--

    @Override
    public boolean equals(Object object) {
		return false;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public String toString() {
		return null;
	}

}
