/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with this
 * work for additional information regarding copyright ownership. The ASF
 * licenses this file to You under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.apache.jackrabbit.oak.query;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.apache.jackrabbit.oak.api.PropertyValue;
import org.apache.jackrabbit.oak.api.Result;
import org.apache.jackrabbit.oak.api.Tree;
import org.apache.jackrabbit.oak.query.ast.ColumnImpl;
import org.apache.jackrabbit.oak.query.ast.OrderingImpl;
import org.apache.jackrabbit.oak.spi.query.PropertyValues;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.collect.Iterators;

/**
 * Represents a union query.
 */
public class UnionQueryImpl implements Query {
    
    private static final Logger LOG = LoggerFactory.getLogger(QueryImpl.class);
    
    private final boolean unionAll;
    private final Query left, right;
    private ColumnImpl[] columns;
    private OrderingImpl[] orderings;
    private boolean explain;
    private boolean measure;
    private long limit = Long.MAX_VALUE;
    private long offset;
    private long size = -1;
    private final QueryEngineSettings settings;
    
    UnionQueryImpl(boolean unionAll, Query left, Query right, QueryEngineSettings settings) {
        this.unionAll = unionAll;
        this.left = left;
        this.right = right;
        this.settings = settings;
    }

    @Override
    public void setExecutionContext(ExecutionContext context) {
	}

    @Override
    public void setOrderings(OrderingImpl[] orderings) {
	}

    @Override
    public void setLimit(long limit) {
	}

    @Override
    public void setOffset(long offset) {
	}

    @Override
    public void bindValue(String key, PropertyValue value) {
	}

    @Override
    public void setTraversalEnabled(boolean traversal) {
	}

    @Override
    public void prepare() {
	}
    
    @Override
    public double getEstimatedCost() {
		return 0.0d;
	}

    @Override
    public List<String> getBindVariableNames() {
		return null;
	}

    @Override
    public ColumnImpl[] getColumns() {
		return null;
	}

    @Override
    public String[] getSelectorNames() {
		return null;
	}
    
    @Override
    public int getSelectorIndex(String selectorName) {
		return 0;
	}

    @Override
    public long getSize() {
		return 0L;
	}

    @Override
    public void setExplain(boolean explain) {
	}

    @Override
    public void setMeasure(boolean measure) {
	}

    @Override
    public void init() {
	}
    
    @Override
    public String toString() {
		return null;
	}
    
    @Override
    public Result executeQuery() {
		return null;
	}
    
    @Override
    public String getPlan() {
		return null;
	}
    
    @Override
    public Tree getTree(String path) {
		return null;
	}
    
    @Override
    public int getColumnIndex(String columnName) {
		return 0;
	}
    
    @Override
    public Iterator<ResultRowImpl> getRows() {
		return null;
	}
    
}
