/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.spi.commit;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.annotation.Nullable;

import org.apache.jackrabbit.oak.api.CommitFailedException;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.spi.state.NodeState;
import org.apache.jackrabbit.oak.spi.state.NodeStateUtils;

/**
 * Validator implementation that allows to exclude hidden nodes and/or properties
 * for the validation process.
 */
public class VisibleValidator implements Validator {

    private final Validator validator;
    private final boolean hideNodes;
    private final boolean hideProperties;

    public VisibleValidator(@Nonnull Validator validator, boolean hideNodes, boolean hideProperties) {
        this.validator = validator;
        this.hideNodes = hideNodes;
        this.hideProperties = hideProperties;
    }

    private Validator getValidator(@Nullable Validator validator) {
		return null;
	}

    private boolean isVisibleNode(String name) {
		return false;
	}

    private boolean isVisibleProperty(String name) {
		return false;
	}

    //----------------------------------------------------------< Validator >---

    @Override
    public void enter(NodeState before, NodeState after) throws CommitFailedException {
	}

    @Override
    public void leave(NodeState before, NodeState after) throws CommitFailedException {
	}

    @Override
    public void propertyAdded(PropertyState after) throws CommitFailedException {
	}

    @Override
    public void propertyChanged(PropertyState before, PropertyState after) throws CommitFailedException {
	}

    @Override
    public void propertyDeleted(PropertyState before) throws CommitFailedException {
	}

    @Override @CheckForNull
    public Validator childNodeAdded(String name, NodeState after) throws CommitFailedException {
		return null;
	}

    @Override @CheckForNull
    public Validator childNodeChanged(String name, NodeState before, NodeState after) throws CommitFailedException {
		return null;
	}

    @Override @CheckForNull
    public Validator childNodeDeleted(String name, NodeState before)
            throws CommitFailedException {
				return null;
			}
}