/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.spi.query;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.Iterator;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.jcr.PropertyType;

import org.apache.jackrabbit.oak.api.Blob;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.api.PropertyValue;
import org.apache.jackrabbit.oak.api.Type;
import org.apache.jackrabbit.util.ISO8601;

/**
 * A {@link PropertyValue} implementation that wraps a {@link PropertyState}
 */
public class PropertyStateValue implements PropertyValue {

    private final PropertyState ps;

    protected PropertyStateValue(PropertyState ps) {
        this.ps = ps;
    }

    @Override
    public boolean isArray() {
		return false;
	}

    @Override
    @Nonnull
    public Type<?> getType() {
		return null;
	}

    @Override
    @Nonnull
    public <T> T getValue(Type<T> type) {
		return null;
	}

    @Override
    @Nonnull
    public <T> T getValue(Type<T> type, int index) {
		return null;
	}

    @Override
    public long size() {
		return 0L;
	}

    @Override
    public long size(int index) {
		return 0L;
	}

    @Override
    public int count() {
		return 0;
	}

    @CheckForNull
    public PropertyState unwrap() {
		return null;
	}

    @Override
    public int compareTo(PropertyValue p2) {
		return 0;
	}

    private static <T extends Comparable<T>> int compare(Iterable<T> p1,
            Iterable<T> p2) {
				return 0;
			}

    private static int compareBinaries(Iterable<Blob> p1, Iterable<Blob> p2) {
		return 0;
	}

    private static int compareAsDate(Iterable<String> p1, Iterable<String> p2) {
		return 0;
	}

    // --------------------------------------------------------------< Object >

    private String getInternalString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public boolean equals(Object o) {
		return false;
	}

    @Override
    public String toString() {
		return null;
	}

}
