/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.spi.security.user.util;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.annotation.Nullable;

import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.api.Tree;
import org.apache.jackrabbit.oak.spi.security.ConfigurationParameters;
import org.apache.jackrabbit.oak.spi.security.user.AuthorizableType;
import org.apache.jackrabbit.oak.spi.security.user.UserConstants;
import org.apache.jackrabbit.oak.util.TreeUtil;
import org.apache.jackrabbit.util.Text;

import static com.google.common.base.Preconditions.checkNotNull;
import static org.apache.jackrabbit.oak.api.Type.STRING;

/**
 * Utility methods for user management.
 */
public final class UserUtil implements UserConstants {

    private UserUtil() {
    }

    @Nonnull
    public static String getAdminId(@Nonnull ConfigurationParameters parameters) {
		return null;
	}

    @Nonnull
    public static String getAnonymousId(@Nonnull ConfigurationParameters parameters) {
		return null;
	}

    public static boolean isType(@Nullable Tree authorizableTree, @Nonnull AuthorizableType type) {
		return false;
	}

    @CheckForNull
    public static AuthorizableType getType(@Nonnull Tree authorizableNode) {
		return null;
	}

    @CheckForNull
    public static String getAuthorizableRootPath(ConfigurationParameters parameters, AuthorizableType type) {
		return null;
	}

    @CheckForNull
    public static String getAuthorizableId(@Nonnull Tree authorizableTree) {
		return null;
	}
}