/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.rmi.server;

import java.rmi.RemoteException;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.version.Version;
import javax.jcr.version.VersionManager;

import org.apache.jackrabbit.rmi.remote.RemoteIterator;
import org.apache.jackrabbit.rmi.remote.RemoteNode;
import org.apache.jackrabbit.rmi.remote.RemoteVersion;
import org.apache.jackrabbit.rmi.remote.RemoteVersionHistory;
import org.apache.jackrabbit.rmi.remote.RemoteVersionManager;

public class ServerVersionManager extends ServerObject
        implements RemoteVersionManager {

    private final Session session;    
    
    private final VersionManager manager;
    
    public ServerVersionManager(Session session,
            VersionManager manager, RemoteAdapterFactory factory)
            throws RemoteException {
        super(factory);
        this.session = session;
        this.manager = manager;
    }

    public RemoteVersion checkin(String absPath)
            throws RepositoryException, RemoteException {
				return null;
			}

    public void checkout(String absPath) throws RepositoryException {
	}

    public RemoteVersion checkpoint(String absPath)
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteNode createActivity(String title)
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteNode createConfiguration(String absPath)
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteNode getActivity()
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteVersion getBaseVersion(String absPath)
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteVersionHistory getVersionHistory(String absPath)
            throws RepositoryException, RemoteException {
				return null;
			}

    public boolean isCheckedOut(String absPath)
            throws RepositoryException {
				return false;
			}

    public RemoteIterator merge(
            String absPath, String srcWorkspace, boolean bestEffort)
            throws RepositoryException, RemoteException {
				return null;
			}

    public RemoteIterator merge(
            String absPath, String srcWorkspace, boolean bestEffort,
            boolean isShallow) throws RepositoryException, RemoteException {
				return null;
			}

    public void restore(
            String absPath, String versionName, boolean removeExisting)
            throws RepositoryException {
			}

    public void restoreByLabel(
            String absPath, String versionLabel, boolean removeExisting)
            throws RepositoryException {
			}

    public void cancelMerge(String absPath, String versionIdentifier)
            throws RepositoryException, RemoteException {
			}

    public void doneMerge(String absPath, String versionIdentifier)
            throws RepositoryException, RemoteException {
			}

    @Override
    public void restore(String[] versionIdentifiers, boolean removeExisting)
            throws RepositoryException, RemoteException {
			}

    @Override
    public void restore(String versionIdentifier, boolean removeExisting)
            throws RepositoryException, RemoteException {
			}

    @Override
    public RemoteNode setActivity(String activityNodeIdentifier)
            throws RepositoryException, RemoteException {
				return null;
			}

    @Override
    public void removeActivity(String activityNodeIdentifier)
            throws RepositoryException, RemoteException {
			}

    @Override
    public RemoteIterator merge(String activityNodeIdentifier)
            throws RepositoryException, RemoteException {
				return null;
			}

    @Override
    public void restoreVI(String absPath, String versionIdentifier,
            boolean removeExisting) throws RepositoryException, RemoteException {
			}

}
