/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.rmi.server;

import java.rmi.RemoteException;

import javax.jcr.Session;
import javax.transaction.xa.XAException;
import javax.transaction.xa.XAResource;
import javax.transaction.xa.Xid;

import org.apache.jackrabbit.rmi.remote.RemoteXASession;
import org.apache.jackrabbit.rmi.remote.SerializableXid;

/**
 * Remote adapter for XA-enabled sessions.
 *
 * @since 1.4
 */
public class ServerXASession extends ServerSession implements RemoteXASession {

    /**
     * The adapted local XA resource
     */
    private final XAResource resource;

    /**
     * Creates a remote adapter for the given local, transaction enabled,
     * session.
     */
    public ServerXASession(
            Session session, XAResource resource, RemoteAdapterFactory factory)
            throws RemoteException {
        super(session, factory);
        this.resource = resource;
    }

    private static XAException getXAException(XAException e) {
		return null;
	}

    public void commit(Xid xid, boolean onePhase) throws XAException {
	}

    public void end(Xid xid, int flags) throws XAException {
	}

    public void forget(Xid xid) throws XAException {
	}

    public int getTransactionTimeout() throws XAException {
		return 0;
	}

    public int prepare(Xid xid) throws XAException {
		return 0;
	}

    public Xid[] recover(int flag) throws XAException {
		return null;
	}

    public void rollback(Xid xid) throws XAException {
	}

    public boolean setTransactionTimeout(int seconds) throws XAException {
		return false;
	}

    public void start(Xid xid, int flags) throws XAException {
	}

}
