/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.logging;

import java.io.InputStream;
import java.util.Iterator;
import java.util.Map;

import javax.jcr.Credentials;
import javax.jcr.RepositoryException;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.nodetype.InvalidNodeTypeDefinitionException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeTypeExistsException;

import org.apache.jackrabbit.spi.Batch;
import org.apache.jackrabbit.spi.ChildInfo;
import org.apache.jackrabbit.spi.EventBundle;
import org.apache.jackrabbit.spi.EventFilter;
import org.apache.jackrabbit.spi.IdFactory;
import org.apache.jackrabbit.spi.ItemId;
import org.apache.jackrabbit.spi.ItemInfo;
import org.apache.jackrabbit.spi.ItemInfoCache;
import org.apache.jackrabbit.spi.LockInfo;
import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.NameFactory;
import org.apache.jackrabbit.spi.NodeId;
import org.apache.jackrabbit.spi.NodeInfo;
import org.apache.jackrabbit.spi.Path;
import org.apache.jackrabbit.spi.PathFactory;
import org.apache.jackrabbit.spi.PropertyId;
import org.apache.jackrabbit.spi.PropertyInfo;
import org.apache.jackrabbit.spi.QNodeDefinition;
import org.apache.jackrabbit.spi.QNodeTypeDefinition;
import org.apache.jackrabbit.spi.QPropertyDefinition;
import org.apache.jackrabbit.spi.QValue;
import org.apache.jackrabbit.spi.QValueFactory;
import org.apache.jackrabbit.spi.QueryInfo;
import org.apache.jackrabbit.spi.RepositoryService;
import org.apache.jackrabbit.spi.SessionInfo;
import org.apache.jackrabbit.spi.Subscription;

/**
 * Log wrapper for a {@link RepositoryService}.
 */
public class RepositoryServiceLogger extends AbstractLogger implements RepositoryService {
    private final RepositoryService service;

    /**
     * Create a new instance for the given <code>service</code> which uses
     * <code>writer</code> for persisting log messages.
     * @param service
     * @param writer
     */
    public RepositoryServiceLogger(RepositoryService service, LogWriter writer) {
        super(writer);
        this.service = service;
    }

    /**
     * @return  the wrapped RepositoryService
     */
    public RepositoryService getRepositoryService() {
		return null;
	}

    public NameFactory getNameFactory() throws RepositoryException {
		return null;
	}

    public PathFactory getPathFactory() throws RepositoryException {
		return null;
	}

    public IdFactory getIdFactory() throws RepositoryException {
		return null;
	}

    public QValueFactory getQValueFactory() throws RepositoryException {
		return null;
	}

    public Map<String, QValue[]> getRepositoryDescriptors() throws RepositoryException {
		return null;
	}

    public ItemInfoCache getItemInfoCache(final SessionInfo sessionInfo) throws RepositoryException {
		return null;
	}

    public SessionInfo obtain(final Credentials credentials, final String workspaceName)
            throws RepositoryException {
				return null;
			}

    public SessionInfo obtain(final SessionInfo sessionInfo, final String workspaceName)
            throws RepositoryException {
				return null;
			}

    public SessionInfo impersonate(final SessionInfo sessionInfo, final Credentials credentials)
            throws RepositoryException {
				return null;
			}

    public void dispose(final SessionInfo sessionInfo) throws RepositoryException {
	}

    public String[] getWorkspaceNames(final SessionInfo sessionInfo) throws RepositoryException {
		return null;
	}

    public boolean isGranted(final SessionInfo sessionInfo, final ItemId itemId, final String[] actions)
            throws RepositoryException {
				return false;
			}

    public QNodeDefinition getNodeDefinition(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
				return null;
			}

    public QPropertyDefinition getPropertyDefinition(final SessionInfo sessionInfo,
            final PropertyId propertyId) throws RepositoryException {
				return null;
			}

    public NodeInfo getNodeInfo(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
				return null;
			}

    public Iterator<? extends ItemInfo> getItemInfos(final SessionInfo sessionInfo, final ItemId itemId)
            throws RepositoryException {
				return null;
			}

    public Iterator<ChildInfo> getChildInfos(final SessionInfo sessionInfo, final NodeId parentId)
            throws RepositoryException {
				return null;
			}

    public Iterator<PropertyId> getReferences(final SessionInfo sessionInfo, final NodeId nodeId, final Name propertyName, final boolean weakReferences) throws RepositoryException {
		return null;
	}

    public PropertyInfo getPropertyInfo(final SessionInfo sessionInfo, final PropertyId propertyId)
            throws RepositoryException {
				return null;
			}

    public Batch createBatch(final SessionInfo sessionInfo, final ItemId itemId) throws RepositoryException {
		return null;
	}

    public void submit(final Batch batch) throws RepositoryException {
	}

    public void importXml(final SessionInfo sessionInfo, final NodeId parentId, final InputStream xmlStream,
            final int uuidBehaviour) throws RepositoryException {
			}

    public void move(final SessionInfo sessionInfo, final NodeId srcNodeId, final NodeId destParentNodeId,
            final Name destName) throws RepositoryException {
			}

    public void copy(final SessionInfo sessionInfo, final String srcWorkspaceName, final NodeId srcNodeId,
            final NodeId destParentNodeId, final Name destName) throws RepositoryException {
			}

    public void update(final SessionInfo sessionInfo, final NodeId nodeId, final String srcWorkspaceName)
            throws RepositoryException {
			}

    public void clone(final SessionInfo sessionInfo, final String srcWorkspaceName, final NodeId srcNodeId,
            final NodeId destParentNodeId, final Name destName, final boolean removeExisting)
            throws RepositoryException {
			}

    public LockInfo getLockInfo(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
				return null;
			}

    public LockInfo lock(final SessionInfo sessionInfo, final NodeId nodeId, final boolean deep,
            final boolean sessionScoped) throws RepositoryException {
				return null;
			}

    public LockInfo lock(final SessionInfo sessionInfo, final NodeId nodeId, final boolean deep,
            final boolean sessionScoped, final long timeoutHint, final String ownerHint)
            throws RepositoryException {
				return null;
			}

    public void refreshLock(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
			}

    public void unlock(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
			}

    public NodeId checkin(final SessionInfo sessionInfo, final NodeId nodeId) throws RepositoryException {
		return null;
	}

    public void checkout(final SessionInfo sessionInfo, final NodeId nodeId)
            throws RepositoryException {
			}

    public void checkout(final SessionInfo sessionInfo, final NodeId nodeId, final NodeId activityId)
            throws RepositoryException {
			}

    public NodeId checkpoint(final SessionInfo sessionInfo, final NodeId nodeId) throws UnsupportedRepositoryOperationException, RepositoryException {
		return null;
	}

    public NodeId checkpoint(final SessionInfo sessionInfo, final NodeId nodeId, final NodeId activityId) throws UnsupportedRepositoryOperationException, RepositoryException {
		return null;
	}

    public void removeVersion(final SessionInfo sessionInfo, final NodeId versionHistoryId,
            final NodeId versionId) throws RepositoryException {
			}

    public void restore(final SessionInfo sessionInfo, final NodeId nodeId, final NodeId versionId,
            final boolean removeExisting) throws RepositoryException {
			}

    public void restore(final SessionInfo sessionInfo, final NodeId[] nodeIds, final boolean removeExisting)
            throws RepositoryException {
			}

    public Iterator<NodeId> merge(final SessionInfo sessionInfo, final NodeId nodeId, final String srcWorkspaceName,
            final boolean bestEffort) throws RepositoryException {
				return null;
			}

    public Iterator<NodeId> merge(final SessionInfo sessionInfo, final NodeId nodeId, final String srcWorkspaceName,
            final boolean bestEffort, final boolean isShallow) throws RepositoryException {
				return null;
			}

    public void resolveMergeConflict(final SessionInfo sessionInfo, final NodeId nodeId,
            final NodeId[] mergeFailedIds, final NodeId[] predecessorIds) throws RepositoryException {
			}

    public void addVersionLabel(final SessionInfo sessionInfo, final NodeId versionHistoryId,
            final NodeId versionId, final Name label, final boolean moveLabel) throws RepositoryException {
			}

    public void removeVersionLabel(final SessionInfo sessionInfo, final NodeId versionHistoryId,
            final NodeId versionId, final Name label) throws RepositoryException {
			}

    public NodeId createActivity(final SessionInfo sessionInfo, final String title) throws UnsupportedRepositoryOperationException, RepositoryException {
		return null;
	}

    public void removeActivity(final SessionInfo sessionInfo, final NodeId activityId) throws UnsupportedRepositoryOperationException, RepositoryException {
	}

    public Iterator<NodeId> mergeActivity(final SessionInfo sessionInfo, final NodeId activityId) throws UnsupportedRepositoryOperationException, RepositoryException {
		return null;
	}

    public NodeId createConfiguration(final SessionInfo sessionInfo, final NodeId nodeId) throws UnsupportedRepositoryOperationException, RepositoryException {
		return null;
	}

    public String[] getSupportedQueryLanguages(final SessionInfo sessionInfo) throws RepositoryException {
		return null;
	}

    public String[] checkQueryStatement(final SessionInfo sessionInfo, final String statement,
            final String language, final Map<String, String> namespaces) throws RepositoryException {
				return null;
			}

    public QueryInfo executeQuery(final SessionInfo sessionInfo, final String statement,
                                  final String language, final Map<String, String> namespaces, final long limit, final long offset, final Map<String, QValue> values) throws RepositoryException {
									return null;
								}

    public EventFilter createEventFilter(final SessionInfo sessionInfo, final int eventTypes,
            final Path absPath, final boolean isDeep, final String[] uuid, final Name[] qnodeTypeName,
            final boolean noLocal) throws RepositoryException {
				return null;
			}

    public Subscription createSubscription(final SessionInfo sessionInfo, final EventFilter[] filters)
            throws RepositoryException {
				return null;
			}

    public EventBundle[] getEvents(final Subscription subscription, final long timeout)
            throws RepositoryException, InterruptedException {
				return null;
			}

    public EventBundle getEvents(final SessionInfo sessionInfo,
                                 final EventFilter filter,
                                 final long after) throws RepositoryException,
            UnsupportedRepositoryOperationException {
				return null;
			}

    public void updateEventFilters(final Subscription subscription, final EventFilter[] eventFilters)
            throws RepositoryException {
			}

    public void dispose(final Subscription subscription) throws RepositoryException {
	}

    public Map<String, String> getRegisteredNamespaces(final SessionInfo sessionInfo) throws RepositoryException {
		return null;
	}

    public String getNamespaceURI(final SessionInfo sessionInfo, final String prefix)
            throws RepositoryException {
				return null;
			}

    public String getNamespacePrefix(final SessionInfo sessionInfo, final String uri)
            throws RepositoryException {
				return null;
			}

    public void registerNamespace(final SessionInfo sessionInfo, final String prefix, final String uri)
            throws RepositoryException {
			}

    public void unregisterNamespace(final SessionInfo sessionInfo, final String uri)
            throws RepositoryException {
			}

    public Iterator<QNodeTypeDefinition> getQNodeTypeDefinitions(final SessionInfo sessionInfo) throws RepositoryException {
		return null;
	}

    public Iterator<QNodeTypeDefinition> getQNodeTypeDefinitions(final SessionInfo sessionInfo, final Name[] nodetypeNames)
            throws RepositoryException {
				return null;
			}

    public void registerNodeTypes(final SessionInfo sessionInfo, final QNodeTypeDefinition[] nodeTypeDefinitions, final boolean allowUpdate) throws InvalidNodeTypeDefinitionException, NodeTypeExistsException, UnsupportedRepositoryOperationException, RepositoryException {
	}

    public void unregisterNodeTypes(final SessionInfo sessionInfo, final Name[] nodeTypeNames) throws UnsupportedRepositoryOperationException, NoSuchNodeTypeException, RepositoryException {
	}

    public void createWorkspace(final SessionInfo sessionInfo, final String name, final String srcWorkspaceName) throws RepositoryException {
	}

    public void deleteWorkspace(final SessionInfo sessionInfo, final String name) throws RepositoryException {
	}

    // -----------------------------------------------------< private  >---

    private static SessionInfo unwrap(SessionInfo sessionInfo) {
		return null;
	}

    private static Batch unwrap(Batch batch) {
		return null;
	}

}
