/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.util;

import java.lang.ref.SoftReference;

/**
 * A few String utility functions.
 */
public class StringCache {

    public static final boolean OBJECT_CACHE = getBooleanSetting("jackrabbit.stringCache", true);
    public static final int OBJECT_CACHE_SIZE = nextPowerOf2(getIntSetting("jackrabbit.stringCacheSize", 1024));

    private static SoftReference<String[]> softCache = new SoftReference<String[]>(null);

    private StringCache() {
        // utility class
    }

    private static int nextPowerOf2(int x) {
		return 0;
	}

    private static boolean getBooleanSetting(String name, boolean defaultValue) {
		return false;
	}

    private static int getIntSetting(String name, int defaultValue) {
		return 0;
	}

    private static String getProperty(String name) {
		return null;
	}

    private static String[] getCache() {
		return null;
	}

    /**
     * Get the string from the cache if possible. If the string has not been
     * found, it is added to the cache. If there is such a string in the cache,
     * that one is returned.
     *
     * @param s the original string
     * @return a string with the same content, if possible from the cache
     */
    public static String cache(String s) {
		return null;
	}

    /**
     * Get a string from the cache, and if no such string has been found, create
     * a new one with only this content. This solves out of memory problems if
     * the string is a substring of another, large string. In Java, strings are
     * shared, which could lead to memory problems. This avoid such problems.
     *
     * @param s the string
     * @return a string that is guaranteed not be a substring of a large string
     */
    public static String fromCacheOrNew(String s) {
		return null;
	}

    /**
     * Clear the cache. This method is used for testing.
     */
    public static void clearCache() {
	}

}