/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jackrabbit.vault.fs.config;

import java.util.Map;

import org.apache.jackrabbit.vault.fs.api.Aggregator;
import org.apache.jackrabbit.vault.fs.api.ArtifactHandler;
import org.apache.jackrabbit.vault.fs.api.ItemFilter;
import org.apache.jackrabbit.vault.fs.api.ItemFilterSet;
import org.apache.jackrabbit.vault.fs.filter.IsMandatoryFilter;
import org.apache.jackrabbit.vault.fs.filter.IsNodeFilter;
import org.apache.jackrabbit.vault.fs.filter.NameItemFilter;
import org.apache.jackrabbit.vault.fs.filter.NodeTypeItemFilter;
import org.apache.jackrabbit.vault.fs.impl.aggregator.GenericAggregator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;

/**
 * <code>JcrFsConfig</code>...
 */
class VaultFsConfig11 extends AbstractVaultFsConfig {

    /**
     * the default logger
     */
    private static final Logger log = LoggerFactory.getLogger(VaultFsConfig11.class);

    public static final double SUPPORTED_VERSION = 1.1;

    private final ConfigHelper helper = new ConfigHelper();

    @SuppressWarnings("unchecked")
    public VaultFsConfig11() {
        helper.getDefaultPackages().put("include", "org.apache.jackrabbit.vault.fs.filter");
        helper.getDefaultPackages().put("exclude", "org.apache.jackrabbit.vault.fs.filter");
    }

    protected void process(Element elem) throws ConfigurationException {
	}

    private void processAggregate(Element elem) throws ConfigurationException {
	}

    private void processFilter(ItemFilterSet filterSet, Element elem)
            throws ConfigurationException {
			}

    private void processHandler(Element elem) throws ConfigurationException {
	}


}