/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jackrabbit.vault.fs.io;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipInputStream;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.io.input.CloseShieldInputStream;
import org.apache.jackrabbit.vault.fs.api.VaultInputSource;
import org.apache.jackrabbit.vault.fs.config.ConfigurationException;
import org.apache.jackrabbit.vault.fs.config.DefaultMetaInf;
import org.apache.jackrabbit.vault.fs.config.MetaInf;
import org.apache.jackrabbit.vault.fs.config.VaultSettings;
import org.apache.jackrabbit.vault.fs.spi.CNDReader;
import org.apache.jackrabbit.vault.fs.spi.ServiceProviderFactory;
import org.apache.jackrabbit.vault.util.Constants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * The zip archive implements bridge between the ZipStreamArchive and the
 * ZipFileArchive. the former is needed due to a bug in ZipFile of jdk1.5 that
 * causes problems with zip files with a lot of entries.
 */
public class ZipArchive extends AbstractArchive {

    /**
     * default logger
     */
    private static final Logger log = LoggerFactory.getLogger(ZipArchive.class);

    private DefaultMetaInf inf;

    private int numEntries;

    private Archive base;

    private File zipFile;

    private final boolean isTempFile;

    public ZipArchive(File zipFile) {
        this(zipFile, false);
    }

    public ZipArchive(File zipFile, boolean isTempFile) {
        this.zipFile = zipFile;
        this.isTempFile = isTempFile;
    }

    public void open(boolean strict) throws IOException {
	}

    private Archive getBase() throws IOException {
		return null;
	}

    public MetaInf getMetaInf() {
		return null;
	}

    public InputStream openInputStream(Entry entry) throws IOException {
		return null;
	}

    public VaultInputSource getInputSource(Entry entry) throws IOException {
		return null;
	}

    public Entry getRoot() throws IOException {
		return null;
	}

    public void close() {
	}

    public File getFile() {
		return null;
	}

    public long getFileSize() {
		return 0L;
	}

    @Override
    public String toString() {
		return null;
	}
}