/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jackrabbit.vault.fs.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import org.apache.jackrabbit.vault.fs.api.VaultInputSource;
import org.apache.jackrabbit.vault.fs.config.MetaInf;
import org.apache.jackrabbit.vault.util.Text;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Implements an archive that is based on a zip file.
 */
class ZipFileArchive extends AbstractArchive {

    /**
     * default logger
     */
    private static final Logger log = LoggerFactory.getLogger(ZipFileArchive.class);

    private ZipFile zip;

    private JarEntry root;

    public ZipFileArchive(ZipFile zip) {
        this.zip = zip;
    }

    public void open(boolean strict) throws IOException {
	}


    public InputStream openInputStream(Entry entry) throws IOException {
		return null;
	}

    public VaultInputSource getInputSource(Entry entry) throws IOException {
		return null;
	}

    public void close() {
	}

    public Entry getRoot() throws IOException {
		return null;
	}

    public MetaInf getMetaInf() {
		return null;
	}

    private static class JarEntry implements Entry {

        public final String name;

        private String zipEntryName;

        public final boolean isDirectory;

        public Map<String, JarEntry> children;

        public JarEntry(String name, boolean directory) {
            this.name = name;
            isDirectory = directory;
        }

        public JarEntry add(String name, boolean isDirectory) {
			return null;
		}

        public String getName() {
			return null;
		}

        public boolean isDirectory() {
			return false;
		}

        public JarEntry add(JarEntry e) {
			return null;
		}

        public Collection<? extends Entry> getChildren() {
			return null;
		}

        public Entry getChild(String name) {
			return null;
		}

    }
}