/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with this
 * work for additional information regarding copyright ownership. The ASF
 * licenses this file to You under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.apache.sling.scripting.jsp.jasper.runtime;

import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Set;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.jsp.PageContext;

/**
 * Wrapper around the Sling servlet config in order to return a wrapped servlet context
 * for other servlet contexts.
 */
class InternalServletConfigWrapper implements ServletConfig {
    
    private final ServletConfig delegate;
    
    private final PageContext pageContext;
    
    public InternalServletConfigWrapper(ServletConfig sc, PageContext pageContext) {
        this.delegate = sc;
        this.pageContext = pageContext;
    }

    public String getServletName() {
		return null;
	}

    public ServletContext getServletContext() {
		return null;
	}

    public String getInitParameter(String s) {
		return null;
	}

    public Enumeration getInitParameterNames() {
		return null;
	}
    
    class InternalServletContextWrapper implements ServletContext {
        
        private final ServletContext delegate;
        
        public InternalServletContextWrapper(ServletContext sc) {
            this.delegate = sc;
        }

        public ServletContext getContext(String s) {
			return null;
		}

        public String getContextPath() {
			return null;
		}

        public int getMajorVersion() {
			return 0;
		}

        public int getMinorVersion() {
			return 0;
		}

        public String getMimeType(String s) {
			return null;
		}

        public Set getResourcePaths(String s) {
			return null;
		}

        public URL getResource(String s) throws MalformedURLException {
			return null;
		}

        public InputStream getResourceAsStream(String s) {
			return null;
		}

        public RequestDispatcher getRequestDispatcher(String s) {
			return null;
		}

        public RequestDispatcher getNamedDispatcher(String s) {
			return null;
		}

        public Servlet getServlet(String s) throws ServletException {
			return null;
		}

        public Enumeration getServlets() {
			return null;
		}

        public Enumeration getServletNames() {
			return null;
		}

        public void log(String s) {
		}

        public void log(Exception exception, String s) {
		}

        public void log(String s, Throwable throwable) {
		}

        public String getRealPath(String s) {
			return null;
		}

        public String getServerInfo() {
			return null;
		}

        public String getInitParameter(String s) {
			return null;
		}

        public Enumeration getInitParameterNames() {
			return null;
		}

        public Object getAttribute(String s) {
			return null;
		}

        public Enumeration getAttributeNames() {
			return null;
		}

        public void setAttribute(String s, Object obj) {
		}

        public void removeAttribute(String s) {
		}

        public String getServletContextName() {
			return null;
		}
        
        
    }
    
    

}
